#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'colours/commandline/commandline.rb'
# =========================================================================== #
module Colours

  require 'colours/commandline/menu.rb'
  require 'colours/eparse/eparse.rb'

  alias e puts

  # ========================================================================= #
  # === Colours.set_commandline
  # ========================================================================= #
  def self.set_commandline(i = ARGV)
    @commandline = [i].flatten.compact
  end

  # ========================================================================= #
  # === Colours.commandline?
  # ========================================================================= #
  def self.commandline?
    @commandline
  end

  # ========================================================================= #
  # === Colours.show_the_version
  #
  # Invocation example:
  #
  #   colours --version?
  #
  # ========================================================================= #
  def self.show_the_version
    e steelblue(VERSION)
  end

  # ========================================================================= #
  # === Colours.show_help                                          (help tag)
  # ========================================================================= #
  def self.show_help
    e
    e 'This menu supports the following commands:'
    e
    eparse '  file?               # read in from the default test file'
    eparse '  html_colours        # show all html colours'
    eparse '  open                # open this file here in your editor'
    eparse '  --version?          # report the current version of '\
           'the colours gem'
    eparse '  --base-dir?         # show the project base directory '\
           'of the Colours namespace'
    eparse '  --show-html-colours # show the available HTML colours'
    e
  end; self.instance_eval { alias help show_help } # === Colours.help

end