#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal =  true
# =========================================================================== #
# require 'colours/constants/escape.rb'
# =========================================================================== #
module Colours

  # ========================================================================= #
  # === Colours::ESC
  #
  # Escape sequences start with the character ESC (ASCII decimal 27/hex
  # 0x1B/octal 033).
  #
  # The characters ESC and [ (left bracket) are called CSI, for "Control
  # Sequence Initiator".
  #
  # Keep in mind that "\e" can be represented via "\u001b" in Ruby, too.
  # ========================================================================= #
  ESC = "\e["

end