#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'colours/constants/file_constants.rb'
# Colours.file_html_colours_to_rgb?
# =========================================================================== #
module Colours

  require 'colours/project/project.rb'

  # ========================================================================= #
  # === Colours::FILE_HTML_COLOURS
  # ========================================================================= #
  FILE_HTML_COLOURS =
    "#{PROJECT_BASE_DIRECTORY}yaml/html_colours.yml"

  # ========================================================================= #
  # === Colours::FILE_KDE_COLOUR_PALETTE
  # ========================================================================= #
  FILE_KDE_COLOUR_PALETTE =
    "#{PROJECT_BASE_DIRECTORY}yaml/kde_colour_palette.yml"

  # ========================================================================= #
  # === Colours::FILE_256_COLOURS
  # ========================================================================= #
  FILE_256_COLOURS =
    "#{PROJECT_BASE_DIRECTORY}yaml/256_colours.yml"

  # ========================================================================= #
  # === Colours::FILE_BASIC_COLOURS
  # ========================================================================= #
  FILE_BASIC_COLOURS =
    "#{PROJECT_BASE_DIRECTORY}yaml/basic_colours.yml"

  # ========================================================================= #
  # === Colours::FILE_USE_THESE_VALUES_FOR_THE_COLOUR_METHODS
  # ========================================================================= #
  FILE_USE_THESE_VALUES_FOR_THE_COLOUR_METHODS =
    "#{PROJECT_BASE_DIRECTORY}yaml/use_these_values_for_the_colour_methods.yml"

  # ========================================================================= #
  # === Colours::FILE_PREFER_THIS_COLOUR_SCHEMATA
  # ========================================================================= #
  FILE_PREFER_THIS_COLOUR_SCHEMATA =
    "#{PROJECT_BASE_DIRECTORY}yaml/prefer_this_colour_schemata.yml"

  # ========================================================================= #
  # === Colours.file_html_colours_to_rgb?
  #
  # Easier toplevel-getter method to determine where the file for
  # the html-colours-to-rgb conversion resides.
  # ========================================================================= #
  def self.file_html_colours_to_rgb?
    "#{PROJECT_BASE_DIRECTORY}yaml/html_colours.yml"
  end

  # ========================================================================= #
  # === Colours.available_file_constants
  # ========================================================================= #
  def self.available_file_constants
    [
      FILE_HTML_COLOURS,
      FILE_KDE_COLOUR_PALETTE
    ]
  end

end

if __FILE__ == $PROGRAM_NAME
  pp Colours.available_file_constants  
end