#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'colours/constants/registered_colour_methods.rb'
# =========================================================================== #
module Colours

  # ========================================================================= #
  # === Colours::REGISTERED_COLOUR_METHODS
  #
  # These methods constitute the registered colour methods.
  #
  # These have a corresponding method, such as snormal() or sdir() or
  # sfile().
  #
  # snormal() stands for the "normal" colour, aka the "default
  # colour".
  # ========================================================================= #
  REGISTERED_COLOUR_METHODS = %i(
    snormal
    sargument
    scomments
    ssymlink
    sdir
    sfile
    sfancy
    simportant
    swarn
  )

  # ========================================================================= #
  # === Colours::REGISTERED_COLOUR_METHODS_ALIASES
  #
  # This Array should hold all aliases to the main colour-methods,
  # such as simportant() or sargument().
  # ========================================================================= #
  REGISTERED_COLOUR_METHODS_ALIASES = %i(
    argument
    ssym
    simp
    sarg
    normal
    comments
    symlink
    dir
    file
    fancy
    important
    warn
  )

end