#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'colours/rainbow_colours/println_plain.rb'

module Colours

module RainbowColours

  # ========================================================================= #
  # === Colours::RainbowColours.println_ani
  #
  # This method here will be called if the "animate option" was enabled,
  # that is, set to true.
  # ========================================================================= #
  def self.println_ani(
      str, opts = {}
    )
    return if str.empty? # Return early in this case.
    (1..opts[:duration]).each { |irrelevant_variable|
      print "\e[#{str.length}D"
      opts[:os] += opts[:spread]
      # ===================================================================== #
      # Next, delegate to println_plain():
      # ===================================================================== #
      println_plain(str, opts)
      sleep 1.0/opts[:speed]
    }
  end

end; end