#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# The "colour-methods" are methods such as sdir(), swarn() and so forth.
#
# The file here specifies code that can be used to require these .rb
# files from the given colour_methods/ subdirectory of the colours
# project.
# =========================================================================== #
# require 'colours/requires/require_the_colour_methods.rb'
# =========================================================================== #
module Colours

  require 'colours/project/project.rb'

  # ========================================================================= #
  # === Colours.require_the_colour_methods
  #
  # This method will batch-require the .rb files that are found in the
  # colour_methods/ subdirectory of the colours gem.
  # ========================================================================= #
  def self.require_the_colour_methods
    target = "#{::Colours::PROJECT_BASE_DIRECTORY}colour_methods/"

    Dir["#{target}*.rb"].each {|this_file|
      require target+File.basename(this_file)
    }

  end; self.instance_eval { alias default_string_methods require_the_colour_methods } # === Colours.default_string_methods

  ::Colours.require_the_colour_methods # Also trigger the above method at once.

end