#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
require 'colours/project/project.rb'
require 'colours/requires/require_the_constants.rb'
require 'colours/class/colours.rb'
require 'colours/base/base.rb'
require 'colours/requires/require_the_basic_colours.rb'
require 'colours/requires/require_the_toplevel_methods.rb'
require 'colours/map_symbol_to_corresponding_colour/map_symbol_to_corresponding_colour.rb'
require 'colours/256_colours/support_for_256_colours.rb'
# =========================================================================== #
# Next require the colour-methods:
# =========================================================================== #
require 'colours/requires/require_the_colour_methods.rb'
# =========================================================================== #
# Next require the html-colours components of the colours project:
# =========================================================================== #
require 'colours/requires/require_the_html_colours.rb'
require 'colours/requires/require_eparse.rb'
require 'colours/requires/require_commandline.rb'
require 'colours/requires/require_the_colour_table.rb'
require 'colours/requires/require_rgb.rb'
require 'colours/requires/require_the_256_colours_module.rb'
require 'colours/requires/require_the_kde_colour_palette.rb'
require 'colours/version/version.rb'
require 'colours/requires/require_autogenerated_colour_methods.rb'
require 'colours/html_colours/add_html_colours_onto_the_toplevel_namespace.rb'
# =========================================================================== #
# Require the big "symbol-mapper" next:
# =========================================================================== #
require 'colours/map_symbol_to_corresponding_colour/map_symbol_to_corresponding_colour.rb'
# =========================================================================== #
# Load up the testing-relevant code:
# =========================================================================== #
require 'colours/testing/testing.rb'
# =========================================================================== #
# Next, add the submodule at "Colours::E":
# =========================================================================== #
require 'colours/e/e.rb'

module Colours

  # ========================================================================= #
  # We have to put the ColourMethods into the toplevel namespace at once,
  # so that methods such as slateblue() are defined.
  # ========================================================================= #
  extend ::Colours::AllColourMethods

  include ::Colours::AllColourMethods

end