#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# This file will pull in all .rb files that reside in the
# colours/toplevel_methods/ subdirectory.  
# =========================================================================== #
require 'colours/project/project.rb'

require_these_files = Dir["#{Colours::PROJECT_BASE_DIRECTORY}toplevel_methods/*.rb"]

if require_these_files.empty?
  # ===================================================================== #
  # If we can not find any of the files then we will use a hardcoded
  # approach, which follows next.
  # ===================================================================== #
  require_these_files = %w(
    bold_and_italic.rb
    bold.rb
    cat.rb
    clear_screen.rb
    cliner.rb
    col.rb
    e.rb
    html_colourize.rb
    is_on_roebe.rb
    italic.rb
    make_colour.rb
    misc.rb
    prefer_this_colour_schemata.rb
    random_html_colour.rb
    random_value.rb
    remove_escape_sequence.rb
    show_basic_colour_palette.rb
    underline.rb
    use_colours.rb
  )
end

require_these_files.each {|this_file|
  require "colours/toplevel_methods/#{File.basename(this_file)}"
}