#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'colours/toplevel_methods/bold.rb'
# Colours.bold
# =========================================================================== #
module Colours

  require 'colours/toplevel_methods/revert.rb'

  # ========================================================================= #
  # === Colours.bold
  #
  # ANSI colour escape code for bold is "1".
  #
  # The method has to call Colours.rev() at the end, because that way
  # downstream users can modify the default rev-colour in use.
  #
  # Usage example:
  #
  #   puts ' ok | '+Colours.bold('Hello world!')+' | ok'
  #
  # ========================================================================= #
  def self.bold(
      show_this_text = 'This must be bold.'
    )
    return "\x1b[1m#{show_this_text}#{::Colours.rev}"
  end; self.instance_eval { alias return_bold bold } # === Colours.return_bold

end

if __FILE__ == $PROGRAM_NAME
  alias e puts
  if ARGV.empty?
    e Colours.bold('Hello world!')
    e 'Hello world!'
  else
    e Colours.bold(ARGV.join(' ').strip)
  end
end # colours_bold hello there how do you do