#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'colours/toplevel_methods/bold_and_italic.rb'
# =========================================================================== #
module Colours

  require 'colours/toplevel_methods/bold.rb'
  require 'colours/toplevel_methods/italic.rb'
  require 'colours/toplevel_methods/revert.rb'

  # ========================================================================= #
  # === Colours.bold_and_italic
  #
  # Usage example:
  #
  #   puts Colours.bold_and_italic 'Hello world!'
  #
  # ========================================================================= #
  def self.bold_and_italic(
      i = 'This must be bold.'
    )
    if i.is_a? Array
      i = i.join(' ')
    end
    italic(bold(i))
  end

end

if __FILE__ == $PROGRAM_NAME
  if ARGV.empty?
    puts Colours.bold_and_italic('Hello world!')+' All is fine.'
  else
    puts Colours.bold_and_italic(ARGV)
  end
end # boldanditalic yo there yoda