#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'colours/toplevel_methods/cat.rb'
# =========================================================================== #
module Colours

  require 'colours/rainbow_colours/print_rainbow_line.rb'

  # ========================================================================= #
  # === Colours.cat
  #
  # The first argument may be ARGF. It ought to respond to .each anyway.
  #
  # Note that .cat() will delegate towards print_line().
  # ========================================================================= #
  def self.cat(
      file_descriptor, hash_options = {}
    )
    print "\e[?25l" if hash_options[:animate] # Print this if we animate (enabling psychedelics).
    # ======================================================================= #
    # Iterate over the file_descriptor passed.
    # ======================================================================= #
    file_descriptor.each { |line|
      hash_options[:os] += 1 # Increase the output-count.
      # ===================================================================== #
      # Next, colourize the line. This depends on the method called
      # print_rainbow_line().
      # ===================================================================== #
      RainbowColours.print_rainbow_line(
        line, hash_options
      ) # Delegate towards print_line.
    }
  ensure
    print "\e[?25h" if hash_options[:animate]
  end

end