#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'colours/toplevel_methods/html_colour_to_hex_value.rb'
# =========================================================================== #
module Colours

  require 'yaml'
  require 'colours/constants/file_constants.rb'

  # ========================================================================= #
  # === Colours.html_colour_to_hex_value
  # ========================================================================= #
  def self.html_colour_to_hex_value(
      this_html_colour,
      return_with_hash_key = true
    )
    if this_html_colour.is_a? Array
      this_html_colour = this_html_colour.first
    end
    _ = file_html_colours_to_rgb?
    if File.exist? _
      # ===================================================================== #
      # Load the yaml-file next:
      # ===================================================================== #
      dataset = YAML.load_file(_)
      if dataset.has_key? this_html_colour
        _ = dataset[this_html_colour].last
        if return_with_hash_key
          _ = _.dup if _.frozen?
          _ = _.to_s unless _.is_a? String
          _[0,0] = '#' if _.respond_to? :[]=
        end
        return _
      end
    end
    return this_html_colour
  end

end