#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# require 'colours/toplevel_methods/set_last_colour_used.rb'
# =========================================================================== #
module Colours

  # ========================================================================= #
  # === @last_colour_used
  #
  # This instance variable keeps track what the last colour used was.
  # ========================================================================= #
  @last_colour_used = nil

  # ========================================================================= #
  # === last_colour_used?
  #
  # Tell us which colour was used last.
  # ========================================================================= #
  def last_colour_used?
    @last_colour_used.to_s # Always required a string.
  end

  # ========================================================================= #
  # === Colours.set_last_colour_used
  # ========================================================================= #
  def self.set_last_colour_used(i)
    @last_colour_used = i
  end

end