#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal =  true
# =========================================================================== #
# require 'colours/toplevel_methods/show_basic_colour_palette.rb'
# =========================================================================== #
module Colours

  require 'colours/constants/hash_simple_colours.rb'
  require 'colours/toplevel_methods/cliner.rb'
  require 'colours/toplevel_methods/e.rb'
  require 'colours/toplevel_methods/make_colour.rb'

  # ========================================================================= #
  # === Colours.show_basic_colour_palette
  #
  # This will show a colour palette on the commandline.
  # ========================================================================= #
  def self.show_basic_colour_palette
    e
    MAIN_COLOURS.reject {|e| e == :black }.each { |entry|
      make_colour(entry) # make_colour() is defined in this file here.
    }
    cliner
    SECONDARY_COLOURS.each { |entry|
      make_colour(entry)
    }
    e
  end; self.instance_eval { alias show_palette        show_basic_colour_palette } # === Colours.show_palette
       self.instance_eval { alias show_colour_palette show_basic_colour_palette } # === Colours.show_colour_palette

end

if __FILE__ == $PROGRAM_NAME
  Colours.show_basic_colour_palette
end # showbasiccolourpalette