#!/usr/bin/ruby -w
# Encoding: UTF-8
# frozen_string_literal: true
# =========================================================================== #
# This file contains the code that will call the corresponding colour method
# depending on which colour-mode the user prefers.
# =========================================================================== #
# require 'colours/autogenerated/toplevel_basic_colour_methods.rb'
# =========================================================================== #
module Colours

require 'colours/toplevel_methods/use_colours.rb'
require 'colours/basic_colours/basic_colours.rb'
require 'colours/256_colours/support_for_256_colours.rb'
require 'colours/autogenerated/support_for_html_colours.rb'

module AllColourMethods # include Colours::AllColourMethods

  # ======================================================================== 
  # === Colours::AllColourMethods.aliceblue
  # ======================================================================== 
  def self.aliceblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.aliceblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.aliceblue(i, &block)
      else
        return ::Colours::BasicColours.aliceblue(i, &block)
      end
    else
      return i
    end
  end; def aliceblue(i = '', &block); AllColourMethods.aliceblue(i, &block); end
       def konsole_colour_aliceblue(i = ''); AllColourMethods.aliceblue(i); end
       def konsole_aliceblue(i = ''); AllColourMethods.aliceblue(i); end
       self.instance_eval { alias konsole_colour_aliceblue aliceblue } # === Colours::AllColourMethods.konsole_colour_aliceblue
       def Colours.ealiceblue(i = ''); puts AllColourMethods.aliceblue(i); end
       def ealiceblue(i = ''); puts AllColourMethods.aliceblue(i); end
       alias ekonsole_colour_aliceblue ealiceblue

  # ======================================================================== 
  # === Colours::AllColourMethods.antiquewhite
  # ======================================================================== 
  def self.antiquewhite(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.antiquewhite(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.antiquewhite(i, &block)
      else
        return ::Colours::BasicColours.antiquewhite(i, &block)
      end
    else
      return i
    end
  end; def antiquewhite(i = '', &block); AllColourMethods.antiquewhite(i, &block); end
       def konsole_colour_antiquewhite(i = ''); AllColourMethods.antiquewhite(i); end
       def konsole_antiquewhite(i = ''); AllColourMethods.antiquewhite(i); end
       self.instance_eval { alias konsole_colour_antiquewhite antiquewhite } # === Colours::AllColourMethods.konsole_colour_antiquewhite
       def Colours.eantiquewhite(i = ''); puts AllColourMethods.antiquewhite(i); end
       def eantiquewhite(i = ''); puts AllColourMethods.antiquewhite(i); end
       alias ekonsole_colour_antiquewhite eantiquewhite

  # ======================================================================== 
  # === Colours::AllColourMethods.aqua
  # ======================================================================== 
  def self.aqua(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.aqua(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.aqua(i, &block)
      else
        return ::Colours::BasicColours.aqua(i, &block)
      end
    else
      return i
    end
  end; def aqua(i = '', &block); AllColourMethods.aqua(i, &block); end
       def konsole_colour_aqua(i = ''); AllColourMethods.aqua(i); end
       def konsole_aqua(i = ''); AllColourMethods.aqua(i); end
       self.instance_eval { alias konsole_colour_aqua aqua } # === Colours::AllColourMethods.konsole_colour_aqua
       def Colours.eaqua(i = ''); puts AllColourMethods.aqua(i); end
       def eaqua(i = ''); puts AllColourMethods.aqua(i); end
       alias ekonsole_colour_aqua eaqua

  # ======================================================================== 
  # === Colours::AllColourMethods.aquamarine
  # ======================================================================== 
  def self.aquamarine(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.aquamarine(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.aquamarine(i, &block)
      else
        return ::Colours::BasicColours.aquamarine(i, &block)
      end
    else
      return i
    end
  end; def aquamarine(i = '', &block); AllColourMethods.aquamarine(i, &block); end
       def konsole_colour_aquamarine(i = ''); AllColourMethods.aquamarine(i); end
       def konsole_aquamarine(i = ''); AllColourMethods.aquamarine(i); end
       self.instance_eval { alias konsole_colour_aquamarine aquamarine } # === Colours::AllColourMethods.konsole_colour_aquamarine
       def Colours.eaquamarine(i = ''); puts AllColourMethods.aquamarine(i); end
       def eaquamarine(i = ''); puts AllColourMethods.aquamarine(i); end
       alias ekonsole_colour_aquamarine eaquamarine

  # ======================================================================== 
  # === Colours::AllColourMethods.aquamarine1
  # ======================================================================== 
  def self.aquamarine1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.aquamarine1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.aquamarine1(i, &block)
      else
        return ::Colours::BasicColours.aquamarine1(i, &block)
      end
    else
      return i
    end
  end; def aquamarine1(i = '', &block); AllColourMethods.aquamarine1(i, &block); end
       def konsole_colour_aquamarine1(i = ''); AllColourMethods.aquamarine1(i); end
       def konsole_aquamarine1(i = ''); AllColourMethods.aquamarine1(i); end
       self.instance_eval { alias konsole_colour_aquamarine1 aquamarine1 } # === Colours::AllColourMethods.konsole_colour_aquamarine1
       def Colours.eaquamarine1(i = ''); puts AllColourMethods.aquamarine1(i); end
       def eaquamarine1(i = ''); puts AllColourMethods.aquamarine1(i); end
       alias ekonsole_colour_aquamarine1 eaquamarine1

  # ======================================================================== 
  # === Colours::AllColourMethods.aquamarine3
  # ======================================================================== 
  def self.aquamarine3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.aquamarine3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.aquamarine3(i, &block)
      else
        return ::Colours::BasicColours.aquamarine3(i, &block)
      end
    else
      return i
    end
  end; def aquamarine3(i = '', &block); AllColourMethods.aquamarine3(i, &block); end
       def konsole_colour_aquamarine3(i = ''); AllColourMethods.aquamarine3(i); end
       def konsole_aquamarine3(i = ''); AllColourMethods.aquamarine3(i); end
       self.instance_eval { alias konsole_colour_aquamarine3 aquamarine3 } # === Colours::AllColourMethods.konsole_colour_aquamarine3
       def Colours.eaquamarine3(i = ''); puts AllColourMethods.aquamarine3(i); end
       def eaquamarine3(i = ''); puts AllColourMethods.aquamarine3(i); end
       alias ekonsole_colour_aquamarine3 eaquamarine3

  # ======================================================================== 
  # === Colours::AllColourMethods.azure
  # ======================================================================== 
  def self.azure(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.azure(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.azure(i, &block)
      else
        return ::Colours::BasicColours.azure(i, &block)
      end
    else
      return i
    end
  end; def azure(i = '', &block); AllColourMethods.azure(i, &block); end
       def konsole_colour_azure(i = ''); AllColourMethods.azure(i); end
       def konsole_azure(i = ''); AllColourMethods.azure(i); end
       self.instance_eval { alias konsole_colour_azure azure } # === Colours::AllColourMethods.konsole_colour_azure
       def Colours.eazure(i = ''); puts AllColourMethods.azure(i); end
       def eazure(i = ''); puts AllColourMethods.azure(i); end
       alias ekonsole_colour_azure eazure

  # ======================================================================== 
  # === Colours::AllColourMethods.beige
  # ======================================================================== 
  def self.beige(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.beige(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.beige(i, &block)
      else
        return ::Colours::BasicColours.beige(i, &block)
      end
    else
      return i
    end
  end; def beige(i = '', &block); AllColourMethods.beige(i, &block); end
       def konsole_colour_beige(i = ''); AllColourMethods.beige(i); end
       def konsole_beige(i = ''); AllColourMethods.beige(i); end
       self.instance_eval { alias konsole_colour_beige beige } # === Colours::AllColourMethods.konsole_colour_beige
       def Colours.ebeige(i = ''); puts AllColourMethods.beige(i); end
       def ebeige(i = ''); puts AllColourMethods.beige(i); end
       alias ekonsole_colour_beige ebeige

  # ======================================================================== 
  # === Colours::AllColourMethods.bisque
  # ======================================================================== 
  def self.bisque(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.bisque(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.bisque(i, &block)
      else
        return ::Colours::BasicColours.bisque(i, &block)
      end
    else
      return i
    end
  end; def bisque(i = '', &block); AllColourMethods.bisque(i, &block); end
       def konsole_colour_bisque(i = ''); AllColourMethods.bisque(i); end
       def konsole_bisque(i = ''); AllColourMethods.bisque(i); end
       self.instance_eval { alias konsole_colour_bisque bisque } # === Colours::AllColourMethods.konsole_colour_bisque
       def Colours.ebisque(i = ''); puts AllColourMethods.bisque(i); end
       def ebisque(i = ''); puts AllColourMethods.bisque(i); end
       alias ekonsole_colour_bisque ebisque

  # ======================================================================== 
  # === Colours::AllColourMethods.black
  # ======================================================================== 
  def self.black(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.black(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.black(i, &block)
      else
        return ::Colours::BasicColours.black(i, &block)
      end
    else
      return i
    end
  end; def black(i = '', &block); AllColourMethods.black(i, &block); end
       def konsole_colour_black(i = ''); AllColourMethods.black(i); end
       def konsole_black(i = ''); AllColourMethods.black(i); end
       self.instance_eval { alias konsole_colour_black black } # === Colours::AllColourMethods.konsole_colour_black
       def Colours.eblack(i = ''); puts AllColourMethods.black(i); end
       def eblack(i = ''); puts AllColourMethods.black(i); end
       alias ekonsole_colour_black eblack

  # ======================================================================== 
  # === Colours::AllColourMethods.blanchedalmond
  # ======================================================================== 
  def self.blanchedalmond(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.blanchedalmond(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.blanchedalmond(i, &block)
      else
        return ::Colours::BasicColours.blanchedalmond(i, &block)
      end
    else
      return i
    end
  end; def blanchedalmond(i = '', &block); AllColourMethods.blanchedalmond(i, &block); end
       def konsole_colour_blanchedalmond(i = ''); AllColourMethods.blanchedalmond(i); end
       def konsole_blanchedalmond(i = ''); AllColourMethods.blanchedalmond(i); end
       self.instance_eval { alias konsole_colour_blanchedalmond blanchedalmond } # === Colours::AllColourMethods.konsole_colour_blanchedalmond
       def Colours.eblanchedalmond(i = ''); puts AllColourMethods.blanchedalmond(i); end
       def eblanchedalmond(i = ''); puts AllColourMethods.blanchedalmond(i); end
       alias ekonsole_colour_blanchedalmond eblanchedalmond

  # ======================================================================== 
  # === Colours::AllColourMethods.blue
  # ======================================================================== 
  def self.blue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.blue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.blue(i, &block)
      else
        return ::Colours::BasicColours.blue(i, &block)
      end
    else
      return i
    end
  end; def blue(i = '', &block); AllColourMethods.blue(i, &block); end
       def konsole_colour_blue(i = ''); AllColourMethods.blue(i); end
       def konsole_blue(i = ''); AllColourMethods.blue(i); end
       self.instance_eval { alias konsole_colour_blue blue } # === Colours::AllColourMethods.konsole_colour_blue
       def Colours.eblue(i = ''); puts AllColourMethods.blue(i); end
       def eblue(i = ''); puts AllColourMethods.blue(i); end
       alias ekonsole_colour_blue eblue

  # ======================================================================== 
  # === Colours::AllColourMethods.blue1
  # ======================================================================== 
  def self.blue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.blue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.blue1(i, &block)
      else
        return ::Colours::BasicColours.blue1(i, &block)
      end
    else
      return i
    end
  end; def blue1(i = '', &block); AllColourMethods.blue1(i, &block); end
       def konsole_colour_blue1(i = ''); AllColourMethods.blue1(i); end
       def konsole_blue1(i = ''); AllColourMethods.blue1(i); end
       self.instance_eval { alias konsole_colour_blue1 blue1 } # === Colours::AllColourMethods.konsole_colour_blue1
       def Colours.eblue1(i = ''); puts AllColourMethods.blue1(i); end
       def eblue1(i = ''); puts AllColourMethods.blue1(i); end
       alias ekonsole_colour_blue1 eblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.blue3
  # ======================================================================== 
  def self.blue3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.blue3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.blue3(i, &block)
      else
        return ::Colours::BasicColours.blue3(i, &block)
      end
    else
      return i
    end
  end; def blue3(i = '', &block); AllColourMethods.blue3(i, &block); end
       def konsole_colour_blue3(i = ''); AllColourMethods.blue3(i); end
       def konsole_blue3(i = ''); AllColourMethods.blue3(i); end
       self.instance_eval { alias konsole_colour_blue3 blue3 } # === Colours::AllColourMethods.konsole_colour_blue3
       def Colours.eblue3(i = ''); puts AllColourMethods.blue3(i); end
       def eblue3(i = ''); puts AllColourMethods.blue3(i); end
       alias ekonsole_colour_blue3 eblue3

  # ======================================================================== 
  # === Colours::AllColourMethods.blueviolet
  # ======================================================================== 
  def self.blueviolet(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.blueviolet(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.blueviolet(i, &block)
      else
        return ::Colours::BasicColours.blueviolet(i, &block)
      end
    else
      return i
    end
  end; def blueviolet(i = '', &block); AllColourMethods.blueviolet(i, &block); end
       def konsole_colour_blueviolet(i = ''); AllColourMethods.blueviolet(i); end
       def konsole_blueviolet(i = ''); AllColourMethods.blueviolet(i); end
       self.instance_eval { alias konsole_colour_blueviolet blueviolet } # === Colours::AllColourMethods.konsole_colour_blueviolet
       def Colours.eblueviolet(i = ''); puts AllColourMethods.blueviolet(i); end
       def eblueviolet(i = ''); puts AllColourMethods.blueviolet(i); end
       alias ekonsole_colour_blueviolet eblueviolet

  # ======================================================================== 
  # === Colours::AllColourMethods.brown
  # ======================================================================== 
  def self.brown(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.brown(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.brown(i, &block)
      else
        return ::Colours::BasicColours.brown(i, &block)
      end
    else
      return i
    end
  end; def brown(i = '', &block); AllColourMethods.brown(i, &block); end
       def konsole_colour_brown(i = ''); AllColourMethods.brown(i); end
       def konsole_brown(i = ''); AllColourMethods.brown(i); end
       self.instance_eval { alias konsole_colour_brown brown } # === Colours::AllColourMethods.konsole_colour_brown
       def Colours.ebrown(i = ''); puts AllColourMethods.brown(i); end
       def ebrown(i = ''); puts AllColourMethods.brown(i); end
       alias ekonsole_colour_brown ebrown

  # ======================================================================== 
  # === Colours::AllColourMethods.burlywood
  # ======================================================================== 
  def self.burlywood(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.burlywood(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.burlywood(i, &block)
      else
        return ::Colours::BasicColours.burlywood(i, &block)
      end
    else
      return i
    end
  end; def burlywood(i = '', &block); AllColourMethods.burlywood(i, &block); end
       def konsole_colour_burlywood(i = ''); AllColourMethods.burlywood(i); end
       def konsole_burlywood(i = ''); AllColourMethods.burlywood(i); end
       self.instance_eval { alias konsole_colour_burlywood burlywood } # === Colours::AllColourMethods.konsole_colour_burlywood
       def Colours.eburlywood(i = ''); puts AllColourMethods.burlywood(i); end
       def eburlywood(i = ''); puts AllColourMethods.burlywood(i); end
       alias ekonsole_colour_burlywood eburlywood

  # ======================================================================== 
  # === Colours::AllColourMethods.cadetblue
  # ======================================================================== 
  def self.cadetblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.cadetblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.cadetblue(i, &block)
      else
        return ::Colours::BasicColours.cadetblue(i, &block)
      end
    else
      return i
    end
  end; def cadetblue(i = '', &block); AllColourMethods.cadetblue(i, &block); end
       def konsole_colour_cadetblue(i = ''); AllColourMethods.cadetblue(i); end
       def konsole_cadetblue(i = ''); AllColourMethods.cadetblue(i); end
       self.instance_eval { alias konsole_colour_cadetblue cadetblue } # === Colours::AllColourMethods.konsole_colour_cadetblue
       def Colours.ecadetblue(i = ''); puts AllColourMethods.cadetblue(i); end
       def ecadetblue(i = ''); puts AllColourMethods.cadetblue(i); end
       alias ekonsole_colour_cadetblue ecadetblue

  # ======================================================================== 
  # === Colours::AllColourMethods.chartreuse
  # ======================================================================== 
  def self.chartreuse(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.chartreuse(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.chartreuse(i, &block)
      else
        return ::Colours::BasicColours.chartreuse(i, &block)
      end
    else
      return i
    end
  end; def chartreuse(i = '', &block); AllColourMethods.chartreuse(i, &block); end
       def konsole_colour_chartreuse(i = ''); AllColourMethods.chartreuse(i); end
       def konsole_chartreuse(i = ''); AllColourMethods.chartreuse(i); end
       self.instance_eval { alias konsole_colour_chartreuse chartreuse } # === Colours::AllColourMethods.konsole_colour_chartreuse
       def Colours.echartreuse(i = ''); puts AllColourMethods.chartreuse(i); end
       def echartreuse(i = ''); puts AllColourMethods.chartreuse(i); end
       alias ekonsole_colour_chartreuse echartreuse

  # ======================================================================== 
  # === Colours::AllColourMethods.chartreuse1
  # ======================================================================== 
  def self.chartreuse1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.chartreuse1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.chartreuse1(i, &block)
      else
        return ::Colours::BasicColours.chartreuse1(i, &block)
      end
    else
      return i
    end
  end; def chartreuse1(i = '', &block); AllColourMethods.chartreuse1(i, &block); end
       def konsole_colour_chartreuse1(i = ''); AllColourMethods.chartreuse1(i); end
       def konsole_chartreuse1(i = ''); AllColourMethods.chartreuse1(i); end
       self.instance_eval { alias konsole_colour_chartreuse1 chartreuse1 } # === Colours::AllColourMethods.konsole_colour_chartreuse1
       def Colours.echartreuse1(i = ''); puts AllColourMethods.chartreuse1(i); end
       def echartreuse1(i = ''); puts AllColourMethods.chartreuse1(i); end
       alias ekonsole_colour_chartreuse1 echartreuse1

  # ======================================================================== 
  # === Colours::AllColourMethods.chartreuse2
  # ======================================================================== 
  def self.chartreuse2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.chartreuse2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.chartreuse2(i, &block)
      else
        return ::Colours::BasicColours.chartreuse2(i, &block)
      end
    else
      return i
    end
  end; def chartreuse2(i = '', &block); AllColourMethods.chartreuse2(i, &block); end
       def konsole_colour_chartreuse2(i = ''); AllColourMethods.chartreuse2(i); end
       def konsole_chartreuse2(i = ''); AllColourMethods.chartreuse2(i); end
       self.instance_eval { alias konsole_colour_chartreuse2 chartreuse2 } # === Colours::AllColourMethods.konsole_colour_chartreuse2
       def Colours.echartreuse2(i = ''); puts AllColourMethods.chartreuse2(i); end
       def echartreuse2(i = ''); puts AllColourMethods.chartreuse2(i); end
       alias ekonsole_colour_chartreuse2 echartreuse2

  # ======================================================================== 
  # === Colours::AllColourMethods.chartreuse3
  # ======================================================================== 
  def self.chartreuse3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.chartreuse3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.chartreuse3(i, &block)
      else
        return ::Colours::BasicColours.chartreuse3(i, &block)
      end
    else
      return i
    end
  end; def chartreuse3(i = '', &block); AllColourMethods.chartreuse3(i, &block); end
       def konsole_colour_chartreuse3(i = ''); AllColourMethods.chartreuse3(i); end
       def konsole_chartreuse3(i = ''); AllColourMethods.chartreuse3(i); end
       self.instance_eval { alias konsole_colour_chartreuse3 chartreuse3 } # === Colours::AllColourMethods.konsole_colour_chartreuse3
       def Colours.echartreuse3(i = ''); puts AllColourMethods.chartreuse3(i); end
       def echartreuse3(i = ''); puts AllColourMethods.chartreuse3(i); end
       alias ekonsole_colour_chartreuse3 echartreuse3

  # ======================================================================== 
  # === Colours::AllColourMethods.chartreuse4
  # ======================================================================== 
  def self.chartreuse4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.chartreuse4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.chartreuse4(i, &block)
      else
        return ::Colours::BasicColours.chartreuse4(i, &block)
      end
    else
      return i
    end
  end; def chartreuse4(i = '', &block); AllColourMethods.chartreuse4(i, &block); end
       def konsole_colour_chartreuse4(i = ''); AllColourMethods.chartreuse4(i); end
       def konsole_chartreuse4(i = ''); AllColourMethods.chartreuse4(i); end
       self.instance_eval { alias konsole_colour_chartreuse4 chartreuse4 } # === Colours::AllColourMethods.konsole_colour_chartreuse4
       def Colours.echartreuse4(i = ''); puts AllColourMethods.chartreuse4(i); end
       def echartreuse4(i = ''); puts AllColourMethods.chartreuse4(i); end
       alias ekonsole_colour_chartreuse4 echartreuse4

  # ======================================================================== 
  # === Colours::AllColourMethods.chocolate
  # ======================================================================== 
  def self.chocolate(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.chocolate(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.chocolate(i, &block)
      else
        return ::Colours::BasicColours.chocolate(i, &block)
      end
    else
      return i
    end
  end; def chocolate(i = '', &block); AllColourMethods.chocolate(i, &block); end
       def konsole_colour_chocolate(i = ''); AllColourMethods.chocolate(i); end
       def konsole_chocolate(i = ''); AllColourMethods.chocolate(i); end
       self.instance_eval { alias konsole_colour_chocolate chocolate } # === Colours::AllColourMethods.konsole_colour_chocolate
       def Colours.echocolate(i = ''); puts AllColourMethods.chocolate(i); end
       def echocolate(i = ''); puts AllColourMethods.chocolate(i); end
       alias ekonsole_colour_chocolate echocolate

  # ======================================================================== 
  # === Colours::AllColourMethods.coral
  # ======================================================================== 
  def self.coral(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.coral(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.coral(i, &block)
      else
        return ::Colours::BasicColours.coral(i, &block)
      end
    else
      return i
    end
  end; def coral(i = '', &block); AllColourMethods.coral(i, &block); end
       def konsole_colour_coral(i = ''); AllColourMethods.coral(i); end
       def konsole_coral(i = ''); AllColourMethods.coral(i); end
       self.instance_eval { alias konsole_colour_coral coral } # === Colours::AllColourMethods.konsole_colour_coral
       def Colours.ecoral(i = ''); puts AllColourMethods.coral(i); end
       def ecoral(i = ''); puts AllColourMethods.coral(i); end
       alias ekonsole_colour_coral ecoral

  # ======================================================================== 
  # === Colours::AllColourMethods.cornflowerblue
  # ======================================================================== 
  def self.cornflowerblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.cornflowerblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.cornflowerblue(i, &block)
      else
        return ::Colours::BasicColours.cornflowerblue(i, &block)
      end
    else
      return i
    end
  end; def cornflowerblue(i = '', &block); AllColourMethods.cornflowerblue(i, &block); end
       def konsole_colour_cornflowerblue(i = ''); AllColourMethods.cornflowerblue(i); end
       def konsole_cornflowerblue(i = ''); AllColourMethods.cornflowerblue(i); end
       self.instance_eval { alias konsole_colour_cornflowerblue cornflowerblue } # === Colours::AllColourMethods.konsole_colour_cornflowerblue
       def Colours.ecornflowerblue(i = ''); puts AllColourMethods.cornflowerblue(i); end
       def ecornflowerblue(i = ''); puts AllColourMethods.cornflowerblue(i); end
       alias ekonsole_colour_cornflowerblue ecornflowerblue

  # ======================================================================== 
  # === Colours::AllColourMethods.cornsilk
  # ======================================================================== 
  def self.cornsilk(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.cornsilk(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.cornsilk(i, &block)
      else
        return ::Colours::BasicColours.cornsilk(i, &block)
      end
    else
      return i
    end
  end; def cornsilk(i = '', &block); AllColourMethods.cornsilk(i, &block); end
       def konsole_colour_cornsilk(i = ''); AllColourMethods.cornsilk(i); end
       def konsole_cornsilk(i = ''); AllColourMethods.cornsilk(i); end
       self.instance_eval { alias konsole_colour_cornsilk cornsilk } # === Colours::AllColourMethods.konsole_colour_cornsilk
       def Colours.ecornsilk(i = ''); puts AllColourMethods.cornsilk(i); end
       def ecornsilk(i = ''); puts AllColourMethods.cornsilk(i); end
       alias ekonsole_colour_cornsilk ecornsilk

  # ======================================================================== 
  # === Colours::AllColourMethods.cornsilk1
  # ======================================================================== 
  def self.cornsilk1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.cornsilk1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.cornsilk1(i, &block)
      else
        return ::Colours::BasicColours.cornsilk1(i, &block)
      end
    else
      return i
    end
  end; def cornsilk1(i = '', &block); AllColourMethods.cornsilk1(i, &block); end
       def konsole_colour_cornsilk1(i = ''); AllColourMethods.cornsilk1(i); end
       def konsole_cornsilk1(i = ''); AllColourMethods.cornsilk1(i); end
       self.instance_eval { alias konsole_colour_cornsilk1 cornsilk1 } # === Colours::AllColourMethods.konsole_colour_cornsilk1
       def Colours.ecornsilk1(i = ''); puts AllColourMethods.cornsilk1(i); end
       def ecornsilk1(i = ''); puts AllColourMethods.cornsilk1(i); end
       alias ekonsole_colour_cornsilk1 ecornsilk1

  # ======================================================================== 
  # === Colours::AllColourMethods.crimson
  # ======================================================================== 
  def self.crimson(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.crimson(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.crimson(i, &block)
      else
        return ::Colours::BasicColours.crimson(i, &block)
      end
    else
      return i
    end
  end; def crimson(i = '', &block); AllColourMethods.crimson(i, &block); end
       def konsole_colour_crimson(i = ''); AllColourMethods.crimson(i); end
       def konsole_crimson(i = ''); AllColourMethods.crimson(i); end
       self.instance_eval { alias konsole_colour_crimson crimson } # === Colours::AllColourMethods.konsole_colour_crimson
       def Colours.ecrimson(i = ''); puts AllColourMethods.crimson(i); end
       def ecrimson(i = ''); puts AllColourMethods.crimson(i); end
       alias ekonsole_colour_crimson ecrimson

  # ======================================================================== 
  # === Colours::AllColourMethods.cyan
  # ======================================================================== 
  def self.cyan(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.cyan(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.cyan(i, &block)
      else
        return ::Colours::BasicColours.cyan(i, &block)
      end
    else
      return i
    end
  end; def cyan(i = '', &block); AllColourMethods.cyan(i, &block); end
       def konsole_colour_cyan(i = ''); AllColourMethods.cyan(i); end
       def konsole_cyan(i = ''); AllColourMethods.cyan(i); end
       self.instance_eval { alias konsole_colour_cyan cyan } # === Colours::AllColourMethods.konsole_colour_cyan
       def Colours.ecyan(i = ''); puts AllColourMethods.cyan(i); end
       def ecyan(i = ''); puts AllColourMethods.cyan(i); end
       alias ekonsole_colour_cyan ecyan

  # ======================================================================== 
  # === Colours::AllColourMethods.cyan1
  # ======================================================================== 
  def self.cyan1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.cyan1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.cyan1(i, &block)
      else
        return ::Colours::BasicColours.cyan1(i, &block)
      end
    else
      return i
    end
  end; def cyan1(i = '', &block); AllColourMethods.cyan1(i, &block); end
       def konsole_colour_cyan1(i = ''); AllColourMethods.cyan1(i); end
       def konsole_cyan1(i = ''); AllColourMethods.cyan1(i); end
       self.instance_eval { alias konsole_colour_cyan1 cyan1 } # === Colours::AllColourMethods.konsole_colour_cyan1
       def Colours.ecyan1(i = ''); puts AllColourMethods.cyan1(i); end
       def ecyan1(i = ''); puts AllColourMethods.cyan1(i); end
       alias ekonsole_colour_cyan1 ecyan1

  # ======================================================================== 
  # === Colours::AllColourMethods.cyan2
  # ======================================================================== 
  def self.cyan2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.cyan2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.cyan2(i, &block)
      else
        return ::Colours::BasicColours.cyan2(i, &block)
      end
    else
      return i
    end
  end; def cyan2(i = '', &block); AllColourMethods.cyan2(i, &block); end
       def konsole_colour_cyan2(i = ''); AllColourMethods.cyan2(i); end
       def konsole_cyan2(i = ''); AllColourMethods.cyan2(i); end
       self.instance_eval { alias konsole_colour_cyan2 cyan2 } # === Colours::AllColourMethods.konsole_colour_cyan2
       def Colours.ecyan2(i = ''); puts AllColourMethods.cyan2(i); end
       def ecyan2(i = ''); puts AllColourMethods.cyan2(i); end
       alias ekonsole_colour_cyan2 ecyan2

  # ======================================================================== 
  # === Colours::AllColourMethods.cyan3
  # ======================================================================== 
  def self.cyan3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.cyan3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.cyan3(i, &block)
      else
        return ::Colours::BasicColours.cyan3(i, &block)
      end
    else
      return i
    end
  end; def cyan3(i = '', &block); AllColourMethods.cyan3(i, &block); end
       def konsole_colour_cyan3(i = ''); AllColourMethods.cyan3(i); end
       def konsole_cyan3(i = ''); AllColourMethods.cyan3(i); end
       self.instance_eval { alias konsole_colour_cyan3 cyan3 } # === Colours::AllColourMethods.konsole_colour_cyan3
       def Colours.ecyan3(i = ''); puts AllColourMethods.cyan3(i); end
       def ecyan3(i = ''); puts AllColourMethods.cyan3(i); end
       alias ekonsole_colour_cyan3 ecyan3

       def dark_gray(i = ''); AllColourMethods.darkgray(i); end
  # ======================================================================== 
  # === Colours::AllColourMethods.darkblue
  # ======================================================================== 
  def self.darkblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkblue(i, &block)
      else
        return ::Colours::BasicColours.darkblue(i, &block)
      end
    else
      return i
    end
  end; def darkblue(i = '', &block); AllColourMethods.darkblue(i, &block); end
       def konsole_colour_darkblue(i = ''); AllColourMethods.darkblue(i); end
       def konsole_darkblue(i = ''); AllColourMethods.darkblue(i); end
       self.instance_eval { alias konsole_colour_darkblue darkblue } # === Colours::AllColourMethods.konsole_colour_darkblue
       def Colours.edarkblue(i = ''); puts AllColourMethods.darkblue(i); end
       def edarkblue(i = ''); puts AllColourMethods.darkblue(i); end
       alias ekonsole_colour_darkblue edarkblue

  # ======================================================================== 
  # === Colours::AllColourMethods.darkcyan
  # ======================================================================== 
  def self.darkcyan(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkcyan(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkcyan(i, &block)
      else
        return ::Colours::BasicColours.darkcyan(i, &block)
      end
    else
      return i
    end
  end; def darkcyan(i = '', &block); AllColourMethods.darkcyan(i, &block); end
       def konsole_colour_darkcyan(i = ''); AllColourMethods.darkcyan(i); end
       def konsole_darkcyan(i = ''); AllColourMethods.darkcyan(i); end
       self.instance_eval { alias konsole_colour_darkcyan darkcyan } # === Colours::AllColourMethods.konsole_colour_darkcyan
       def Colours.edarkcyan(i = ''); puts AllColourMethods.darkcyan(i); end
       def edarkcyan(i = ''); puts AllColourMethods.darkcyan(i); end
       alias ekonsole_colour_darkcyan edarkcyan

  # ======================================================================== 
  # === Colours::AllColourMethods.darkgoldenrod
  # ======================================================================== 
  def self.darkgoldenrod(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkgoldenrod(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkgoldenrod(i, &block)
      else
        return ::Colours::BasicColours.darkgoldenrod(i, &block)
      end
    else
      return i
    end
  end; def darkgoldenrod(i = '', &block); AllColourMethods.darkgoldenrod(i, &block); end
       def konsole_colour_darkgoldenrod(i = ''); AllColourMethods.darkgoldenrod(i); end
       def konsole_darkgoldenrod(i = ''); AllColourMethods.darkgoldenrod(i); end
       self.instance_eval { alias konsole_colour_darkgoldenrod darkgoldenrod } # === Colours::AllColourMethods.konsole_colour_darkgoldenrod
       def Colours.edarkgoldenrod(i = ''); puts AllColourMethods.darkgoldenrod(i); end
       def edarkgoldenrod(i = ''); puts AllColourMethods.darkgoldenrod(i); end
       alias ekonsole_colour_darkgoldenrod edarkgoldenrod

  # ======================================================================== 
  # === Colours::AllColourMethods.darkgray
  # ======================================================================== 
  def self.darkgray(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkgray(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkgray(i, &block)
      else
        return ::Colours::BasicColours.darkgray(i, &block)
      end
    else
      return i
    end
  end; def darkgray(i = '', &block); AllColourMethods.darkgray(i, &block); end
       def konsole_colour_darkgray(i = ''); AllColourMethods.darkgray(i); end
       def konsole_darkgray(i = ''); AllColourMethods.darkgray(i); end
       self.instance_eval { alias konsole_colour_darkgray darkgray } # === Colours::AllColourMethods.konsole_colour_darkgray
       def Colours.edarkgray(i = ''); puts AllColourMethods.darkgray(i); end
       def edarkgray(i = ''); puts AllColourMethods.darkgray(i); end
       alias ekonsole_colour_darkgray edarkgray

  # ======================================================================== 
  # === Colours::AllColourMethods.darkgreen
  # ======================================================================== 
  def self.darkgreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkgreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkgreen(i, &block)
      else
        return ::Colours::BasicColours.darkgreen(i, &block)
      end
    else
      return i
    end
  end; def darkgreen(i = '', &block); AllColourMethods.darkgreen(i, &block); end
       def konsole_colour_darkgreen(i = ''); AllColourMethods.darkgreen(i); end
       def konsole_darkgreen(i = ''); AllColourMethods.darkgreen(i); end
       self.instance_eval { alias konsole_colour_darkgreen darkgreen } # === Colours::AllColourMethods.konsole_colour_darkgreen
       def Colours.edarkgreen(i = ''); puts AllColourMethods.darkgreen(i); end
       def edarkgreen(i = ''); puts AllColourMethods.darkgreen(i); end
       alias ekonsole_colour_darkgreen edarkgreen

  # ======================================================================== 
  # === Colours::AllColourMethods.darkgrey
  # ======================================================================== 
  def self.darkgrey(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkgrey(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkgrey(i, &block)
      else
        return ::Colours::BasicColours.darkgrey(i, &block)
      end
    else
      return i
    end
  end; def darkgrey(i = '', &block); AllColourMethods.darkgrey(i, &block); end
       def konsole_colour_darkgrey(i = ''); AllColourMethods.darkgrey(i); end
       def konsole_darkgrey(i = ''); AllColourMethods.darkgrey(i); end
       self.instance_eval { alias konsole_colour_darkgrey darkgrey } # === Colours::AllColourMethods.konsole_colour_darkgrey
       def Colours.edarkgrey(i = ''); puts AllColourMethods.darkgrey(i); end
       def edarkgrey(i = ''); puts AllColourMethods.darkgrey(i); end
       alias ekonsole_colour_darkgrey edarkgrey

  # ======================================================================== 
  # === Colours::AllColourMethods.darkkhaki
  # ======================================================================== 
  def self.darkkhaki(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkkhaki(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkkhaki(i, &block)
      else
        return ::Colours::BasicColours.darkkhaki(i, &block)
      end
    else
      return i
    end
  end; def darkkhaki(i = '', &block); AllColourMethods.darkkhaki(i, &block); end
       def konsole_colour_darkkhaki(i = ''); AllColourMethods.darkkhaki(i); end
       def konsole_darkkhaki(i = ''); AllColourMethods.darkkhaki(i); end
       self.instance_eval { alias konsole_colour_darkkhaki darkkhaki } # === Colours::AllColourMethods.konsole_colour_darkkhaki
       def Colours.edarkkhaki(i = ''); puts AllColourMethods.darkkhaki(i); end
       def edarkkhaki(i = ''); puts AllColourMethods.darkkhaki(i); end
       alias ekonsole_colour_darkkhaki edarkkhaki

  # ======================================================================== 
  # === Colours::AllColourMethods.darkmagenta
  # ======================================================================== 
  def self.darkmagenta(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkmagenta(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkmagenta(i, &block)
      else
        return ::Colours::BasicColours.darkmagenta(i, &block)
      end
    else
      return i
    end
  end; def darkmagenta(i = '', &block); AllColourMethods.darkmagenta(i, &block); end
       def konsole_colour_darkmagenta(i = ''); AllColourMethods.darkmagenta(i); end
       def konsole_darkmagenta(i = ''); AllColourMethods.darkmagenta(i); end
       self.instance_eval { alias konsole_colour_darkmagenta darkmagenta } # === Colours::AllColourMethods.konsole_colour_darkmagenta
       def Colours.edarkmagenta(i = ''); puts AllColourMethods.darkmagenta(i); end
       def edarkmagenta(i = ''); puts AllColourMethods.darkmagenta(i); end
       alias ekonsole_colour_darkmagenta edarkmagenta

  # ======================================================================== 
  # === Colours::AllColourMethods.darkolivegreen
  # ======================================================================== 
  def self.darkolivegreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkolivegreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkolivegreen(i, &block)
      else
        return ::Colours::BasicColours.darkolivegreen(i, &block)
      end
    else
      return i
    end
  end; def darkolivegreen(i = '', &block); AllColourMethods.darkolivegreen(i, &block); end
       def konsole_colour_darkolivegreen(i = ''); AllColourMethods.darkolivegreen(i); end
       def konsole_darkolivegreen(i = ''); AllColourMethods.darkolivegreen(i); end
       self.instance_eval { alias konsole_colour_darkolivegreen darkolivegreen } # === Colours::AllColourMethods.konsole_colour_darkolivegreen
       def Colours.edarkolivegreen(i = ''); puts AllColourMethods.darkolivegreen(i); end
       def edarkolivegreen(i = ''); puts AllColourMethods.darkolivegreen(i); end
       alias ekonsole_colour_darkolivegreen edarkolivegreen

  # ======================================================================== 
  # === Colours::AllColourMethods.darkolivegreen1
  # ======================================================================== 
  def self.darkolivegreen1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkolivegreen1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkolivegreen1(i, &block)
      else
        return ::Colours::BasicColours.darkolivegreen1(i, &block)
      end
    else
      return i
    end
  end; def darkolivegreen1(i = '', &block); AllColourMethods.darkolivegreen1(i, &block); end
       def konsole_colour_darkolivegreen1(i = ''); AllColourMethods.darkolivegreen1(i); end
       def konsole_darkolivegreen1(i = ''); AllColourMethods.darkolivegreen1(i); end
       self.instance_eval { alias konsole_colour_darkolivegreen1 darkolivegreen1 } # === Colours::AllColourMethods.konsole_colour_darkolivegreen1
       def Colours.edarkolivegreen1(i = ''); puts AllColourMethods.darkolivegreen1(i); end
       def edarkolivegreen1(i = ''); puts AllColourMethods.darkolivegreen1(i); end
       alias ekonsole_colour_darkolivegreen1 edarkolivegreen1

  # ======================================================================== 
  # === Colours::AllColourMethods.darkolivegreen2
  # ======================================================================== 
  def self.darkolivegreen2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkolivegreen2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkolivegreen2(i, &block)
      else
        return ::Colours::BasicColours.darkolivegreen2(i, &block)
      end
    else
      return i
    end
  end; def darkolivegreen2(i = '', &block); AllColourMethods.darkolivegreen2(i, &block); end
       def konsole_colour_darkolivegreen2(i = ''); AllColourMethods.darkolivegreen2(i); end
       def konsole_darkolivegreen2(i = ''); AllColourMethods.darkolivegreen2(i); end
       self.instance_eval { alias konsole_colour_darkolivegreen2 darkolivegreen2 } # === Colours::AllColourMethods.konsole_colour_darkolivegreen2
       def Colours.edarkolivegreen2(i = ''); puts AllColourMethods.darkolivegreen2(i); end
       def edarkolivegreen2(i = ''); puts AllColourMethods.darkolivegreen2(i); end
       alias ekonsole_colour_darkolivegreen2 edarkolivegreen2

  # ======================================================================== 
  # === Colours::AllColourMethods.darkolivegreen3
  # ======================================================================== 
  def self.darkolivegreen3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkolivegreen3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkolivegreen3(i, &block)
      else
        return ::Colours::BasicColours.darkolivegreen3(i, &block)
      end
    else
      return i
    end
  end; def darkolivegreen3(i = '', &block); AllColourMethods.darkolivegreen3(i, &block); end
       def konsole_colour_darkolivegreen3(i = ''); AllColourMethods.darkolivegreen3(i); end
       def konsole_darkolivegreen3(i = ''); AllColourMethods.darkolivegreen3(i); end
       self.instance_eval { alias konsole_colour_darkolivegreen3 darkolivegreen3 } # === Colours::AllColourMethods.konsole_colour_darkolivegreen3
       def Colours.edarkolivegreen3(i = ''); puts AllColourMethods.darkolivegreen3(i); end
       def edarkolivegreen3(i = ''); puts AllColourMethods.darkolivegreen3(i); end
       alias ekonsole_colour_darkolivegreen3 edarkolivegreen3

  # ======================================================================== 
  # === Colours::AllColourMethods.darkorange
  # ======================================================================== 
  def self.darkorange(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkorange(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkorange(i, &block)
      else
        return ::Colours::BasicColours.darkorange(i, &block)
      end
    else
      return i
    end
  end; def darkorange(i = '', &block); AllColourMethods.darkorange(i, &block); end
       def konsole_colour_darkorange(i = ''); AllColourMethods.darkorange(i); end
       def konsole_darkorange(i = ''); AllColourMethods.darkorange(i); end
       self.instance_eval { alias konsole_colour_darkorange darkorange } # === Colours::AllColourMethods.konsole_colour_darkorange
       def Colours.edarkorange(i = ''); puts AllColourMethods.darkorange(i); end
       def edarkorange(i = ''); puts AllColourMethods.darkorange(i); end
       alias ekonsole_colour_darkorange edarkorange

  # ======================================================================== 
  # === Colours::AllColourMethods.darkorange3
  # ======================================================================== 
  def self.darkorange3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkorange3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkorange3(i, &block)
      else
        return ::Colours::BasicColours.darkorange3(i, &block)
      end
    else
      return i
    end
  end; def darkorange3(i = '', &block); AllColourMethods.darkorange3(i, &block); end
       def konsole_colour_darkorange3(i = ''); AllColourMethods.darkorange3(i); end
       def konsole_darkorange3(i = ''); AllColourMethods.darkorange3(i); end
       self.instance_eval { alias konsole_colour_darkorange3 darkorange3 } # === Colours::AllColourMethods.konsole_colour_darkorange3
       def Colours.edarkorange3(i = ''); puts AllColourMethods.darkorange3(i); end
       def edarkorange3(i = ''); puts AllColourMethods.darkorange3(i); end
       alias ekonsole_colour_darkorange3 edarkorange3

  # ======================================================================== 
  # === Colours::AllColourMethods.darkorchid
  # ======================================================================== 
  def self.darkorchid(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkorchid(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkorchid(i, &block)
      else
        return ::Colours::BasicColours.darkorchid(i, &block)
      end
    else
      return i
    end
  end; def darkorchid(i = '', &block); AllColourMethods.darkorchid(i, &block); end
       def konsole_colour_darkorchid(i = ''); AllColourMethods.darkorchid(i); end
       def konsole_darkorchid(i = ''); AllColourMethods.darkorchid(i); end
       self.instance_eval { alias konsole_colour_darkorchid darkorchid } # === Colours::AllColourMethods.konsole_colour_darkorchid
       def Colours.edarkorchid(i = ''); puts AllColourMethods.darkorchid(i); end
       def edarkorchid(i = ''); puts AllColourMethods.darkorchid(i); end
       alias ekonsole_colour_darkorchid edarkorchid

  # ======================================================================== 
  # === Colours::AllColourMethods.darkred
  # ======================================================================== 
  def self.darkred(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkred(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkred(i, &block)
      else
        return ::Colours::BasicColours.darkred(i, &block)
      end
    else
      return i
    end
  end; def darkred(i = '', &block); AllColourMethods.darkred(i, &block); end
       def konsole_colour_darkred(i = ''); AllColourMethods.darkred(i); end
       def konsole_darkred(i = ''); AllColourMethods.darkred(i); end
       self.instance_eval { alias konsole_colour_darkred darkred } # === Colours::AllColourMethods.konsole_colour_darkred
       def Colours.edarkred(i = ''); puts AllColourMethods.darkred(i); end
       def edarkred(i = ''); puts AllColourMethods.darkred(i); end
       alias ekonsole_colour_darkred edarkred

  # ======================================================================== 
  # === Colours::AllColourMethods.darksalmon
  # ======================================================================== 
  def self.darksalmon(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darksalmon(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darksalmon(i, &block)
      else
        return ::Colours::BasicColours.darksalmon(i, &block)
      end
    else
      return i
    end
  end; def darksalmon(i = '', &block); AllColourMethods.darksalmon(i, &block); end
       def konsole_colour_darksalmon(i = ''); AllColourMethods.darksalmon(i); end
       def konsole_darksalmon(i = ''); AllColourMethods.darksalmon(i); end
       self.instance_eval { alias konsole_colour_darksalmon darksalmon } # === Colours::AllColourMethods.konsole_colour_darksalmon
       def Colours.edarksalmon(i = ''); puts AllColourMethods.darksalmon(i); end
       def edarksalmon(i = ''); puts AllColourMethods.darksalmon(i); end
       alias ekonsole_colour_darksalmon edarksalmon

  # ======================================================================== 
  # === Colours::AllColourMethods.darkseagreen
  # ======================================================================== 
  def self.darkseagreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkseagreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkseagreen(i, &block)
      else
        return ::Colours::BasicColours.darkseagreen(i, &block)
      end
    else
      return i
    end
  end; def darkseagreen(i = '', &block); AllColourMethods.darkseagreen(i, &block); end
       def konsole_colour_darkseagreen(i = ''); AllColourMethods.darkseagreen(i); end
       def konsole_darkseagreen(i = ''); AllColourMethods.darkseagreen(i); end
       self.instance_eval { alias konsole_colour_darkseagreen darkseagreen } # === Colours::AllColourMethods.konsole_colour_darkseagreen
       def Colours.edarkseagreen(i = ''); puts AllColourMethods.darkseagreen(i); end
       def edarkseagreen(i = ''); puts AllColourMethods.darkseagreen(i); end
       alias ekonsole_colour_darkseagreen edarkseagreen

  # ======================================================================== 
  # === Colours::AllColourMethods.darkseagreen1
  # ======================================================================== 
  def self.darkseagreen1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkseagreen1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkseagreen1(i, &block)
      else
        return ::Colours::BasicColours.darkseagreen1(i, &block)
      end
    else
      return i
    end
  end; def darkseagreen1(i = '', &block); AllColourMethods.darkseagreen1(i, &block); end
       def konsole_colour_darkseagreen1(i = ''); AllColourMethods.darkseagreen1(i); end
       def konsole_darkseagreen1(i = ''); AllColourMethods.darkseagreen1(i); end
       self.instance_eval { alias konsole_colour_darkseagreen1 darkseagreen1 } # === Colours::AllColourMethods.konsole_colour_darkseagreen1
       def Colours.edarkseagreen1(i = ''); puts AllColourMethods.darkseagreen1(i); end
       def edarkseagreen1(i = ''); puts AllColourMethods.darkseagreen1(i); end
       alias ekonsole_colour_darkseagreen1 edarkseagreen1

  # ======================================================================== 
  # === Colours::AllColourMethods.darkseagreen2
  # ======================================================================== 
  def self.darkseagreen2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkseagreen2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkseagreen2(i, &block)
      else
        return ::Colours::BasicColours.darkseagreen2(i, &block)
      end
    else
      return i
    end
  end; def darkseagreen2(i = '', &block); AllColourMethods.darkseagreen2(i, &block); end
       def konsole_colour_darkseagreen2(i = ''); AllColourMethods.darkseagreen2(i); end
       def konsole_darkseagreen2(i = ''); AllColourMethods.darkseagreen2(i); end
       self.instance_eval { alias konsole_colour_darkseagreen2 darkseagreen2 } # === Colours::AllColourMethods.konsole_colour_darkseagreen2
       def Colours.edarkseagreen2(i = ''); puts AllColourMethods.darkseagreen2(i); end
       def edarkseagreen2(i = ''); puts AllColourMethods.darkseagreen2(i); end
       alias ekonsole_colour_darkseagreen2 edarkseagreen2

  # ======================================================================== 
  # === Colours::AllColourMethods.darkseagreen3
  # ======================================================================== 
  def self.darkseagreen3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkseagreen3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkseagreen3(i, &block)
      else
        return ::Colours::BasicColours.darkseagreen3(i, &block)
      end
    else
      return i
    end
  end; def darkseagreen3(i = '', &block); AllColourMethods.darkseagreen3(i, &block); end
       def konsole_colour_darkseagreen3(i = ''); AllColourMethods.darkseagreen3(i); end
       def konsole_darkseagreen3(i = ''); AllColourMethods.darkseagreen3(i); end
       self.instance_eval { alias konsole_colour_darkseagreen3 darkseagreen3 } # === Colours::AllColourMethods.konsole_colour_darkseagreen3
       def Colours.edarkseagreen3(i = ''); puts AllColourMethods.darkseagreen3(i); end
       def edarkseagreen3(i = ''); puts AllColourMethods.darkseagreen3(i); end
       alias ekonsole_colour_darkseagreen3 edarkseagreen3

  # ======================================================================== 
  # === Colours::AllColourMethods.darkseagreen4
  # ======================================================================== 
  def self.darkseagreen4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkseagreen4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkseagreen4(i, &block)
      else
        return ::Colours::BasicColours.darkseagreen4(i, &block)
      end
    else
      return i
    end
  end; def darkseagreen4(i = '', &block); AllColourMethods.darkseagreen4(i, &block); end
       def konsole_colour_darkseagreen4(i = ''); AllColourMethods.darkseagreen4(i); end
       def konsole_darkseagreen4(i = ''); AllColourMethods.darkseagreen4(i); end
       self.instance_eval { alias konsole_colour_darkseagreen4 darkseagreen4 } # === Colours::AllColourMethods.konsole_colour_darkseagreen4
       def Colours.edarkseagreen4(i = ''); puts AllColourMethods.darkseagreen4(i); end
       def edarkseagreen4(i = ''); puts AllColourMethods.darkseagreen4(i); end
       alias ekonsole_colour_darkseagreen4 edarkseagreen4

  # ======================================================================== 
  # === Colours::AllColourMethods.darkslateblue
  # ======================================================================== 
  def self.darkslateblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkslateblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkslateblue(i, &block)
      else
        return ::Colours::BasicColours.darkslateblue(i, &block)
      end
    else
      return i
    end
  end; def darkslateblue(i = '', &block); AllColourMethods.darkslateblue(i, &block); end
       def konsole_colour_darkslateblue(i = ''); AllColourMethods.darkslateblue(i); end
       def konsole_darkslateblue(i = ''); AllColourMethods.darkslateblue(i); end
       self.instance_eval { alias konsole_colour_darkslateblue darkslateblue } # === Colours::AllColourMethods.konsole_colour_darkslateblue
       def Colours.edarkslateblue(i = ''); puts AllColourMethods.darkslateblue(i); end
       def edarkslateblue(i = ''); puts AllColourMethods.darkslateblue(i); end
       alias ekonsole_colour_darkslateblue edarkslateblue

  # ======================================================================== 
  # === Colours::AllColourMethods.darkslategray
  # ======================================================================== 
  def self.darkslategray(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkslategray(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkslategray(i, &block)
      else
        return ::Colours::BasicColours.darkslategray(i, &block)
      end
    else
      return i
    end
  end; def darkslategray(i = '', &block); AllColourMethods.darkslategray(i, &block); end
       def konsole_colour_darkslategray(i = ''); AllColourMethods.darkslategray(i); end
       def konsole_darkslategray(i = ''); AllColourMethods.darkslategray(i); end
       self.instance_eval { alias konsole_colour_darkslategray darkslategray } # === Colours::AllColourMethods.konsole_colour_darkslategray
       def Colours.edarkslategray(i = ''); puts AllColourMethods.darkslategray(i); end
       def edarkslategray(i = ''); puts AllColourMethods.darkslategray(i); end
       alias ekonsole_colour_darkslategray edarkslategray

  # ======================================================================== 
  # === Colours::AllColourMethods.darkslategray1
  # ======================================================================== 
  def self.darkslategray1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkslategray1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkslategray1(i, &block)
      else
        return ::Colours::BasicColours.darkslategray1(i, &block)
      end
    else
      return i
    end
  end; def darkslategray1(i = '', &block); AllColourMethods.darkslategray1(i, &block); end
       def konsole_colour_darkslategray1(i = ''); AllColourMethods.darkslategray1(i); end
       def konsole_darkslategray1(i = ''); AllColourMethods.darkslategray1(i); end
       self.instance_eval { alias konsole_colour_darkslategray1 darkslategray1 } # === Colours::AllColourMethods.konsole_colour_darkslategray1
       def Colours.edarkslategray1(i = ''); puts AllColourMethods.darkslategray1(i); end
       def edarkslategray1(i = ''); puts AllColourMethods.darkslategray1(i); end
       alias ekonsole_colour_darkslategray1 edarkslategray1

  # ======================================================================== 
  # === Colours::AllColourMethods.darkslategray2
  # ======================================================================== 
  def self.darkslategray2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkslategray2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkslategray2(i, &block)
      else
        return ::Colours::BasicColours.darkslategray2(i, &block)
      end
    else
      return i
    end
  end; def darkslategray2(i = '', &block); AllColourMethods.darkslategray2(i, &block); end
       def konsole_colour_darkslategray2(i = ''); AllColourMethods.darkslategray2(i); end
       def konsole_darkslategray2(i = ''); AllColourMethods.darkslategray2(i); end
       self.instance_eval { alias konsole_colour_darkslategray2 darkslategray2 } # === Colours::AllColourMethods.konsole_colour_darkslategray2
       def Colours.edarkslategray2(i = ''); puts AllColourMethods.darkslategray2(i); end
       def edarkslategray2(i = ''); puts AllColourMethods.darkslategray2(i); end
       alias ekonsole_colour_darkslategray2 edarkslategray2

  # ======================================================================== 
  # === Colours::AllColourMethods.darkslategray3
  # ======================================================================== 
  def self.darkslategray3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkslategray3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkslategray3(i, &block)
      else
        return ::Colours::BasicColours.darkslategray3(i, &block)
      end
    else
      return i
    end
  end; def darkslategray3(i = '', &block); AllColourMethods.darkslategray3(i, &block); end
       def konsole_colour_darkslategray3(i = ''); AllColourMethods.darkslategray3(i); end
       def konsole_darkslategray3(i = ''); AllColourMethods.darkslategray3(i); end
       self.instance_eval { alias konsole_colour_darkslategray3 darkslategray3 } # === Colours::AllColourMethods.konsole_colour_darkslategray3
       def Colours.edarkslategray3(i = ''); puts AllColourMethods.darkslategray3(i); end
       def edarkslategray3(i = ''); puts AllColourMethods.darkslategray3(i); end
       alias ekonsole_colour_darkslategray3 edarkslategray3

  # ======================================================================== 
  # === Colours::AllColourMethods.darkslategrey
  # ======================================================================== 
  def self.darkslategrey(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkslategrey(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkslategrey(i, &block)
      else
        return ::Colours::BasicColours.darkslategrey(i, &block)
      end
    else
      return i
    end
  end; def darkslategrey(i = '', &block); AllColourMethods.darkslategrey(i, &block); end
       def konsole_colour_darkslategrey(i = ''); AllColourMethods.darkslategrey(i); end
       def konsole_darkslategrey(i = ''); AllColourMethods.darkslategrey(i); end
       self.instance_eval { alias konsole_colour_darkslategrey darkslategrey } # === Colours::AllColourMethods.konsole_colour_darkslategrey
       def Colours.edarkslategrey(i = ''); puts AllColourMethods.darkslategrey(i); end
       def edarkslategrey(i = ''); puts AllColourMethods.darkslategrey(i); end
       alias ekonsole_colour_darkslategrey edarkslategrey

  # ======================================================================== 
  # === Colours::AllColourMethods.darkturquoise
  # ======================================================================== 
  def self.darkturquoise(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkturquoise(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkturquoise(i, &block)
      else
        return ::Colours::BasicColours.darkturquoise(i, &block)
      end
    else
      return i
    end
  end; def darkturquoise(i = '', &block); AllColourMethods.darkturquoise(i, &block); end
       def konsole_colour_darkturquoise(i = ''); AllColourMethods.darkturquoise(i); end
       def konsole_darkturquoise(i = ''); AllColourMethods.darkturquoise(i); end
       self.instance_eval { alias konsole_colour_darkturquoise darkturquoise } # === Colours::AllColourMethods.konsole_colour_darkturquoise
       def Colours.edarkturquoise(i = ''); puts AllColourMethods.darkturquoise(i); end
       def edarkturquoise(i = ''); puts AllColourMethods.darkturquoise(i); end
       alias ekonsole_colour_darkturquoise edarkturquoise

  # ======================================================================== 
  # === Colours::AllColourMethods.darkviolet
  # ======================================================================== 
  def self.darkviolet(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.darkviolet(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.darkviolet(i, &block)
      else
        return ::Colours::BasicColours.darkviolet(i, &block)
      end
    else
      return i
    end
  end; def darkviolet(i = '', &block); AllColourMethods.darkviolet(i, &block); end
       def konsole_colour_darkviolet(i = ''); AllColourMethods.darkviolet(i); end
       def konsole_darkviolet(i = ''); AllColourMethods.darkviolet(i); end
       self.instance_eval { alias konsole_colour_darkviolet darkviolet } # === Colours::AllColourMethods.konsole_colour_darkviolet
       def Colours.edarkviolet(i = ''); puts AllColourMethods.darkviolet(i); end
       def edarkviolet(i = ''); puts AllColourMethods.darkviolet(i); end
       alias ekonsole_colour_darkviolet edarkviolet

  # ======================================================================== 
  # === Colours::AllColourMethods.deeppink
  # ======================================================================== 
  def self.deeppink(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deeppink(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deeppink(i, &block)
      else
        return ::Colours::BasicColours.deeppink(i, &block)
      end
    else
      return i
    end
  end; def deeppink(i = '', &block); AllColourMethods.deeppink(i, &block); end
       def konsole_colour_deeppink(i = ''); AllColourMethods.deeppink(i); end
       def konsole_deeppink(i = ''); AllColourMethods.deeppink(i); end
       self.instance_eval { alias konsole_colour_deeppink deeppink } # === Colours::AllColourMethods.konsole_colour_deeppink
       def Colours.edeeppink(i = ''); puts AllColourMethods.deeppink(i); end
       def edeeppink(i = ''); puts AllColourMethods.deeppink(i); end
       alias ekonsole_colour_deeppink edeeppink

  # ======================================================================== 
  # === Colours::AllColourMethods.deeppink1
  # ======================================================================== 
  def self.deeppink1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deeppink1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deeppink1(i, &block)
      else
        return ::Colours::BasicColours.deeppink1(i, &block)
      end
    else
      return i
    end
  end; def deeppink1(i = '', &block); AllColourMethods.deeppink1(i, &block); end
       def konsole_colour_deeppink1(i = ''); AllColourMethods.deeppink1(i); end
       def konsole_deeppink1(i = ''); AllColourMethods.deeppink1(i); end
       self.instance_eval { alias konsole_colour_deeppink1 deeppink1 } # === Colours::AllColourMethods.konsole_colour_deeppink1
       def Colours.edeeppink1(i = ''); puts AllColourMethods.deeppink1(i); end
       def edeeppink1(i = ''); puts AllColourMethods.deeppink1(i); end
       alias ekonsole_colour_deeppink1 edeeppink1

  # ======================================================================== 
  # === Colours::AllColourMethods.deeppink2
  # ======================================================================== 
  def self.deeppink2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deeppink2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deeppink2(i, &block)
      else
        return ::Colours::BasicColours.deeppink2(i, &block)
      end
    else
      return i
    end
  end; def deeppink2(i = '', &block); AllColourMethods.deeppink2(i, &block); end
       def konsole_colour_deeppink2(i = ''); AllColourMethods.deeppink2(i); end
       def konsole_deeppink2(i = ''); AllColourMethods.deeppink2(i); end
       self.instance_eval { alias konsole_colour_deeppink2 deeppink2 } # === Colours::AllColourMethods.konsole_colour_deeppink2
       def Colours.edeeppink2(i = ''); puts AllColourMethods.deeppink2(i); end
       def edeeppink2(i = ''); puts AllColourMethods.deeppink2(i); end
       alias ekonsole_colour_deeppink2 edeeppink2

  # ======================================================================== 
  # === Colours::AllColourMethods.deeppink3
  # ======================================================================== 
  def self.deeppink3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deeppink3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deeppink3(i, &block)
      else
        return ::Colours::BasicColours.deeppink3(i, &block)
      end
    else
      return i
    end
  end; def deeppink3(i = '', &block); AllColourMethods.deeppink3(i, &block); end
       def konsole_colour_deeppink3(i = ''); AllColourMethods.deeppink3(i); end
       def konsole_deeppink3(i = ''); AllColourMethods.deeppink3(i); end
       self.instance_eval { alias konsole_colour_deeppink3 deeppink3 } # === Colours::AllColourMethods.konsole_colour_deeppink3
       def Colours.edeeppink3(i = ''); puts AllColourMethods.deeppink3(i); end
       def edeeppink3(i = ''); puts AllColourMethods.deeppink3(i); end
       alias ekonsole_colour_deeppink3 edeeppink3

  # ======================================================================== 
  # === Colours::AllColourMethods.deeppink4
  # ======================================================================== 
  def self.deeppink4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deeppink4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deeppink4(i, &block)
      else
        return ::Colours::BasicColours.deeppink4(i, &block)
      end
    else
      return i
    end
  end; def deeppink4(i = '', &block); AllColourMethods.deeppink4(i, &block); end
       def konsole_colour_deeppink4(i = ''); AllColourMethods.deeppink4(i); end
       def konsole_deeppink4(i = ''); AllColourMethods.deeppink4(i); end
       self.instance_eval { alias konsole_colour_deeppink4 deeppink4 } # === Colours::AllColourMethods.konsole_colour_deeppink4
       def Colours.edeeppink4(i = ''); puts AllColourMethods.deeppink4(i); end
       def edeeppink4(i = ''); puts AllColourMethods.deeppink4(i); end
       alias ekonsole_colour_deeppink4 edeeppink4

  # ======================================================================== 
  # === Colours::AllColourMethods.deepskyblue
  # ======================================================================== 
  def self.deepskyblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deepskyblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deepskyblue(i, &block)
      else
        return ::Colours::BasicColours.deepskyblue(i, &block)
      end
    else
      return i
    end
  end; def deepskyblue(i = '', &block); AllColourMethods.deepskyblue(i, &block); end
       def konsole_colour_deepskyblue(i = ''); AllColourMethods.deepskyblue(i); end
       def konsole_deepskyblue(i = ''); AllColourMethods.deepskyblue(i); end
       self.instance_eval { alias konsole_colour_deepskyblue deepskyblue } # === Colours::AllColourMethods.konsole_colour_deepskyblue
       def Colours.edeepskyblue(i = ''); puts AllColourMethods.deepskyblue(i); end
       def edeepskyblue(i = ''); puts AllColourMethods.deepskyblue(i); end
       alias ekonsole_colour_deepskyblue edeepskyblue

  # ======================================================================== 
  # === Colours::AllColourMethods.deepskyblue1
  # ======================================================================== 
  def self.deepskyblue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deepskyblue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deepskyblue1(i, &block)
      else
        return ::Colours::BasicColours.deepskyblue1(i, &block)
      end
    else
      return i
    end
  end; def deepskyblue1(i = '', &block); AllColourMethods.deepskyblue1(i, &block); end
       def konsole_colour_deepskyblue1(i = ''); AllColourMethods.deepskyblue1(i); end
       def konsole_deepskyblue1(i = ''); AllColourMethods.deepskyblue1(i); end
       self.instance_eval { alias konsole_colour_deepskyblue1 deepskyblue1 } # === Colours::AllColourMethods.konsole_colour_deepskyblue1
       def Colours.edeepskyblue1(i = ''); puts AllColourMethods.deepskyblue1(i); end
       def edeepskyblue1(i = ''); puts AllColourMethods.deepskyblue1(i); end
       alias ekonsole_colour_deepskyblue1 edeepskyblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.deepskyblue2
  # ======================================================================== 
  def self.deepskyblue2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deepskyblue2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deepskyblue2(i, &block)
      else
        return ::Colours::BasicColours.deepskyblue2(i, &block)
      end
    else
      return i
    end
  end; def deepskyblue2(i = '', &block); AllColourMethods.deepskyblue2(i, &block); end
       def konsole_colour_deepskyblue2(i = ''); AllColourMethods.deepskyblue2(i); end
       def konsole_deepskyblue2(i = ''); AllColourMethods.deepskyblue2(i); end
       self.instance_eval { alias konsole_colour_deepskyblue2 deepskyblue2 } # === Colours::AllColourMethods.konsole_colour_deepskyblue2
       def Colours.edeepskyblue2(i = ''); puts AllColourMethods.deepskyblue2(i); end
       def edeepskyblue2(i = ''); puts AllColourMethods.deepskyblue2(i); end
       alias ekonsole_colour_deepskyblue2 edeepskyblue2

  # ======================================================================== 
  # === Colours::AllColourMethods.deepskyblue3
  # ======================================================================== 
  def self.deepskyblue3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deepskyblue3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deepskyblue3(i, &block)
      else
        return ::Colours::BasicColours.deepskyblue3(i, &block)
      end
    else
      return i
    end
  end; def deepskyblue3(i = '', &block); AllColourMethods.deepskyblue3(i, &block); end
       def konsole_colour_deepskyblue3(i = ''); AllColourMethods.deepskyblue3(i); end
       def konsole_deepskyblue3(i = ''); AllColourMethods.deepskyblue3(i); end
       self.instance_eval { alias konsole_colour_deepskyblue3 deepskyblue3 } # === Colours::AllColourMethods.konsole_colour_deepskyblue3
       def Colours.edeepskyblue3(i = ''); puts AllColourMethods.deepskyblue3(i); end
       def edeepskyblue3(i = ''); puts AllColourMethods.deepskyblue3(i); end
       alias ekonsole_colour_deepskyblue3 edeepskyblue3

  # ======================================================================== 
  # === Colours::AllColourMethods.deepskyblue4
  # ======================================================================== 
  def self.deepskyblue4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.deepskyblue4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.deepskyblue4(i, &block)
      else
        return ::Colours::BasicColours.deepskyblue4(i, &block)
      end
    else
      return i
    end
  end; def deepskyblue4(i = '', &block); AllColourMethods.deepskyblue4(i, &block); end
       def konsole_colour_deepskyblue4(i = ''); AllColourMethods.deepskyblue4(i); end
       def konsole_deepskyblue4(i = ''); AllColourMethods.deepskyblue4(i); end
       self.instance_eval { alias konsole_colour_deepskyblue4 deepskyblue4 } # === Colours::AllColourMethods.konsole_colour_deepskyblue4
       def Colours.edeepskyblue4(i = ''); puts AllColourMethods.deepskyblue4(i); end
       def edeepskyblue4(i = ''); puts AllColourMethods.deepskyblue4(i); end
       alias ekonsole_colour_deepskyblue4 edeepskyblue4

  # ======================================================================== 
  # === Colours::AllColourMethods.dimgray
  # ======================================================================== 
  def self.dimgray(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.dimgray(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.dimgray(i, &block)
      else
        return ::Colours::BasicColours.dimgray(i, &block)
      end
    else
      return i
    end
  end; def dimgray(i = '', &block); AllColourMethods.dimgray(i, &block); end
       def konsole_colour_dimgray(i = ''); AllColourMethods.dimgray(i); end
       def konsole_dimgray(i = ''); AllColourMethods.dimgray(i); end
       self.instance_eval { alias konsole_colour_dimgray dimgray } # === Colours::AllColourMethods.konsole_colour_dimgray
       def Colours.edimgray(i = ''); puts AllColourMethods.dimgray(i); end
       def edimgray(i = ''); puts AllColourMethods.dimgray(i); end
       alias ekonsole_colour_dimgray edimgray

  # ======================================================================== 
  # === Colours::AllColourMethods.dimgrey
  # ======================================================================== 
  def self.dimgrey(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.dimgrey(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.dimgrey(i, &block)
      else
        return ::Colours::BasicColours.dimgrey(i, &block)
      end
    else
      return i
    end
  end; def dimgrey(i = '', &block); AllColourMethods.dimgrey(i, &block); end
       def konsole_colour_dimgrey(i = ''); AllColourMethods.dimgrey(i); end
       def konsole_dimgrey(i = ''); AllColourMethods.dimgrey(i); end
       self.instance_eval { alias konsole_colour_dimgrey dimgrey } # === Colours::AllColourMethods.konsole_colour_dimgrey
       def Colours.edimgrey(i = ''); puts AllColourMethods.dimgrey(i); end
       def edimgrey(i = ''); puts AllColourMethods.dimgrey(i); end
       alias ekonsole_colour_dimgrey edimgrey

  # ======================================================================== 
  # === Colours::AllColourMethods.dodgerblue
  # ======================================================================== 
  def self.dodgerblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.dodgerblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.dodgerblue(i, &block)
      else
        return ::Colours::BasicColours.dodgerblue(i, &block)
      end
    else
      return i
    end
  end; def dodgerblue(i = '', &block); AllColourMethods.dodgerblue(i, &block); end
       def konsole_colour_dodgerblue(i = ''); AllColourMethods.dodgerblue(i); end
       def konsole_dodgerblue(i = ''); AllColourMethods.dodgerblue(i); end
       self.instance_eval { alias konsole_colour_dodgerblue dodgerblue } # === Colours::AllColourMethods.konsole_colour_dodgerblue
       def Colours.edodgerblue(i = ''); puts AllColourMethods.dodgerblue(i); end
       def edodgerblue(i = ''); puts AllColourMethods.dodgerblue(i); end
       alias ekonsole_colour_dodgerblue edodgerblue

  # ======================================================================== 
  # === Colours::AllColourMethods.dodgerblue1
  # ======================================================================== 
  def self.dodgerblue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.dodgerblue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.dodgerblue1(i, &block)
      else
        return ::Colours::BasicColours.dodgerblue1(i, &block)
      end
    else
      return i
    end
  end; def dodgerblue1(i = '', &block); AllColourMethods.dodgerblue1(i, &block); end
       def konsole_colour_dodgerblue1(i = ''); AllColourMethods.dodgerblue1(i); end
       def konsole_dodgerblue1(i = ''); AllColourMethods.dodgerblue1(i); end
       self.instance_eval { alias konsole_colour_dodgerblue1 dodgerblue1 } # === Colours::AllColourMethods.konsole_colour_dodgerblue1
       def Colours.edodgerblue1(i = ''); puts AllColourMethods.dodgerblue1(i); end
       def edodgerblue1(i = ''); puts AllColourMethods.dodgerblue1(i); end
       alias ekonsole_colour_dodgerblue1 edodgerblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.dodgerblue2
  # ======================================================================== 
  def self.dodgerblue2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.dodgerblue2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.dodgerblue2(i, &block)
      else
        return ::Colours::BasicColours.dodgerblue2(i, &block)
      end
    else
      return i
    end
  end; def dodgerblue2(i = '', &block); AllColourMethods.dodgerblue2(i, &block); end
       def konsole_colour_dodgerblue2(i = ''); AllColourMethods.dodgerblue2(i); end
       def konsole_dodgerblue2(i = ''); AllColourMethods.dodgerblue2(i); end
       self.instance_eval { alias konsole_colour_dodgerblue2 dodgerblue2 } # === Colours::AllColourMethods.konsole_colour_dodgerblue2
       def Colours.edodgerblue2(i = ''); puts AllColourMethods.dodgerblue2(i); end
       def edodgerblue2(i = ''); puts AllColourMethods.dodgerblue2(i); end
       alias ekonsole_colour_dodgerblue2 edodgerblue2

  # ======================================================================== 
  # === Colours::AllColourMethods.dodgerblue3
  # ======================================================================== 
  def self.dodgerblue3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.dodgerblue3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.dodgerblue3(i, &block)
      else
        return ::Colours::BasicColours.dodgerblue3(i, &block)
      end
    else
      return i
    end
  end; def dodgerblue3(i = '', &block); AllColourMethods.dodgerblue3(i, &block); end
       def konsole_colour_dodgerblue3(i = ''); AllColourMethods.dodgerblue3(i); end
       def konsole_dodgerblue3(i = ''); AllColourMethods.dodgerblue3(i); end
       self.instance_eval { alias konsole_colour_dodgerblue3 dodgerblue3 } # === Colours::AllColourMethods.konsole_colour_dodgerblue3
       def Colours.edodgerblue3(i = ''); puts AllColourMethods.dodgerblue3(i); end
       def edodgerblue3(i = ''); puts AllColourMethods.dodgerblue3(i); end
       alias ekonsole_colour_dodgerblue3 edodgerblue3

  # ======================================================================== 
  # === Colours::AllColourMethods.firebrick
  # ======================================================================== 
  def self.firebrick(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.firebrick(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.firebrick(i, &block)
      else
        return ::Colours::BasicColours.firebrick(i, &block)
      end
    else
      return i
    end
  end; def firebrick(i = '', &block); AllColourMethods.firebrick(i, &block); end
       def konsole_colour_firebrick(i = ''); AllColourMethods.firebrick(i); end
       def konsole_firebrick(i = ''); AllColourMethods.firebrick(i); end
       self.instance_eval { alias konsole_colour_firebrick firebrick } # === Colours::AllColourMethods.konsole_colour_firebrick
       def Colours.efirebrick(i = ''); puts AllColourMethods.firebrick(i); end
       def efirebrick(i = ''); puts AllColourMethods.firebrick(i); end
       alias ekonsole_colour_firebrick efirebrick

  # ======================================================================== 
  # === Colours::AllColourMethods.floralwhite
  # ======================================================================== 
  def self.floralwhite(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.floralwhite(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.floralwhite(i, &block)
      else
        return ::Colours::BasicColours.floralwhite(i, &block)
      end
    else
      return i
    end
  end; def floralwhite(i = '', &block); AllColourMethods.floralwhite(i, &block); end
       def konsole_colour_floralwhite(i = ''); AllColourMethods.floralwhite(i); end
       def konsole_floralwhite(i = ''); AllColourMethods.floralwhite(i); end
       self.instance_eval { alias konsole_colour_floralwhite floralwhite } # === Colours::AllColourMethods.konsole_colour_floralwhite
       def Colours.efloralwhite(i = ''); puts AllColourMethods.floralwhite(i); end
       def efloralwhite(i = ''); puts AllColourMethods.floralwhite(i); end
       alias ekonsole_colour_floralwhite efloralwhite

  # ======================================================================== 
  # === Colours::AllColourMethods.forestgreen
  # ======================================================================== 
  def self.forestgreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.forestgreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.forestgreen(i, &block)
      else
        return ::Colours::BasicColours.forestgreen(i, &block)
      end
    else
      return i
    end
  end; def forestgreen(i = '', &block); AllColourMethods.forestgreen(i, &block); end
       def konsole_colour_forestgreen(i = ''); AllColourMethods.forestgreen(i); end
       def konsole_forestgreen(i = ''); AllColourMethods.forestgreen(i); end
       self.instance_eval { alias konsole_colour_forestgreen forestgreen } # === Colours::AllColourMethods.konsole_colour_forestgreen
       def Colours.eforestgreen(i = ''); puts AllColourMethods.forestgreen(i); end
       def eforestgreen(i = ''); puts AllColourMethods.forestgreen(i); end
       alias ekonsole_colour_forestgreen eforestgreen

  # ======================================================================== 
  # === Colours::AllColourMethods.fuchsia
  # ======================================================================== 
  def self.fuchsia(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.fuchsia(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.fuchsia(i, &block)
      else
        return ::Colours::BasicColours.fuchsia(i, &block)
      end
    else
      return i
    end
  end; def fuchsia(i = '', &block); AllColourMethods.fuchsia(i, &block); end
       def konsole_colour_fuchsia(i = ''); AllColourMethods.fuchsia(i); end
       def konsole_fuchsia(i = ''); AllColourMethods.fuchsia(i); end
       self.instance_eval { alias konsole_colour_fuchsia fuchsia } # === Colours::AllColourMethods.konsole_colour_fuchsia
       def Colours.efuchsia(i = ''); puts AllColourMethods.fuchsia(i); end
       def efuchsia(i = ''); puts AllColourMethods.fuchsia(i); end
       alias ekonsole_colour_fuchsia efuchsia

  # ======================================================================== 
  # === Colours::AllColourMethods.gainsboro
  # ======================================================================== 
  def self.gainsboro(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.gainsboro(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.gainsboro(i, &block)
      else
        return ::Colours::BasicColours.gainsboro(i, &block)
      end
    else
      return i
    end
  end; def gainsboro(i = '', &block); AllColourMethods.gainsboro(i, &block); end
       def konsole_colour_gainsboro(i = ''); AllColourMethods.gainsboro(i); end
       def konsole_gainsboro(i = ''); AllColourMethods.gainsboro(i); end
       self.instance_eval { alias konsole_colour_gainsboro gainsboro } # === Colours::AllColourMethods.konsole_colour_gainsboro
       def Colours.egainsboro(i = ''); puts AllColourMethods.gainsboro(i); end
       def egainsboro(i = ''); puts AllColourMethods.gainsboro(i); end
       alias ekonsole_colour_gainsboro egainsboro

  # ======================================================================== 
  # === Colours::AllColourMethods.ghostwhite
  # ======================================================================== 
  def self.ghostwhite(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.ghostwhite(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.ghostwhite(i, &block)
      else
        return ::Colours::BasicColours.ghostwhite(i, &block)
      end
    else
      return i
    end
  end; def ghostwhite(i = '', &block); AllColourMethods.ghostwhite(i, &block); end
       def konsole_colour_ghostwhite(i = ''); AllColourMethods.ghostwhite(i); end
       def konsole_ghostwhite(i = ''); AllColourMethods.ghostwhite(i); end
       self.instance_eval { alias konsole_colour_ghostwhite ghostwhite } # === Colours::AllColourMethods.konsole_colour_ghostwhite
       def Colours.eghostwhite(i = ''); puts AllColourMethods.ghostwhite(i); end
       def eghostwhite(i = ''); puts AllColourMethods.ghostwhite(i); end
       alias ekonsole_colour_ghostwhite eghostwhite

  # ======================================================================== 
  # === Colours::AllColourMethods.gold
  # ======================================================================== 
  def self.gold(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.gold(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.gold(i, &block)
      else
        return ::Colours::BasicColours.gold(i, &block)
      end
    else
      return i
    end
  end; def gold(i = '', &block); AllColourMethods.gold(i, &block); end
       def konsole_colour_gold(i = ''); AllColourMethods.gold(i); end
       def konsole_gold(i = ''); AllColourMethods.gold(i); end
       self.instance_eval { alias konsole_colour_gold gold } # === Colours::AllColourMethods.konsole_colour_gold
       def Colours.egold(i = ''); puts AllColourMethods.gold(i); end
       def egold(i = ''); puts AllColourMethods.gold(i); end
       alias ekonsole_colour_gold egold

  # ======================================================================== 
  # === Colours::AllColourMethods.gold1
  # ======================================================================== 
  def self.gold1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.gold1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.gold1(i, &block)
      else
        return ::Colours::BasicColours.gold1(i, &block)
      end
    else
      return i
    end
  end; def gold1(i = '', &block); AllColourMethods.gold1(i, &block); end
       def konsole_colour_gold1(i = ''); AllColourMethods.gold1(i); end
       def konsole_gold1(i = ''); AllColourMethods.gold1(i); end
       self.instance_eval { alias konsole_colour_gold1 gold1 } # === Colours::AllColourMethods.konsole_colour_gold1
       def Colours.egold1(i = ''); puts AllColourMethods.gold1(i); end
       def egold1(i = ''); puts AllColourMethods.gold1(i); end
       alias ekonsole_colour_gold1 egold1

  # ======================================================================== 
  # === Colours::AllColourMethods.gold3
  # ======================================================================== 
  def self.gold3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.gold3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.gold3(i, &block)
      else
        return ::Colours::BasicColours.gold3(i, &block)
      end
    else
      return i
    end
  end; def gold3(i = '', &block); AllColourMethods.gold3(i, &block); end
       def konsole_colour_gold3(i = ''); AllColourMethods.gold3(i); end
       def konsole_gold3(i = ''); AllColourMethods.gold3(i); end
       self.instance_eval { alias konsole_colour_gold3 gold3 } # === Colours::AllColourMethods.konsole_colour_gold3
       def Colours.egold3(i = ''); puts AllColourMethods.gold3(i); end
       def egold3(i = ''); puts AllColourMethods.gold3(i); end
       alias ekonsole_colour_gold3 egold3

  # ======================================================================== 
  # === Colours::AllColourMethods.goldenrod
  # ======================================================================== 
  def self.goldenrod(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.goldenrod(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.goldenrod(i, &block)
      else
        return ::Colours::BasicColours.goldenrod(i, &block)
      end
    else
      return i
    end
  end; def goldenrod(i = '', &block); AllColourMethods.goldenrod(i, &block); end
       def konsole_colour_goldenrod(i = ''); AllColourMethods.goldenrod(i); end
       def konsole_goldenrod(i = ''); AllColourMethods.goldenrod(i); end
       self.instance_eval { alias konsole_colour_goldenrod goldenrod } # === Colours::AllColourMethods.konsole_colour_goldenrod
       def Colours.egoldenrod(i = ''); puts AllColourMethods.goldenrod(i); end
       def egoldenrod(i = ''); puts AllColourMethods.goldenrod(i); end
       alias ekonsole_colour_goldenrod egoldenrod

  # ======================================================================== 
  # === Colours::AllColourMethods.gray
  # ======================================================================== 
  def self.gray(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.gray(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.gray(i, &block)
      else
        return ::Colours::BasicColours.gray(i, &block)
      end
    else
      return i
    end
  end; def gray(i = '', &block); AllColourMethods.gray(i, &block); end
       def konsole_colour_gray(i = ''); AllColourMethods.gray(i); end
       def konsole_gray(i = ''); AllColourMethods.gray(i); end
       self.instance_eval { alias konsole_colour_gray gray } # === Colours::AllColourMethods.konsole_colour_gray
       def Colours.egray(i = ''); puts AllColourMethods.gray(i); end
       def egray(i = ''); puts AllColourMethods.gray(i); end
       alias ekonsole_colour_gray egray

  # ======================================================================== 
  # === Colours::AllColourMethods.green
  # ======================================================================== 
  def self.green(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.green(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.green(i, &block)
      else
        return ::Colours::BasicColours.green(i, &block)
      end
    else
      return i
    end
  end; def green(i = '', &block); AllColourMethods.green(i, &block); end
       def konsole_colour_green(i = ''); AllColourMethods.green(i); end
       def konsole_green(i = ''); AllColourMethods.green(i); end
       self.instance_eval { alias konsole_colour_green green } # === Colours::AllColourMethods.konsole_colour_green
       def Colours.egreen(i = ''); puts AllColourMethods.green(i); end
       def egreen(i = ''); puts AllColourMethods.green(i); end
       alias ekonsole_colour_green egreen

  # ======================================================================== 
  # === Colours::AllColourMethods.green1
  # ======================================================================== 
  def self.green1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.green1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.green1(i, &block)
      else
        return ::Colours::BasicColours.green1(i, &block)
      end
    else
      return i
    end
  end; def green1(i = '', &block); AllColourMethods.green1(i, &block); end
       def konsole_colour_green1(i = ''); AllColourMethods.green1(i); end
       def konsole_green1(i = ''); AllColourMethods.green1(i); end
       self.instance_eval { alias konsole_colour_green1 green1 } # === Colours::AllColourMethods.konsole_colour_green1
       def Colours.egreen1(i = ''); puts AllColourMethods.green1(i); end
       def egreen1(i = ''); puts AllColourMethods.green1(i); end
       alias ekonsole_colour_green1 egreen1

  # ======================================================================== 
  # === Colours::AllColourMethods.green3
  # ======================================================================== 
  def self.green3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.green3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.green3(i, &block)
      else
        return ::Colours::BasicColours.green3(i, &block)
      end
    else
      return i
    end
  end; def green3(i = '', &block); AllColourMethods.green3(i, &block); end
       def konsole_colour_green3(i = ''); AllColourMethods.green3(i); end
       def konsole_green3(i = ''); AllColourMethods.green3(i); end
       self.instance_eval { alias konsole_colour_green3 green3 } # === Colours::AllColourMethods.konsole_colour_green3
       def Colours.egreen3(i = ''); puts AllColourMethods.green3(i); end
       def egreen3(i = ''); puts AllColourMethods.green3(i); end
       alias ekonsole_colour_green3 egreen3

  # ======================================================================== 
  # === Colours::AllColourMethods.green4
  # ======================================================================== 
  def self.green4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.green4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.green4(i, &block)
      else
        return ::Colours::BasicColours.green4(i, &block)
      end
    else
      return i
    end
  end; def green4(i = '', &block); AllColourMethods.green4(i, &block); end
       def konsole_colour_green4(i = ''); AllColourMethods.green4(i); end
       def konsole_green4(i = ''); AllColourMethods.green4(i); end
       self.instance_eval { alias konsole_colour_green4 green4 } # === Colours::AllColourMethods.konsole_colour_green4
       def Colours.egreen4(i = ''); puts AllColourMethods.green4(i); end
       def egreen4(i = ''); puts AllColourMethods.green4(i); end
       alias ekonsole_colour_green4 egreen4

  # ======================================================================== 
  # === Colours::AllColourMethods.greenyellow
  # ======================================================================== 
  def self.greenyellow(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.greenyellow(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.greenyellow(i, &block)
      else
        return ::Colours::BasicColours.greenyellow(i, &block)
      end
    else
      return i
    end
  end; def greenyellow(i = '', &block); AllColourMethods.greenyellow(i, &block); end
       def konsole_colour_greenyellow(i = ''); AllColourMethods.greenyellow(i); end
       def konsole_greenyellow(i = ''); AllColourMethods.greenyellow(i); end
       self.instance_eval { alias konsole_colour_greenyellow greenyellow } # === Colours::AllColourMethods.konsole_colour_greenyellow
       def Colours.egreenyellow(i = ''); puts AllColourMethods.greenyellow(i); end
       def egreenyellow(i = ''); puts AllColourMethods.greenyellow(i); end
       alias ekonsole_colour_greenyellow egreenyellow

  # ======================================================================== 
  # === Colours::AllColourMethods.grey
  # ======================================================================== 
  def self.grey(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey(i, &block)
      else
        return ::Colours::BasicColours.grey(i, &block)
      end
    else
      return i
    end
  end; def grey(i = '', &block); AllColourMethods.grey(i, &block); end
       def konsole_colour_grey(i = ''); AllColourMethods.grey(i); end
       def konsole_grey(i = ''); AllColourMethods.grey(i); end
       self.instance_eval { alias konsole_colour_grey grey } # === Colours::AllColourMethods.konsole_colour_grey
       def Colours.egrey(i = ''); puts AllColourMethods.grey(i); end
       def egrey(i = ''); puts AllColourMethods.grey(i); end
       alias ekonsole_colour_grey egrey

  # ======================================================================== 
  # === Colours::AllColourMethods.grey0
  # ======================================================================== 
  def self.grey0(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey0(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey0(i, &block)
      else
        return ::Colours::BasicColours.grey0(i, &block)
      end
    else
      return i
    end
  end; def grey0(i = '', &block); AllColourMethods.grey0(i, &block); end
       def konsole_colour_grey0(i = ''); AllColourMethods.grey0(i); end
       def konsole_grey0(i = ''); AllColourMethods.grey0(i); end
       self.instance_eval { alias konsole_colour_grey0 grey0 } # === Colours::AllColourMethods.konsole_colour_grey0
       def Colours.egrey0(i = ''); puts AllColourMethods.grey0(i); end
       def egrey0(i = ''); puts AllColourMethods.grey0(i); end
       alias ekonsole_colour_grey0 egrey0

  # ======================================================================== 
  # === Colours::AllColourMethods.grey100
  # ======================================================================== 
  def self.grey100(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey100(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey100(i, &block)
      else
        return ::Colours::BasicColours.grey100(i, &block)
      end
    else
      return i
    end
  end; def grey100(i = '', &block); AllColourMethods.grey100(i, &block); end
       def konsole_colour_grey100(i = ''); AllColourMethods.grey100(i); end
       def konsole_grey100(i = ''); AllColourMethods.grey100(i); end
       self.instance_eval { alias konsole_colour_grey100 grey100 } # === Colours::AllColourMethods.konsole_colour_grey100
       def Colours.egrey100(i = ''); puts AllColourMethods.grey100(i); end
       def egrey100(i = ''); puts AllColourMethods.grey100(i); end
       alias ekonsole_colour_grey100 egrey100

  # ======================================================================== 
  # === Colours::AllColourMethods.grey11
  # ======================================================================== 
  def self.grey11(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey11(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey11(i, &block)
      else
        return ::Colours::BasicColours.grey11(i, &block)
      end
    else
      return i
    end
  end; def grey11(i = '', &block); AllColourMethods.grey11(i, &block); end
       def konsole_colour_grey11(i = ''); AllColourMethods.grey11(i); end
       def konsole_grey11(i = ''); AllColourMethods.grey11(i); end
       self.instance_eval { alias konsole_colour_grey11 grey11 } # === Colours::AllColourMethods.konsole_colour_grey11
       def Colours.egrey11(i = ''); puts AllColourMethods.grey11(i); end
       def egrey11(i = ''); puts AllColourMethods.grey11(i); end
       alias ekonsole_colour_grey11 egrey11

  # ======================================================================== 
  # === Colours::AllColourMethods.grey15
  # ======================================================================== 
  def self.grey15(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey15(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey15(i, &block)
      else
        return ::Colours::BasicColours.grey15(i, &block)
      end
    else
      return i
    end
  end; def grey15(i = '', &block); AllColourMethods.grey15(i, &block); end
       def konsole_colour_grey15(i = ''); AllColourMethods.grey15(i); end
       def konsole_grey15(i = ''); AllColourMethods.grey15(i); end
       self.instance_eval { alias konsole_colour_grey15 grey15 } # === Colours::AllColourMethods.konsole_colour_grey15
       def Colours.egrey15(i = ''); puts AllColourMethods.grey15(i); end
       def egrey15(i = ''); puts AllColourMethods.grey15(i); end
       alias ekonsole_colour_grey15 egrey15

  # ======================================================================== 
  # === Colours::AllColourMethods.grey19
  # ======================================================================== 
  def self.grey19(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey19(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey19(i, &block)
      else
        return ::Colours::BasicColours.grey19(i, &block)
      end
    else
      return i
    end
  end; def grey19(i = '', &block); AllColourMethods.grey19(i, &block); end
       def konsole_colour_grey19(i = ''); AllColourMethods.grey19(i); end
       def konsole_grey19(i = ''); AllColourMethods.grey19(i); end
       self.instance_eval { alias konsole_colour_grey19 grey19 } # === Colours::AllColourMethods.konsole_colour_grey19
       def Colours.egrey19(i = ''); puts AllColourMethods.grey19(i); end
       def egrey19(i = ''); puts AllColourMethods.grey19(i); end
       alias ekonsole_colour_grey19 egrey19

  # ======================================================================== 
  # === Colours::AllColourMethods.grey23
  # ======================================================================== 
  def self.grey23(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey23(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey23(i, &block)
      else
        return ::Colours::BasicColours.grey23(i, &block)
      end
    else
      return i
    end
  end; def grey23(i = '', &block); AllColourMethods.grey23(i, &block); end
       def konsole_colour_grey23(i = ''); AllColourMethods.grey23(i); end
       def konsole_grey23(i = ''); AllColourMethods.grey23(i); end
       self.instance_eval { alias konsole_colour_grey23 grey23 } # === Colours::AllColourMethods.konsole_colour_grey23
       def Colours.egrey23(i = ''); puts AllColourMethods.grey23(i); end
       def egrey23(i = ''); puts AllColourMethods.grey23(i); end
       alias ekonsole_colour_grey23 egrey23

  # ======================================================================== 
  # === Colours::AllColourMethods.grey27
  # ======================================================================== 
  def self.grey27(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey27(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey27(i, &block)
      else
        return ::Colours::BasicColours.grey27(i, &block)
      end
    else
      return i
    end
  end; def grey27(i = '', &block); AllColourMethods.grey27(i, &block); end
       def konsole_colour_grey27(i = ''); AllColourMethods.grey27(i); end
       def konsole_grey27(i = ''); AllColourMethods.grey27(i); end
       self.instance_eval { alias konsole_colour_grey27 grey27 } # === Colours::AllColourMethods.konsole_colour_grey27
       def Colours.egrey27(i = ''); puts AllColourMethods.grey27(i); end
       def egrey27(i = ''); puts AllColourMethods.grey27(i); end
       alias ekonsole_colour_grey27 egrey27

  # ======================================================================== 
  # === Colours::AllColourMethods.grey3
  # ======================================================================== 
  def self.grey3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey3(i, &block)
      else
        return ::Colours::BasicColours.grey3(i, &block)
      end
    else
      return i
    end
  end; def grey3(i = '', &block); AllColourMethods.grey3(i, &block); end
       def konsole_colour_grey3(i = ''); AllColourMethods.grey3(i); end
       def konsole_grey3(i = ''); AllColourMethods.grey3(i); end
       self.instance_eval { alias konsole_colour_grey3 grey3 } # === Colours::AllColourMethods.konsole_colour_grey3
       def Colours.egrey3(i = ''); puts AllColourMethods.grey3(i); end
       def egrey3(i = ''); puts AllColourMethods.grey3(i); end
       alias ekonsole_colour_grey3 egrey3

  # ======================================================================== 
  # === Colours::AllColourMethods.grey30
  # ======================================================================== 
  def self.grey30(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey30(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey30(i, &block)
      else
        return ::Colours::BasicColours.grey30(i, &block)
      end
    else
      return i
    end
  end; def grey30(i = '', &block); AllColourMethods.grey30(i, &block); end
       def konsole_colour_grey30(i = ''); AllColourMethods.grey30(i); end
       def konsole_grey30(i = ''); AllColourMethods.grey30(i); end
       self.instance_eval { alias konsole_colour_grey30 grey30 } # === Colours::AllColourMethods.konsole_colour_grey30
       def Colours.egrey30(i = ''); puts AllColourMethods.grey30(i); end
       def egrey30(i = ''); puts AllColourMethods.grey30(i); end
       alias ekonsole_colour_grey30 egrey30

  # ======================================================================== 
  # === Colours::AllColourMethods.grey35
  # ======================================================================== 
  def self.grey35(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey35(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey35(i, &block)
      else
        return ::Colours::BasicColours.grey35(i, &block)
      end
    else
      return i
    end
  end; def grey35(i = '', &block); AllColourMethods.grey35(i, &block); end
       def konsole_colour_grey35(i = ''); AllColourMethods.grey35(i); end
       def konsole_grey35(i = ''); AllColourMethods.grey35(i); end
       self.instance_eval { alias konsole_colour_grey35 grey35 } # === Colours::AllColourMethods.konsole_colour_grey35
       def Colours.egrey35(i = ''); puts AllColourMethods.grey35(i); end
       def egrey35(i = ''); puts AllColourMethods.grey35(i); end
       alias ekonsole_colour_grey35 egrey35

  # ======================================================================== 
  # === Colours::AllColourMethods.grey37
  # ======================================================================== 
  def self.grey37(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey37(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey37(i, &block)
      else
        return ::Colours::BasicColours.grey37(i, &block)
      end
    else
      return i
    end
  end; def grey37(i = '', &block); AllColourMethods.grey37(i, &block); end
       def konsole_colour_grey37(i = ''); AllColourMethods.grey37(i); end
       def konsole_grey37(i = ''); AllColourMethods.grey37(i); end
       self.instance_eval { alias konsole_colour_grey37 grey37 } # === Colours::AllColourMethods.konsole_colour_grey37
       def Colours.egrey37(i = ''); puts AllColourMethods.grey37(i); end
       def egrey37(i = ''); puts AllColourMethods.grey37(i); end
       alias ekonsole_colour_grey37 egrey37

  # ======================================================================== 
  # === Colours::AllColourMethods.grey39
  # ======================================================================== 
  def self.grey39(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey39(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey39(i, &block)
      else
        return ::Colours::BasicColours.grey39(i, &block)
      end
    else
      return i
    end
  end; def grey39(i = '', &block); AllColourMethods.grey39(i, &block); end
       def konsole_colour_grey39(i = ''); AllColourMethods.grey39(i); end
       def konsole_grey39(i = ''); AllColourMethods.grey39(i); end
       self.instance_eval { alias konsole_colour_grey39 grey39 } # === Colours::AllColourMethods.konsole_colour_grey39
       def Colours.egrey39(i = ''); puts AllColourMethods.grey39(i); end
       def egrey39(i = ''); puts AllColourMethods.grey39(i); end
       alias ekonsole_colour_grey39 egrey39

  # ======================================================================== 
  # === Colours::AllColourMethods.grey42
  # ======================================================================== 
  def self.grey42(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey42(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey42(i, &block)
      else
        return ::Colours::BasicColours.grey42(i, &block)
      end
    else
      return i
    end
  end; def grey42(i = '', &block); AllColourMethods.grey42(i, &block); end
       def konsole_colour_grey42(i = ''); AllColourMethods.grey42(i); end
       def konsole_grey42(i = ''); AllColourMethods.grey42(i); end
       self.instance_eval { alias konsole_colour_grey42 grey42 } # === Colours::AllColourMethods.konsole_colour_grey42
       def Colours.egrey42(i = ''); puts AllColourMethods.grey42(i); end
       def egrey42(i = ''); puts AllColourMethods.grey42(i); end
       alias ekonsole_colour_grey42 egrey42

  # ======================================================================== 
  # === Colours::AllColourMethods.grey46
  # ======================================================================== 
  def self.grey46(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey46(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey46(i, &block)
      else
        return ::Colours::BasicColours.grey46(i, &block)
      end
    else
      return i
    end
  end; def grey46(i = '', &block); AllColourMethods.grey46(i, &block); end
       def konsole_colour_grey46(i = ''); AllColourMethods.grey46(i); end
       def konsole_grey46(i = ''); AllColourMethods.grey46(i); end
       self.instance_eval { alias konsole_colour_grey46 grey46 } # === Colours::AllColourMethods.konsole_colour_grey46
       def Colours.egrey46(i = ''); puts AllColourMethods.grey46(i); end
       def egrey46(i = ''); puts AllColourMethods.grey46(i); end
       alias ekonsole_colour_grey46 egrey46

  # ======================================================================== 
  # === Colours::AllColourMethods.grey50
  # ======================================================================== 
  def self.grey50(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey50(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey50(i, &block)
      else
        return ::Colours::BasicColours.grey50(i, &block)
      end
    else
      return i
    end
  end; def grey50(i = '', &block); AllColourMethods.grey50(i, &block); end
       def konsole_colour_grey50(i = ''); AllColourMethods.grey50(i); end
       def konsole_grey50(i = ''); AllColourMethods.grey50(i); end
       self.instance_eval { alias konsole_colour_grey50 grey50 } # === Colours::AllColourMethods.konsole_colour_grey50
       def Colours.egrey50(i = ''); puts AllColourMethods.grey50(i); end
       def egrey50(i = ''); puts AllColourMethods.grey50(i); end
       alias ekonsole_colour_grey50 egrey50

  # ======================================================================== 
  # === Colours::AllColourMethods.grey53
  # ======================================================================== 
  def self.grey53(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey53(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey53(i, &block)
      else
        return ::Colours::BasicColours.grey53(i, &block)
      end
    else
      return i
    end
  end; def grey53(i = '', &block); AllColourMethods.grey53(i, &block); end
       def konsole_colour_grey53(i = ''); AllColourMethods.grey53(i); end
       def konsole_grey53(i = ''); AllColourMethods.grey53(i); end
       self.instance_eval { alias konsole_colour_grey53 grey53 } # === Colours::AllColourMethods.konsole_colour_grey53
       def Colours.egrey53(i = ''); puts AllColourMethods.grey53(i); end
       def egrey53(i = ''); puts AllColourMethods.grey53(i); end
       alias ekonsole_colour_grey53 egrey53

  # ======================================================================== 
  # === Colours::AllColourMethods.grey54
  # ======================================================================== 
  def self.grey54(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey54(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey54(i, &block)
      else
        return ::Colours::BasicColours.grey54(i, &block)
      end
    else
      return i
    end
  end; def grey54(i = '', &block); AllColourMethods.grey54(i, &block); end
       def konsole_colour_grey54(i = ''); AllColourMethods.grey54(i); end
       def konsole_grey54(i = ''); AllColourMethods.grey54(i); end
       self.instance_eval { alias konsole_colour_grey54 grey54 } # === Colours::AllColourMethods.konsole_colour_grey54
       def Colours.egrey54(i = ''); puts AllColourMethods.grey54(i); end
       def egrey54(i = ''); puts AllColourMethods.grey54(i); end
       alias ekonsole_colour_grey54 egrey54

  # ======================================================================== 
  # === Colours::AllColourMethods.grey58
  # ======================================================================== 
  def self.grey58(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey58(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey58(i, &block)
      else
        return ::Colours::BasicColours.grey58(i, &block)
      end
    else
      return i
    end
  end; def grey58(i = '', &block); AllColourMethods.grey58(i, &block); end
       def konsole_colour_grey58(i = ''); AllColourMethods.grey58(i); end
       def konsole_grey58(i = ''); AllColourMethods.grey58(i); end
       self.instance_eval { alias konsole_colour_grey58 grey58 } # === Colours::AllColourMethods.konsole_colour_grey58
       def Colours.egrey58(i = ''); puts AllColourMethods.grey58(i); end
       def egrey58(i = ''); puts AllColourMethods.grey58(i); end
       alias ekonsole_colour_grey58 egrey58

  # ======================================================================== 
  # === Colours::AllColourMethods.grey62
  # ======================================================================== 
  def self.grey62(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey62(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey62(i, &block)
      else
        return ::Colours::BasicColours.grey62(i, &block)
      end
    else
      return i
    end
  end; def grey62(i = '', &block); AllColourMethods.grey62(i, &block); end
       def konsole_colour_grey62(i = ''); AllColourMethods.grey62(i); end
       def konsole_grey62(i = ''); AllColourMethods.grey62(i); end
       self.instance_eval { alias konsole_colour_grey62 grey62 } # === Colours::AllColourMethods.konsole_colour_grey62
       def Colours.egrey62(i = ''); puts AllColourMethods.grey62(i); end
       def egrey62(i = ''); puts AllColourMethods.grey62(i); end
       alias ekonsole_colour_grey62 egrey62

  # ======================================================================== 
  # === Colours::AllColourMethods.grey63
  # ======================================================================== 
  def self.grey63(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey63(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey63(i, &block)
      else
        return ::Colours::BasicColours.grey63(i, &block)
      end
    else
      return i
    end
  end; def grey63(i = '', &block); AllColourMethods.grey63(i, &block); end
       def konsole_colour_grey63(i = ''); AllColourMethods.grey63(i); end
       def konsole_grey63(i = ''); AllColourMethods.grey63(i); end
       self.instance_eval { alias konsole_colour_grey63 grey63 } # === Colours::AllColourMethods.konsole_colour_grey63
       def Colours.egrey63(i = ''); puts AllColourMethods.grey63(i); end
       def egrey63(i = ''); puts AllColourMethods.grey63(i); end
       alias ekonsole_colour_grey63 egrey63

  # ======================================================================== 
  # === Colours::AllColourMethods.grey66
  # ======================================================================== 
  def self.grey66(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey66(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey66(i, &block)
      else
        return ::Colours::BasicColours.grey66(i, &block)
      end
    else
      return i
    end
  end; def grey66(i = '', &block); AllColourMethods.grey66(i, &block); end
       def konsole_colour_grey66(i = ''); AllColourMethods.grey66(i); end
       def konsole_grey66(i = ''); AllColourMethods.grey66(i); end
       self.instance_eval { alias konsole_colour_grey66 grey66 } # === Colours::AllColourMethods.konsole_colour_grey66
       def Colours.egrey66(i = ''); puts AllColourMethods.grey66(i); end
       def egrey66(i = ''); puts AllColourMethods.grey66(i); end
       alias ekonsole_colour_grey66 egrey66

  # ======================================================================== 
  # === Colours::AllColourMethods.grey69
  # ======================================================================== 
  def self.grey69(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey69(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey69(i, &block)
      else
        return ::Colours::BasicColours.grey69(i, &block)
      end
    else
      return i
    end
  end; def grey69(i = '', &block); AllColourMethods.grey69(i, &block); end
       def konsole_colour_grey69(i = ''); AllColourMethods.grey69(i); end
       def konsole_grey69(i = ''); AllColourMethods.grey69(i); end
       self.instance_eval { alias konsole_colour_grey69 grey69 } # === Colours::AllColourMethods.konsole_colour_grey69
       def Colours.egrey69(i = ''); puts AllColourMethods.grey69(i); end
       def egrey69(i = ''); puts AllColourMethods.grey69(i); end
       alias ekonsole_colour_grey69 egrey69

  # ======================================================================== 
  # === Colours::AllColourMethods.grey7
  # ======================================================================== 
  def self.grey7(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey7(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey7(i, &block)
      else
        return ::Colours::BasicColours.grey7(i, &block)
      end
    else
      return i
    end
  end; def grey7(i = '', &block); AllColourMethods.grey7(i, &block); end
       def konsole_colour_grey7(i = ''); AllColourMethods.grey7(i); end
       def konsole_grey7(i = ''); AllColourMethods.grey7(i); end
       self.instance_eval { alias konsole_colour_grey7 grey7 } # === Colours::AllColourMethods.konsole_colour_grey7
       def Colours.egrey7(i = ''); puts AllColourMethods.grey7(i); end
       def egrey7(i = ''); puts AllColourMethods.grey7(i); end
       alias ekonsole_colour_grey7 egrey7

  # ======================================================================== 
  # === Colours::AllColourMethods.grey70
  # ======================================================================== 
  def self.grey70(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey70(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey70(i, &block)
      else
        return ::Colours::BasicColours.grey70(i, &block)
      end
    else
      return i
    end
  end; def grey70(i = '', &block); AllColourMethods.grey70(i, &block); end
       def konsole_colour_grey70(i = ''); AllColourMethods.grey70(i); end
       def konsole_grey70(i = ''); AllColourMethods.grey70(i); end
       self.instance_eval { alias konsole_colour_grey70 grey70 } # === Colours::AllColourMethods.konsole_colour_grey70
       def Colours.egrey70(i = ''); puts AllColourMethods.grey70(i); end
       def egrey70(i = ''); puts AllColourMethods.grey70(i); end
       alias ekonsole_colour_grey70 egrey70

  # ======================================================================== 
  # === Colours::AllColourMethods.grey74
  # ======================================================================== 
  def self.grey74(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey74(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey74(i, &block)
      else
        return ::Colours::BasicColours.grey74(i, &block)
      end
    else
      return i
    end
  end; def grey74(i = '', &block); AllColourMethods.grey74(i, &block); end
       def konsole_colour_grey74(i = ''); AllColourMethods.grey74(i); end
       def konsole_grey74(i = ''); AllColourMethods.grey74(i); end
       self.instance_eval { alias konsole_colour_grey74 grey74 } # === Colours::AllColourMethods.konsole_colour_grey74
       def Colours.egrey74(i = ''); puts AllColourMethods.grey74(i); end
       def egrey74(i = ''); puts AllColourMethods.grey74(i); end
       alias ekonsole_colour_grey74 egrey74

  # ======================================================================== 
  # === Colours::AllColourMethods.grey78
  # ======================================================================== 
  def self.grey78(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey78(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey78(i, &block)
      else
        return ::Colours::BasicColours.grey78(i, &block)
      end
    else
      return i
    end
  end; def grey78(i = '', &block); AllColourMethods.grey78(i, &block); end
       def konsole_colour_grey78(i = ''); AllColourMethods.grey78(i); end
       def konsole_grey78(i = ''); AllColourMethods.grey78(i); end
       self.instance_eval { alias konsole_colour_grey78 grey78 } # === Colours::AllColourMethods.konsole_colour_grey78
       def Colours.egrey78(i = ''); puts AllColourMethods.grey78(i); end
       def egrey78(i = ''); puts AllColourMethods.grey78(i); end
       alias ekonsole_colour_grey78 egrey78

  # ======================================================================== 
  # === Colours::AllColourMethods.grey82
  # ======================================================================== 
  def self.grey82(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey82(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey82(i, &block)
      else
        return ::Colours::BasicColours.grey82(i, &block)
      end
    else
      return i
    end
  end; def grey82(i = '', &block); AllColourMethods.grey82(i, &block); end
       def konsole_colour_grey82(i = ''); AllColourMethods.grey82(i); end
       def konsole_grey82(i = ''); AllColourMethods.grey82(i); end
       self.instance_eval { alias konsole_colour_grey82 grey82 } # === Colours::AllColourMethods.konsole_colour_grey82
       def Colours.egrey82(i = ''); puts AllColourMethods.grey82(i); end
       def egrey82(i = ''); puts AllColourMethods.grey82(i); end
       alias ekonsole_colour_grey82 egrey82

  # ======================================================================== 
  # === Colours::AllColourMethods.grey84
  # ======================================================================== 
  def self.grey84(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey84(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey84(i, &block)
      else
        return ::Colours::BasicColours.grey84(i, &block)
      end
    else
      return i
    end
  end; def grey84(i = '', &block); AllColourMethods.grey84(i, &block); end
       def konsole_colour_grey84(i = ''); AllColourMethods.grey84(i); end
       def konsole_grey84(i = ''); AllColourMethods.grey84(i); end
       self.instance_eval { alias konsole_colour_grey84 grey84 } # === Colours::AllColourMethods.konsole_colour_grey84
       def Colours.egrey84(i = ''); puts AllColourMethods.grey84(i); end
       def egrey84(i = ''); puts AllColourMethods.grey84(i); end
       alias ekonsole_colour_grey84 egrey84

  # ======================================================================== 
  # === Colours::AllColourMethods.grey85
  # ======================================================================== 
  def self.grey85(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey85(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey85(i, &block)
      else
        return ::Colours::BasicColours.grey85(i, &block)
      end
    else
      return i
    end
  end; def grey85(i = '', &block); AllColourMethods.grey85(i, &block); end
       def konsole_colour_grey85(i = ''); AllColourMethods.grey85(i); end
       def konsole_grey85(i = ''); AllColourMethods.grey85(i); end
       self.instance_eval { alias konsole_colour_grey85 grey85 } # === Colours::AllColourMethods.konsole_colour_grey85
       def Colours.egrey85(i = ''); puts AllColourMethods.grey85(i); end
       def egrey85(i = ''); puts AllColourMethods.grey85(i); end
       alias ekonsole_colour_grey85 egrey85

  # ======================================================================== 
  # === Colours::AllColourMethods.grey89
  # ======================================================================== 
  def self.grey89(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey89(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey89(i, &block)
      else
        return ::Colours::BasicColours.grey89(i, &block)
      end
    else
      return i
    end
  end; def grey89(i = '', &block); AllColourMethods.grey89(i, &block); end
       def konsole_colour_grey89(i = ''); AllColourMethods.grey89(i); end
       def konsole_grey89(i = ''); AllColourMethods.grey89(i); end
       self.instance_eval { alias konsole_colour_grey89 grey89 } # === Colours::AllColourMethods.konsole_colour_grey89
       def Colours.egrey89(i = ''); puts AllColourMethods.grey89(i); end
       def egrey89(i = ''); puts AllColourMethods.grey89(i); end
       alias ekonsole_colour_grey89 egrey89

  # ======================================================================== 
  # === Colours::AllColourMethods.grey93
  # ======================================================================== 
  def self.grey93(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.grey93(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.grey93(i, &block)
      else
        return ::Colours::BasicColours.grey93(i, &block)
      end
    else
      return i
    end
  end; def grey93(i = '', &block); AllColourMethods.grey93(i, &block); end
       def konsole_colour_grey93(i = ''); AllColourMethods.grey93(i); end
       def konsole_grey93(i = ''); AllColourMethods.grey93(i); end
       self.instance_eval { alias konsole_colour_grey93 grey93 } # === Colours::AllColourMethods.konsole_colour_grey93
       def Colours.egrey93(i = ''); puts AllColourMethods.grey93(i); end
       def egrey93(i = ''); puts AllColourMethods.grey93(i); end
       alias ekonsole_colour_grey93 egrey93

  # ======================================================================== 
  # === Colours::AllColourMethods.honeydew
  # ======================================================================== 
  def self.honeydew(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.honeydew(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.honeydew(i, &block)
      else
        return ::Colours::BasicColours.honeydew(i, &block)
      end
    else
      return i
    end
  end; def honeydew(i = '', &block); AllColourMethods.honeydew(i, &block); end
       def konsole_colour_honeydew(i = ''); AllColourMethods.honeydew(i); end
       def konsole_honeydew(i = ''); AllColourMethods.honeydew(i); end
       self.instance_eval { alias konsole_colour_honeydew honeydew } # === Colours::AllColourMethods.konsole_colour_honeydew
       def Colours.ehoneydew(i = ''); puts AllColourMethods.honeydew(i); end
       def ehoneydew(i = ''); puts AllColourMethods.honeydew(i); end
       alias ekonsole_colour_honeydew ehoneydew

  # ======================================================================== 
  # === Colours::AllColourMethods.honeydew2
  # ======================================================================== 
  def self.honeydew2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.honeydew2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.honeydew2(i, &block)
      else
        return ::Colours::BasicColours.honeydew2(i, &block)
      end
    else
      return i
    end
  end; def honeydew2(i = '', &block); AllColourMethods.honeydew2(i, &block); end
       def konsole_colour_honeydew2(i = ''); AllColourMethods.honeydew2(i); end
       def konsole_honeydew2(i = ''); AllColourMethods.honeydew2(i); end
       self.instance_eval { alias konsole_colour_honeydew2 honeydew2 } # === Colours::AllColourMethods.konsole_colour_honeydew2
       def Colours.ehoneydew2(i = ''); puts AllColourMethods.honeydew2(i); end
       def ehoneydew2(i = ''); puts AllColourMethods.honeydew2(i); end
       alias ekonsole_colour_honeydew2 ehoneydew2

  # ======================================================================== 
  # === Colours::AllColourMethods.hotpink
  # ======================================================================== 
  def self.hotpink(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.hotpink(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.hotpink(i, &block)
      else
        return ::Colours::BasicColours.hotpink(i, &block)
      end
    else
      return i
    end
  end; def hotpink(i = '', &block); AllColourMethods.hotpink(i, &block); end
       def konsole_colour_hotpink(i = ''); AllColourMethods.hotpink(i); end
       def konsole_hotpink(i = ''); AllColourMethods.hotpink(i); end
       self.instance_eval { alias konsole_colour_hotpink hotpink } # === Colours::AllColourMethods.konsole_colour_hotpink
       def Colours.ehotpink(i = ''); puts AllColourMethods.hotpink(i); end
       def ehotpink(i = ''); puts AllColourMethods.hotpink(i); end
       alias ekonsole_colour_hotpink ehotpink

  # ======================================================================== 
  # === Colours::AllColourMethods.hotpink2
  # ======================================================================== 
  def self.hotpink2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.hotpink2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.hotpink2(i, &block)
      else
        return ::Colours::BasicColours.hotpink2(i, &block)
      end
    else
      return i
    end
  end; def hotpink2(i = '', &block); AllColourMethods.hotpink2(i, &block); end
       def konsole_colour_hotpink2(i = ''); AllColourMethods.hotpink2(i); end
       def konsole_hotpink2(i = ''); AllColourMethods.hotpink2(i); end
       self.instance_eval { alias konsole_colour_hotpink2 hotpink2 } # === Colours::AllColourMethods.konsole_colour_hotpink2
       def Colours.ehotpink2(i = ''); puts AllColourMethods.hotpink2(i); end
       def ehotpink2(i = ''); puts AllColourMethods.hotpink2(i); end
       alias ekonsole_colour_hotpink2 ehotpink2

  # ======================================================================== 
  # === Colours::AllColourMethods.hotpink3
  # ======================================================================== 
  def self.hotpink3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.hotpink3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.hotpink3(i, &block)
      else
        return ::Colours::BasicColours.hotpink3(i, &block)
      end
    else
      return i
    end
  end; def hotpink3(i = '', &block); AllColourMethods.hotpink3(i, &block); end
       def konsole_colour_hotpink3(i = ''); AllColourMethods.hotpink3(i); end
       def konsole_hotpink3(i = ''); AllColourMethods.hotpink3(i); end
       self.instance_eval { alias konsole_colour_hotpink3 hotpink3 } # === Colours::AllColourMethods.konsole_colour_hotpink3
       def Colours.ehotpink3(i = ''); puts AllColourMethods.hotpink3(i); end
       def ehotpink3(i = ''); puts AllColourMethods.hotpink3(i); end
       alias ekonsole_colour_hotpink3 ehotpink3

  # ======================================================================== 
  # === Colours::AllColourMethods.indianred
  # ======================================================================== 
  def self.indianred(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.indianred(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.indianred(i, &block)
      else
        return ::Colours::BasicColours.indianred(i, &block)
      end
    else
      return i
    end
  end; def indianred(i = '', &block); AllColourMethods.indianred(i, &block); end
       def konsole_colour_indianred(i = ''); AllColourMethods.indianred(i); end
       def konsole_indianred(i = ''); AllColourMethods.indianred(i); end
       self.instance_eval { alias konsole_colour_indianred indianred } # === Colours::AllColourMethods.konsole_colour_indianred
       def Colours.eindianred(i = ''); puts AllColourMethods.indianred(i); end
       def eindianred(i = ''); puts AllColourMethods.indianred(i); end
       alias ekonsole_colour_indianred eindianred

  # ======================================================================== 
  # === Colours::AllColourMethods.indianred1
  # ======================================================================== 
  def self.indianred1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.indianred1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.indianred1(i, &block)
      else
        return ::Colours::BasicColours.indianred1(i, &block)
      end
    else
      return i
    end
  end; def indianred1(i = '', &block); AllColourMethods.indianred1(i, &block); end
       def konsole_colour_indianred1(i = ''); AllColourMethods.indianred1(i); end
       def konsole_indianred1(i = ''); AllColourMethods.indianred1(i); end
       self.instance_eval { alias konsole_colour_indianred1 indianred1 } # === Colours::AllColourMethods.konsole_colour_indianred1
       def Colours.eindianred1(i = ''); puts AllColourMethods.indianred1(i); end
       def eindianred1(i = ''); puts AllColourMethods.indianred1(i); end
       alias ekonsole_colour_indianred1 eindianred1

  # ======================================================================== 
  # === Colours::AllColourMethods.indigo
  # ======================================================================== 
  def self.indigo(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.indigo(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.indigo(i, &block)
      else
        return ::Colours::BasicColours.indigo(i, &block)
      end
    else
      return i
    end
  end; def indigo(i = '', &block); AllColourMethods.indigo(i, &block); end
       def konsole_colour_indigo(i = ''); AllColourMethods.indigo(i); end
       def konsole_indigo(i = ''); AllColourMethods.indigo(i); end
       self.instance_eval { alias konsole_colour_indigo indigo } # === Colours::AllColourMethods.konsole_colour_indigo
       def Colours.eindigo(i = ''); puts AllColourMethods.indigo(i); end
       def eindigo(i = ''); puts AllColourMethods.indigo(i); end
       alias ekonsole_colour_indigo eindigo

  # ======================================================================== 
  # === Colours::AllColourMethods.ivory
  # ======================================================================== 
  def self.ivory(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.ivory(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.ivory(i, &block)
      else
        return ::Colours::BasicColours.ivory(i, &block)
      end
    else
      return i
    end
  end; def ivory(i = '', &block); AllColourMethods.ivory(i, &block); end
       def konsole_colour_ivory(i = ''); AllColourMethods.ivory(i); end
       def konsole_ivory(i = ''); AllColourMethods.ivory(i); end
       self.instance_eval { alias konsole_colour_ivory ivory } # === Colours::AllColourMethods.konsole_colour_ivory
       def Colours.eivory(i = ''); puts AllColourMethods.ivory(i); end
       def eivory(i = ''); puts AllColourMethods.ivory(i); end
       alias ekonsole_colour_ivory eivory

  # ======================================================================== 
  # === Colours::AllColourMethods.khaki
  # ======================================================================== 
  def self.khaki(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.khaki(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.khaki(i, &block)
      else
        return ::Colours::BasicColours.khaki(i, &block)
      end
    else
      return i
    end
  end; def khaki(i = '', &block); AllColourMethods.khaki(i, &block); end
       def konsole_colour_khaki(i = ''); AllColourMethods.khaki(i); end
       def konsole_khaki(i = ''); AllColourMethods.khaki(i); end
       self.instance_eval { alias konsole_colour_khaki khaki } # === Colours::AllColourMethods.konsole_colour_khaki
       def Colours.ekhaki(i = ''); puts AllColourMethods.khaki(i); end
       def ekhaki(i = ''); puts AllColourMethods.khaki(i); end
       alias ekonsole_colour_khaki ekhaki

  # ======================================================================== 
  # === Colours::AllColourMethods.khaki1
  # ======================================================================== 
  def self.khaki1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.khaki1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.khaki1(i, &block)
      else
        return ::Colours::BasicColours.khaki1(i, &block)
      end
    else
      return i
    end
  end; def khaki1(i = '', &block); AllColourMethods.khaki1(i, &block); end
       def konsole_colour_khaki1(i = ''); AllColourMethods.khaki1(i); end
       def konsole_khaki1(i = ''); AllColourMethods.khaki1(i); end
       self.instance_eval { alias konsole_colour_khaki1 khaki1 } # === Colours::AllColourMethods.konsole_colour_khaki1
       def Colours.ekhaki1(i = ''); puts AllColourMethods.khaki1(i); end
       def ekhaki1(i = ''); puts AllColourMethods.khaki1(i); end
       alias ekonsole_colour_khaki1 ekhaki1

  # ======================================================================== 
  # === Colours::AllColourMethods.khaki3
  # ======================================================================== 
  def self.khaki3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.khaki3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.khaki3(i, &block)
      else
        return ::Colours::BasicColours.khaki3(i, &block)
      end
    else
      return i
    end
  end; def khaki3(i = '', &block); AllColourMethods.khaki3(i, &block); end
       def konsole_colour_khaki3(i = ''); AllColourMethods.khaki3(i); end
       def konsole_khaki3(i = ''); AllColourMethods.khaki3(i); end
       self.instance_eval { alias konsole_colour_khaki3 khaki3 } # === Colours::AllColourMethods.konsole_colour_khaki3
       def Colours.ekhaki3(i = ''); puts AllColourMethods.khaki3(i); end
       def ekhaki3(i = ''); puts AllColourMethods.khaki3(i); end
       alias ekonsole_colour_khaki3 ekhaki3

  # ======================================================================== 
  # === Colours::AllColourMethods.lavender
  # ======================================================================== 
  def self.lavender(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lavender(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lavender(i, &block)
      else
        return ::Colours::BasicColours.lavender(i, &block)
      end
    else
      return i
    end
  end; def lavender(i = '', &block); AllColourMethods.lavender(i, &block); end
       def konsole_colour_lavender(i = ''); AllColourMethods.lavender(i); end
       def konsole_lavender(i = ''); AllColourMethods.lavender(i); end
       self.instance_eval { alias konsole_colour_lavender lavender } # === Colours::AllColourMethods.konsole_colour_lavender
       def Colours.elavender(i = ''); puts AllColourMethods.lavender(i); end
       def elavender(i = ''); puts AllColourMethods.lavender(i); end
       alias ekonsole_colour_lavender elavender

  # ======================================================================== 
  # === Colours::AllColourMethods.lavenderblush
  # ======================================================================== 
  def self.lavenderblush(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lavenderblush(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lavenderblush(i, &block)
      else
        return ::Colours::BasicColours.lavenderblush(i, &block)
      end
    else
      return i
    end
  end; def lavenderblush(i = '', &block); AllColourMethods.lavenderblush(i, &block); end
       def konsole_colour_lavenderblush(i = ''); AllColourMethods.lavenderblush(i); end
       def konsole_lavenderblush(i = ''); AllColourMethods.lavenderblush(i); end
       self.instance_eval { alias konsole_colour_lavenderblush lavenderblush } # === Colours::AllColourMethods.konsole_colour_lavenderblush
       def Colours.elavenderblush(i = ''); puts AllColourMethods.lavenderblush(i); end
       def elavenderblush(i = ''); puts AllColourMethods.lavenderblush(i); end
       alias ekonsole_colour_lavenderblush elavenderblush

  # ======================================================================== 
  # === Colours::AllColourMethods.lawngreen
  # ======================================================================== 
  def self.lawngreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lawngreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lawngreen(i, &block)
      else
        return ::Colours::BasicColours.lawngreen(i, &block)
      end
    else
      return i
    end
  end; def lawngreen(i = '', &block); AllColourMethods.lawngreen(i, &block); end
       def konsole_colour_lawngreen(i = ''); AllColourMethods.lawngreen(i); end
       def konsole_lawngreen(i = ''); AllColourMethods.lawngreen(i); end
       self.instance_eval { alias konsole_colour_lawngreen lawngreen } # === Colours::AllColourMethods.konsole_colour_lawngreen
       def Colours.elawngreen(i = ''); puts AllColourMethods.lawngreen(i); end
       def elawngreen(i = ''); puts AllColourMethods.lawngreen(i); end
       alias ekonsole_colour_lawngreen elawngreen

  # ======================================================================== 
  # === Colours::AllColourMethods.lemonchiffon
  # ======================================================================== 
  def self.lemonchiffon(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lemonchiffon(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lemonchiffon(i, &block)
      else
        return ::Colours::BasicColours.lemonchiffon(i, &block)
      end
    else
      return i
    end
  end; def lemonchiffon(i = '', &block); AllColourMethods.lemonchiffon(i, &block); end
       def konsole_colour_lemonchiffon(i = ''); AllColourMethods.lemonchiffon(i); end
       def konsole_lemonchiffon(i = ''); AllColourMethods.lemonchiffon(i); end
       self.instance_eval { alias konsole_colour_lemonchiffon lemonchiffon } # === Colours::AllColourMethods.konsole_colour_lemonchiffon
       def Colours.elemonchiffon(i = ''); puts AllColourMethods.lemonchiffon(i); end
       def elemonchiffon(i = ''); puts AllColourMethods.lemonchiffon(i); end
       alias ekonsole_colour_lemonchiffon elemonchiffon

       def light_blue(i = ''); AllColourMethods.lightblue(i); end
       def light_cyan(i = ''); AllColourMethods.lightcyan(i); end
       def light_gray(i = ''); AllColourMethods.lightgray(i); end
       def light_green(i = ''); AllColourMethods.lightgreen(i); end
  # ======================================================================== 
  # === Colours::AllColourMethods.lightmagenta
  # ======================================================================== 
  def self.lightmagenta(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightmagenta(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightmagenta(i, &block)
      else
        return ::Colours::BasicColours.lightmagenta(i, &block)
      end
    else
      return i
    end
  end; def lightmagenta(i = '', &block); AllColourMethods.lightmagenta(i, &block); end
       def konsole_colour_lightmagenta(i = ''); AllColourMethods.lightmagenta(i); end
       def konsole_lightmagenta(i = ''); AllColourMethods.lightmagenta(i); end
       self.instance_eval { alias konsole_colour_lightmagenta lightmagenta } # === Colours::AllColourMethods.konsole_colour_lightmagenta
       def Colours.elightmagenta(i = ''); puts AllColourMethods.lightmagenta(i); end
       def elightmagenta(i = ''); puts AllColourMethods.lightmagenta(i); end
       alias ekonsole_colour_lightmagenta elightmagenta

  # ======================================================================== 
  # === Colours::AllColourMethods.lightred
  # ======================================================================== 
  def self.lightred(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightred(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightred(i, &block)
      else
        return ::Colours::BasicColours.lightred(i, &block)
      end
    else
      return i
    end
  end; def lightred(i = '', &block); AllColourMethods.lightred(i, &block); end
       def konsole_colour_lightred(i = ''); AllColourMethods.lightred(i); end
       def konsole_lightred(i = ''); AllColourMethods.lightred(i); end
       self.instance_eval { alias konsole_colour_lightred lightred } # === Colours::AllColourMethods.konsole_colour_lightred
       def Colours.elightred(i = ''); puts AllColourMethods.lightred(i); end
       def elightred(i = ''); puts AllColourMethods.lightred(i); end
       alias ekonsole_colour_lightred elightred

  # ======================================================================== 
  # === Colours::AllColourMethods.lightblue
  # ======================================================================== 
  def self.lightblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightblue(i, &block)
      else
        return ::Colours::BasicColours.lightblue(i, &block)
      end
    else
      return i
    end
  end; def lightblue(i = '', &block); AllColourMethods.lightblue(i, &block); end
       def konsole_colour_lightblue(i = ''); AllColourMethods.lightblue(i); end
       def konsole_lightblue(i = ''); AllColourMethods.lightblue(i); end
       self.instance_eval { alias konsole_colour_lightblue lightblue } # === Colours::AllColourMethods.konsole_colour_lightblue
       def Colours.elightblue(i = ''); puts AllColourMethods.lightblue(i); end
       def elightblue(i = ''); puts AllColourMethods.lightblue(i); end
       alias ekonsole_colour_lightblue elightblue

  # ======================================================================== 
  # === Colours::AllColourMethods.lightcoral
  # ======================================================================== 
  def self.lightcoral(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightcoral(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightcoral(i, &block)
      else
        return ::Colours::BasicColours.lightcoral(i, &block)
      end
    else
      return i
    end
  end; def lightcoral(i = '', &block); AllColourMethods.lightcoral(i, &block); end
       def konsole_colour_lightcoral(i = ''); AllColourMethods.lightcoral(i); end
       def konsole_lightcoral(i = ''); AllColourMethods.lightcoral(i); end
       self.instance_eval { alias konsole_colour_lightcoral lightcoral } # === Colours::AllColourMethods.konsole_colour_lightcoral
       def Colours.elightcoral(i = ''); puts AllColourMethods.lightcoral(i); end
       def elightcoral(i = ''); puts AllColourMethods.lightcoral(i); end
       alias ekonsole_colour_lightcoral elightcoral

  # ======================================================================== 
  # === Colours::AllColourMethods.lightcyan
  # ======================================================================== 
  def self.lightcyan(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightcyan(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightcyan(i, &block)
      else
        return ::Colours::BasicColours.lightcyan(i, &block)
      end
    else
      return i
    end
  end; def lightcyan(i = '', &block); AllColourMethods.lightcyan(i, &block); end
       def konsole_colour_lightcyan(i = ''); AllColourMethods.lightcyan(i); end
       def konsole_lightcyan(i = ''); AllColourMethods.lightcyan(i); end
       self.instance_eval { alias konsole_colour_lightcyan lightcyan } # === Colours::AllColourMethods.konsole_colour_lightcyan
       def Colours.elightcyan(i = ''); puts AllColourMethods.lightcyan(i); end
       def elightcyan(i = ''); puts AllColourMethods.lightcyan(i); end
       alias ekonsole_colour_lightcyan elightcyan

  # ======================================================================== 
  # === Colours::AllColourMethods.lightcyan1
  # ======================================================================== 
  def self.lightcyan1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightcyan1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightcyan1(i, &block)
      else
        return ::Colours::BasicColours.lightcyan1(i, &block)
      end
    else
      return i
    end
  end; def lightcyan1(i = '', &block); AllColourMethods.lightcyan1(i, &block); end
       def konsole_colour_lightcyan1(i = ''); AllColourMethods.lightcyan1(i); end
       def konsole_lightcyan1(i = ''); AllColourMethods.lightcyan1(i); end
       self.instance_eval { alias konsole_colour_lightcyan1 lightcyan1 } # === Colours::AllColourMethods.konsole_colour_lightcyan1
       def Colours.elightcyan1(i = ''); puts AllColourMethods.lightcyan1(i); end
       def elightcyan1(i = ''); puts AllColourMethods.lightcyan1(i); end
       alias ekonsole_colour_lightcyan1 elightcyan1

  # ======================================================================== 
  # === Colours::AllColourMethods.lightcyan3
  # ======================================================================== 
  def self.lightcyan3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightcyan3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightcyan3(i, &block)
      else
        return ::Colours::BasicColours.lightcyan3(i, &block)
      end
    else
      return i
    end
  end; def lightcyan3(i = '', &block); AllColourMethods.lightcyan3(i, &block); end
       def konsole_colour_lightcyan3(i = ''); AllColourMethods.lightcyan3(i); end
       def konsole_lightcyan3(i = ''); AllColourMethods.lightcyan3(i); end
       self.instance_eval { alias konsole_colour_lightcyan3 lightcyan3 } # === Colours::AllColourMethods.konsole_colour_lightcyan3
       def Colours.elightcyan3(i = ''); puts AllColourMethods.lightcyan3(i); end
       def elightcyan3(i = ''); puts AllColourMethods.lightcyan3(i); end
       alias ekonsole_colour_lightcyan3 elightcyan3

  # ======================================================================== 
  # === Colours::AllColourMethods.lightgoldenrod1
  # ======================================================================== 
  def self.lightgoldenrod1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightgoldenrod1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightgoldenrod1(i, &block)
      else
        return ::Colours::BasicColours.lightgoldenrod1(i, &block)
      end
    else
      return i
    end
  end; def lightgoldenrod1(i = '', &block); AllColourMethods.lightgoldenrod1(i, &block); end
       def konsole_colour_lightgoldenrod1(i = ''); AllColourMethods.lightgoldenrod1(i); end
       def konsole_lightgoldenrod1(i = ''); AllColourMethods.lightgoldenrod1(i); end
       self.instance_eval { alias konsole_colour_lightgoldenrod1 lightgoldenrod1 } # === Colours::AllColourMethods.konsole_colour_lightgoldenrod1
       def Colours.elightgoldenrod1(i = ''); puts AllColourMethods.lightgoldenrod1(i); end
       def elightgoldenrod1(i = ''); puts AllColourMethods.lightgoldenrod1(i); end
       alias ekonsole_colour_lightgoldenrod1 elightgoldenrod1

  # ======================================================================== 
  # === Colours::AllColourMethods.lightgoldenrod2
  # ======================================================================== 
  def self.lightgoldenrod2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightgoldenrod2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightgoldenrod2(i, &block)
      else
        return ::Colours::BasicColours.lightgoldenrod2(i, &block)
      end
    else
      return i
    end
  end; def lightgoldenrod2(i = '', &block); AllColourMethods.lightgoldenrod2(i, &block); end
       def konsole_colour_lightgoldenrod2(i = ''); AllColourMethods.lightgoldenrod2(i); end
       def konsole_lightgoldenrod2(i = ''); AllColourMethods.lightgoldenrod2(i); end
       self.instance_eval { alias konsole_colour_lightgoldenrod2 lightgoldenrod2 } # === Colours::AllColourMethods.konsole_colour_lightgoldenrod2
       def Colours.elightgoldenrod2(i = ''); puts AllColourMethods.lightgoldenrod2(i); end
       def elightgoldenrod2(i = ''); puts AllColourMethods.lightgoldenrod2(i); end
       alias ekonsole_colour_lightgoldenrod2 elightgoldenrod2

  # ======================================================================== 
  # === Colours::AllColourMethods.lightgoldenrod3
  # ======================================================================== 
  def self.lightgoldenrod3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightgoldenrod3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightgoldenrod3(i, &block)
      else
        return ::Colours::BasicColours.lightgoldenrod3(i, &block)
      end
    else
      return i
    end
  end; def lightgoldenrod3(i = '', &block); AllColourMethods.lightgoldenrod3(i, &block); end
       def konsole_colour_lightgoldenrod3(i = ''); AllColourMethods.lightgoldenrod3(i); end
       def konsole_lightgoldenrod3(i = ''); AllColourMethods.lightgoldenrod3(i); end
       self.instance_eval { alias konsole_colour_lightgoldenrod3 lightgoldenrod3 } # === Colours::AllColourMethods.konsole_colour_lightgoldenrod3
       def Colours.elightgoldenrod3(i = ''); puts AllColourMethods.lightgoldenrod3(i); end
       def elightgoldenrod3(i = ''); puts AllColourMethods.lightgoldenrod3(i); end
       alias ekonsole_colour_lightgoldenrod3 elightgoldenrod3

  # ======================================================================== 
  # === Colours::AllColourMethods.lightgoldenrodyellow
  # ======================================================================== 
  def self.lightgoldenrodyellow(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightgoldenrodyellow(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightgoldenrodyellow(i, &block)
      else
        return ::Colours::BasicColours.lightgoldenrodyellow(i, &block)
      end
    else
      return i
    end
  end; def lightgoldenrodyellow(i = '', &block); AllColourMethods.lightgoldenrodyellow(i, &block); end
       def konsole_colour_lightgoldenrodyellow(i = ''); AllColourMethods.lightgoldenrodyellow(i); end
       def konsole_lightgoldenrodyellow(i = ''); AllColourMethods.lightgoldenrodyellow(i); end
       self.instance_eval { alias konsole_colour_lightgoldenrodyellow lightgoldenrodyellow } # === Colours::AllColourMethods.konsole_colour_lightgoldenrodyellow
       def Colours.elightgoldenrodyellow(i = ''); puts AllColourMethods.lightgoldenrodyellow(i); end
       def elightgoldenrodyellow(i = ''); puts AllColourMethods.lightgoldenrodyellow(i); end
       alias ekonsole_colour_lightgoldenrodyellow elightgoldenrodyellow

  # ======================================================================== 
  # === Colours::AllColourMethods.lightgray
  # ======================================================================== 
  def self.lightgray(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightgray(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightgray(i, &block)
      else
        return ::Colours::BasicColours.lightgray(i, &block)
      end
    else
      return i
    end
  end; def lightgray(i = '', &block); AllColourMethods.lightgray(i, &block); end
       def konsole_colour_lightgray(i = ''); AllColourMethods.lightgray(i); end
       def konsole_lightgray(i = ''); AllColourMethods.lightgray(i); end
       self.instance_eval { alias konsole_colour_lightgray lightgray } # === Colours::AllColourMethods.konsole_colour_lightgray
       def Colours.elightgray(i = ''); puts AllColourMethods.lightgray(i); end
       def elightgray(i = ''); puts AllColourMethods.lightgray(i); end
       alias ekonsole_colour_lightgray elightgray

  # ======================================================================== 
  # === Colours::AllColourMethods.lightgreen
  # ======================================================================== 
  def self.lightgreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightgreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightgreen(i, &block)
      else
        return ::Colours::BasicColours.lightgreen(i, &block)
      end
    else
      return i
    end
  end; def lightgreen(i = '', &block); AllColourMethods.lightgreen(i, &block); end
       def konsole_colour_lightgreen(i = ''); AllColourMethods.lightgreen(i); end
       def konsole_lightgreen(i = ''); AllColourMethods.lightgreen(i); end
       self.instance_eval { alias konsole_colour_lightgreen lightgreen } # === Colours::AllColourMethods.konsole_colour_lightgreen
       def Colours.elightgreen(i = ''); puts AllColourMethods.lightgreen(i); end
       def elightgreen(i = ''); puts AllColourMethods.lightgreen(i); end
       alias ekonsole_colour_lightgreen elightgreen

  # ======================================================================== 
  # === Colours::AllColourMethods.lightgrey
  # ======================================================================== 
  def self.lightgrey(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightgrey(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightgrey(i, &block)
      else
        return ::Colours::BasicColours.lightgrey(i, &block)
      end
    else
      return i
    end
  end; def lightgrey(i = '', &block); AllColourMethods.lightgrey(i, &block); end
       def konsole_colour_lightgrey(i = ''); AllColourMethods.lightgrey(i); end
       def konsole_lightgrey(i = ''); AllColourMethods.lightgrey(i); end
       self.instance_eval { alias konsole_colour_lightgrey lightgrey } # === Colours::AllColourMethods.konsole_colour_lightgrey
       def Colours.elightgrey(i = ''); puts AllColourMethods.lightgrey(i); end
       def elightgrey(i = ''); puts AllColourMethods.lightgrey(i); end
       alias ekonsole_colour_lightgrey elightgrey

  # ======================================================================== 
  # === Colours::AllColourMethods.lightpink
  # ======================================================================== 
  def self.lightpink(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightpink(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightpink(i, &block)
      else
        return ::Colours::BasicColours.lightpink(i, &block)
      end
    else
      return i
    end
  end; def lightpink(i = '', &block); AllColourMethods.lightpink(i, &block); end
       def konsole_colour_lightpink(i = ''); AllColourMethods.lightpink(i); end
       def konsole_lightpink(i = ''); AllColourMethods.lightpink(i); end
       self.instance_eval { alias konsole_colour_lightpink lightpink } # === Colours::AllColourMethods.konsole_colour_lightpink
       def Colours.elightpink(i = ''); puts AllColourMethods.lightpink(i); end
       def elightpink(i = ''); puts AllColourMethods.lightpink(i); end
       alias ekonsole_colour_lightpink elightpink

  # ======================================================================== 
  # === Colours::AllColourMethods.lightpink1
  # ======================================================================== 
  def self.lightpink1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightpink1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightpink1(i, &block)
      else
        return ::Colours::BasicColours.lightpink1(i, &block)
      end
    else
      return i
    end
  end; def lightpink1(i = '', &block); AllColourMethods.lightpink1(i, &block); end
       def konsole_colour_lightpink1(i = ''); AllColourMethods.lightpink1(i); end
       def konsole_lightpink1(i = ''); AllColourMethods.lightpink1(i); end
       self.instance_eval { alias konsole_colour_lightpink1 lightpink1 } # === Colours::AllColourMethods.konsole_colour_lightpink1
       def Colours.elightpink1(i = ''); puts AllColourMethods.lightpink1(i); end
       def elightpink1(i = ''); puts AllColourMethods.lightpink1(i); end
       alias ekonsole_colour_lightpink1 elightpink1

  # ======================================================================== 
  # === Colours::AllColourMethods.lightpink3
  # ======================================================================== 
  def self.lightpink3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightpink3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightpink3(i, &block)
      else
        return ::Colours::BasicColours.lightpink3(i, &block)
      end
    else
      return i
    end
  end; def lightpink3(i = '', &block); AllColourMethods.lightpink3(i, &block); end
       def konsole_colour_lightpink3(i = ''); AllColourMethods.lightpink3(i); end
       def konsole_lightpink3(i = ''); AllColourMethods.lightpink3(i); end
       self.instance_eval { alias konsole_colour_lightpink3 lightpink3 } # === Colours::AllColourMethods.konsole_colour_lightpink3
       def Colours.elightpink3(i = ''); puts AllColourMethods.lightpink3(i); end
       def elightpink3(i = ''); puts AllColourMethods.lightpink3(i); end
       alias ekonsole_colour_lightpink3 elightpink3

  # ======================================================================== 
  # === Colours::AllColourMethods.lightpink4
  # ======================================================================== 
  def self.lightpink4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightpink4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightpink4(i, &block)
      else
        return ::Colours::BasicColours.lightpink4(i, &block)
      end
    else
      return i
    end
  end; def lightpink4(i = '', &block); AllColourMethods.lightpink4(i, &block); end
       def konsole_colour_lightpink4(i = ''); AllColourMethods.lightpink4(i); end
       def konsole_lightpink4(i = ''); AllColourMethods.lightpink4(i); end
       self.instance_eval { alias konsole_colour_lightpink4 lightpink4 } # === Colours::AllColourMethods.konsole_colour_lightpink4
       def Colours.elightpink4(i = ''); puts AllColourMethods.lightpink4(i); end
       def elightpink4(i = ''); puts AllColourMethods.lightpink4(i); end
       alias ekonsole_colour_lightpink4 elightpink4

  # ======================================================================== 
  # === Colours::AllColourMethods.lightsalmon
  # ======================================================================== 
  def self.lightsalmon(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightsalmon(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightsalmon(i, &block)
      else
        return ::Colours::BasicColours.lightsalmon(i, &block)
      end
    else
      return i
    end
  end; def lightsalmon(i = '', &block); AllColourMethods.lightsalmon(i, &block); end
       def konsole_colour_lightsalmon(i = ''); AllColourMethods.lightsalmon(i); end
       def konsole_lightsalmon(i = ''); AllColourMethods.lightsalmon(i); end
       self.instance_eval { alias konsole_colour_lightsalmon lightsalmon } # === Colours::AllColourMethods.konsole_colour_lightsalmon
       def Colours.elightsalmon(i = ''); puts AllColourMethods.lightsalmon(i); end
       def elightsalmon(i = ''); puts AllColourMethods.lightsalmon(i); end
       alias ekonsole_colour_lightsalmon elightsalmon

  # ======================================================================== 
  # === Colours::AllColourMethods.lightsalmon1
  # ======================================================================== 
  def self.lightsalmon1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightsalmon1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightsalmon1(i, &block)
      else
        return ::Colours::BasicColours.lightsalmon1(i, &block)
      end
    else
      return i
    end
  end; def lightsalmon1(i = '', &block); AllColourMethods.lightsalmon1(i, &block); end
       def konsole_colour_lightsalmon1(i = ''); AllColourMethods.lightsalmon1(i); end
       def konsole_lightsalmon1(i = ''); AllColourMethods.lightsalmon1(i); end
       self.instance_eval { alias konsole_colour_lightsalmon1 lightsalmon1 } # === Colours::AllColourMethods.konsole_colour_lightsalmon1
       def Colours.elightsalmon1(i = ''); puts AllColourMethods.lightsalmon1(i); end
       def elightsalmon1(i = ''); puts AllColourMethods.lightsalmon1(i); end
       alias ekonsole_colour_lightsalmon1 elightsalmon1

  # ======================================================================== 
  # === Colours::AllColourMethods.lightsalmon3
  # ======================================================================== 
  def self.lightsalmon3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightsalmon3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightsalmon3(i, &block)
      else
        return ::Colours::BasicColours.lightsalmon3(i, &block)
      end
    else
      return i
    end
  end; def lightsalmon3(i = '', &block); AllColourMethods.lightsalmon3(i, &block); end
       def konsole_colour_lightsalmon3(i = ''); AllColourMethods.lightsalmon3(i); end
       def konsole_lightsalmon3(i = ''); AllColourMethods.lightsalmon3(i); end
       self.instance_eval { alias konsole_colour_lightsalmon3 lightsalmon3 } # === Colours::AllColourMethods.konsole_colour_lightsalmon3
       def Colours.elightsalmon3(i = ''); puts AllColourMethods.lightsalmon3(i); end
       def elightsalmon3(i = ''); puts AllColourMethods.lightsalmon3(i); end
       alias ekonsole_colour_lightsalmon3 elightsalmon3

  # ======================================================================== 
  # === Colours::AllColourMethods.lightseagreen
  # ======================================================================== 
  def self.lightseagreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightseagreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightseagreen(i, &block)
      else
        return ::Colours::BasicColours.lightseagreen(i, &block)
      end
    else
      return i
    end
  end; def lightseagreen(i = '', &block); AllColourMethods.lightseagreen(i, &block); end
       def konsole_colour_lightseagreen(i = ''); AllColourMethods.lightseagreen(i); end
       def konsole_lightseagreen(i = ''); AllColourMethods.lightseagreen(i); end
       self.instance_eval { alias konsole_colour_lightseagreen lightseagreen } # === Colours::AllColourMethods.konsole_colour_lightseagreen
       def Colours.elightseagreen(i = ''); puts AllColourMethods.lightseagreen(i); end
       def elightseagreen(i = ''); puts AllColourMethods.lightseagreen(i); end
       alias ekonsole_colour_lightseagreen elightseagreen

  # ======================================================================== 
  # === Colours::AllColourMethods.lightskyblue
  # ======================================================================== 
  def self.lightskyblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightskyblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightskyblue(i, &block)
      else
        return ::Colours::BasicColours.lightskyblue(i, &block)
      end
    else
      return i
    end
  end; def lightskyblue(i = '', &block); AllColourMethods.lightskyblue(i, &block); end
       def konsole_colour_lightskyblue(i = ''); AllColourMethods.lightskyblue(i); end
       def konsole_lightskyblue(i = ''); AllColourMethods.lightskyblue(i); end
       self.instance_eval { alias konsole_colour_lightskyblue lightskyblue } # === Colours::AllColourMethods.konsole_colour_lightskyblue
       def Colours.elightskyblue(i = ''); puts AllColourMethods.lightskyblue(i); end
       def elightskyblue(i = ''); puts AllColourMethods.lightskyblue(i); end
       alias ekonsole_colour_lightskyblue elightskyblue

  # ======================================================================== 
  # === Colours::AllColourMethods.lightskyblue1
  # ======================================================================== 
  def self.lightskyblue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightskyblue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightskyblue1(i, &block)
      else
        return ::Colours::BasicColours.lightskyblue1(i, &block)
      end
    else
      return i
    end
  end; def lightskyblue1(i = '', &block); AllColourMethods.lightskyblue1(i, &block); end
       def konsole_colour_lightskyblue1(i = ''); AllColourMethods.lightskyblue1(i); end
       def konsole_lightskyblue1(i = ''); AllColourMethods.lightskyblue1(i); end
       self.instance_eval { alias konsole_colour_lightskyblue1 lightskyblue1 } # === Colours::AllColourMethods.konsole_colour_lightskyblue1
       def Colours.elightskyblue1(i = ''); puts AllColourMethods.lightskyblue1(i); end
       def elightskyblue1(i = ''); puts AllColourMethods.lightskyblue1(i); end
       alias ekonsole_colour_lightskyblue1 elightskyblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.lightskyblue3
  # ======================================================================== 
  def self.lightskyblue3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightskyblue3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightskyblue3(i, &block)
      else
        return ::Colours::BasicColours.lightskyblue3(i, &block)
      end
    else
      return i
    end
  end; def lightskyblue3(i = '', &block); AllColourMethods.lightskyblue3(i, &block); end
       def konsole_colour_lightskyblue3(i = ''); AllColourMethods.lightskyblue3(i); end
       def konsole_lightskyblue3(i = ''); AllColourMethods.lightskyblue3(i); end
       self.instance_eval { alias konsole_colour_lightskyblue3 lightskyblue3 } # === Colours::AllColourMethods.konsole_colour_lightskyblue3
       def Colours.elightskyblue3(i = ''); puts AllColourMethods.lightskyblue3(i); end
       def elightskyblue3(i = ''); puts AllColourMethods.lightskyblue3(i); end
       alias ekonsole_colour_lightskyblue3 elightskyblue3

  # ======================================================================== 
  # === Colours::AllColourMethods.lightslateblue
  # ======================================================================== 
  def self.lightslateblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightslateblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightslateblue(i, &block)
      else
        return ::Colours::BasicColours.lightslateblue(i, &block)
      end
    else
      return i
    end
  end; def lightslateblue(i = '', &block); AllColourMethods.lightslateblue(i, &block); end
       def konsole_colour_lightslateblue(i = ''); AllColourMethods.lightslateblue(i); end
       def konsole_lightslateblue(i = ''); AllColourMethods.lightslateblue(i); end
       self.instance_eval { alias konsole_colour_lightslateblue lightslateblue } # === Colours::AllColourMethods.konsole_colour_lightslateblue
       def Colours.elightslateblue(i = ''); puts AllColourMethods.lightslateblue(i); end
       def elightslateblue(i = ''); puts AllColourMethods.lightslateblue(i); end
       alias ekonsole_colour_lightslateblue elightslateblue

  # ======================================================================== 
  # === Colours::AllColourMethods.lightslategray
  # ======================================================================== 
  def self.lightslategray(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightslategray(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightslategray(i, &block)
      else
        return ::Colours::BasicColours.lightslategray(i, &block)
      end
    else
      return i
    end
  end; def lightslategray(i = '', &block); AllColourMethods.lightslategray(i, &block); end
       def konsole_colour_lightslategray(i = ''); AllColourMethods.lightslategray(i); end
       def konsole_lightslategray(i = ''); AllColourMethods.lightslategray(i); end
       self.instance_eval { alias konsole_colour_lightslategray lightslategray } # === Colours::AllColourMethods.konsole_colour_lightslategray
       def Colours.elightslategray(i = ''); puts AllColourMethods.lightslategray(i); end
       def elightslategray(i = ''); puts AllColourMethods.lightslategray(i); end
       alias ekonsole_colour_lightslategray elightslategray

  # ======================================================================== 
  # === Colours::AllColourMethods.lightslategrey
  # ======================================================================== 
  def self.lightslategrey(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightslategrey(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightslategrey(i, &block)
      else
        return ::Colours::BasicColours.lightslategrey(i, &block)
      end
    else
      return i
    end
  end; def lightslategrey(i = '', &block); AllColourMethods.lightslategrey(i, &block); end
       def konsole_colour_lightslategrey(i = ''); AllColourMethods.lightslategrey(i); end
       def konsole_lightslategrey(i = ''); AllColourMethods.lightslategrey(i); end
       self.instance_eval { alias konsole_colour_lightslategrey lightslategrey } # === Colours::AllColourMethods.konsole_colour_lightslategrey
       def Colours.elightslategrey(i = ''); puts AllColourMethods.lightslategrey(i); end
       def elightslategrey(i = ''); puts AllColourMethods.lightslategrey(i); end
       alias ekonsole_colour_lightslategrey elightslategrey

  # ======================================================================== 
  # === Colours::AllColourMethods.lightsteelblue
  # ======================================================================== 
  def self.lightsteelblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightsteelblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightsteelblue(i, &block)
      else
        return ::Colours::BasicColours.lightsteelblue(i, &block)
      end
    else
      return i
    end
  end; def lightsteelblue(i = '', &block); AllColourMethods.lightsteelblue(i, &block); end
       def konsole_colour_lightsteelblue(i = ''); AllColourMethods.lightsteelblue(i); end
       def konsole_lightsteelblue(i = ''); AllColourMethods.lightsteelblue(i); end
       self.instance_eval { alias konsole_colour_lightsteelblue lightsteelblue } # === Colours::AllColourMethods.konsole_colour_lightsteelblue
       def Colours.elightsteelblue(i = ''); puts AllColourMethods.lightsteelblue(i); end
       def elightsteelblue(i = ''); puts AllColourMethods.lightsteelblue(i); end
       alias ekonsole_colour_lightsteelblue elightsteelblue

  # ======================================================================== 
  # === Colours::AllColourMethods.lightsteelblue1
  # ======================================================================== 
  def self.lightsteelblue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightsteelblue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightsteelblue1(i, &block)
      else
        return ::Colours::BasicColours.lightsteelblue1(i, &block)
      end
    else
      return i
    end
  end; def lightsteelblue1(i = '', &block); AllColourMethods.lightsteelblue1(i, &block); end
       def konsole_colour_lightsteelblue1(i = ''); AllColourMethods.lightsteelblue1(i); end
       def konsole_lightsteelblue1(i = ''); AllColourMethods.lightsteelblue1(i); end
       self.instance_eval { alias konsole_colour_lightsteelblue1 lightsteelblue1 } # === Colours::AllColourMethods.konsole_colour_lightsteelblue1
       def Colours.elightsteelblue1(i = ''); puts AllColourMethods.lightsteelblue1(i); end
       def elightsteelblue1(i = ''); puts AllColourMethods.lightsteelblue1(i); end
       alias ekonsole_colour_lightsteelblue1 elightsteelblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.lightsteelblue3
  # ======================================================================== 
  def self.lightsteelblue3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightsteelblue3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightsteelblue3(i, &block)
      else
        return ::Colours::BasicColours.lightsteelblue3(i, &block)
      end
    else
      return i
    end
  end; def lightsteelblue3(i = '', &block); AllColourMethods.lightsteelblue3(i, &block); end
       def konsole_colour_lightsteelblue3(i = ''); AllColourMethods.lightsteelblue3(i); end
       def konsole_lightsteelblue3(i = ''); AllColourMethods.lightsteelblue3(i); end
       self.instance_eval { alias konsole_colour_lightsteelblue3 lightsteelblue3 } # === Colours::AllColourMethods.konsole_colour_lightsteelblue3
       def Colours.elightsteelblue3(i = ''); puts AllColourMethods.lightsteelblue3(i); end
       def elightsteelblue3(i = ''); puts AllColourMethods.lightsteelblue3(i); end
       alias ekonsole_colour_lightsteelblue3 elightsteelblue3

  # ======================================================================== 
  # === Colours::AllColourMethods.lightyellow
  # ======================================================================== 
  def self.lightyellow(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightyellow(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightyellow(i, &block)
      else
        return ::Colours::BasicColours.lightyellow(i, &block)
      end
    else
      return i
    end
  end; def lightyellow(i = '', &block); AllColourMethods.lightyellow(i, &block); end
       def konsole_colour_lightyellow(i = ''); AllColourMethods.lightyellow(i); end
       def konsole_lightyellow(i = ''); AllColourMethods.lightyellow(i); end
       self.instance_eval { alias konsole_colour_lightyellow lightyellow } # === Colours::AllColourMethods.konsole_colour_lightyellow
       def Colours.elightyellow(i = ''); puts AllColourMethods.lightyellow(i); end
       def elightyellow(i = ''); puts AllColourMethods.lightyellow(i); end
       alias ekonsole_colour_lightyellow elightyellow

  # ======================================================================== 
  # === Colours::AllColourMethods.lightyellow3
  # ======================================================================== 
  def self.lightyellow3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lightyellow3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lightyellow3(i, &block)
      else
        return ::Colours::BasicColours.lightyellow3(i, &block)
      end
    else
      return i
    end
  end; def lightyellow3(i = '', &block); AllColourMethods.lightyellow3(i, &block); end
       def konsole_colour_lightyellow3(i = ''); AllColourMethods.lightyellow3(i); end
       def konsole_lightyellow3(i = ''); AllColourMethods.lightyellow3(i); end
       self.instance_eval { alias konsole_colour_lightyellow3 lightyellow3 } # === Colours::AllColourMethods.konsole_colour_lightyellow3
       def Colours.elightyellow3(i = ''); puts AllColourMethods.lightyellow3(i); end
       def elightyellow3(i = ''); puts AllColourMethods.lightyellow3(i); end
       alias ekonsole_colour_lightyellow3 elightyellow3

  # ======================================================================== 
  # === Colours::AllColourMethods.lime
  # ======================================================================== 
  def self.lime(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.lime(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.lime(i, &block)
      else
        return ::Colours::BasicColours.lime(i, &block)
      end
    else
      return i
    end
  end; def lime(i = '', &block); AllColourMethods.lime(i, &block); end
       def konsole_colour_lime(i = ''); AllColourMethods.lime(i); end
       def konsole_lime(i = ''); AllColourMethods.lime(i); end
       self.instance_eval { alias konsole_colour_lime lime } # === Colours::AllColourMethods.konsole_colour_lime
       def Colours.elime(i = ''); puts AllColourMethods.lime(i); end
       def elime(i = ''); puts AllColourMethods.lime(i); end
       alias ekonsole_colour_lime elime

  # ======================================================================== 
  # === Colours::AllColourMethods.limegreen
  # ======================================================================== 
  def self.limegreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.limegreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.limegreen(i, &block)
      else
        return ::Colours::BasicColours.limegreen(i, &block)
      end
    else
      return i
    end
  end; def limegreen(i = '', &block); AllColourMethods.limegreen(i, &block); end
       def konsole_colour_limegreen(i = ''); AllColourMethods.limegreen(i); end
       def konsole_limegreen(i = ''); AllColourMethods.limegreen(i); end
       self.instance_eval { alias konsole_colour_limegreen limegreen } # === Colours::AllColourMethods.konsole_colour_limegreen
       def Colours.elimegreen(i = ''); puts AllColourMethods.limegreen(i); end
       def elimegreen(i = ''); puts AllColourMethods.limegreen(i); end
       alias ekonsole_colour_limegreen elimegreen

  # ======================================================================== 
  # === Colours::AllColourMethods.linen
  # ======================================================================== 
  def self.linen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.linen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.linen(i, &block)
      else
        return ::Colours::BasicColours.linen(i, &block)
      end
    else
      return i
    end
  end; def linen(i = '', &block); AllColourMethods.linen(i, &block); end
       def konsole_colour_linen(i = ''); AllColourMethods.linen(i); end
       def konsole_linen(i = ''); AllColourMethods.linen(i); end
       self.instance_eval { alias konsole_colour_linen linen } # === Colours::AllColourMethods.konsole_colour_linen
       def Colours.elinen(i = ''); puts AllColourMethods.linen(i); end
       def elinen(i = ''); puts AllColourMethods.linen(i); end
       alias ekonsole_colour_linen elinen

  # ======================================================================== 
  # === Colours::AllColourMethods.magenta
  # ======================================================================== 
  def self.magenta(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.magenta(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.magenta(i, &block)
      else
        return ::Colours::BasicColours.magenta(i, &block)
      end
    else
      return i
    end
  end; def magenta(i = '', &block); AllColourMethods.magenta(i, &block); end
       def konsole_colour_magenta(i = ''); AllColourMethods.magenta(i); end
       def konsole_magenta(i = ''); AllColourMethods.magenta(i); end
       self.instance_eval { alias konsole_colour_magenta magenta } # === Colours::AllColourMethods.konsole_colour_magenta
       def Colours.emagenta(i = ''); puts AllColourMethods.magenta(i); end
       def emagenta(i = ''); puts AllColourMethods.magenta(i); end
       alias ekonsole_colour_magenta emagenta

  # ======================================================================== 
  # === Colours::AllColourMethods.magenta1
  # ======================================================================== 
  def self.magenta1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.magenta1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.magenta1(i, &block)
      else
        return ::Colours::BasicColours.magenta1(i, &block)
      end
    else
      return i
    end
  end; def magenta1(i = '', &block); AllColourMethods.magenta1(i, &block); end
       def konsole_colour_magenta1(i = ''); AllColourMethods.magenta1(i); end
       def konsole_magenta1(i = ''); AllColourMethods.magenta1(i); end
       self.instance_eval { alias konsole_colour_magenta1 magenta1 } # === Colours::AllColourMethods.konsole_colour_magenta1
       def Colours.emagenta1(i = ''); puts AllColourMethods.magenta1(i); end
       def emagenta1(i = ''); puts AllColourMethods.magenta1(i); end
       alias ekonsole_colour_magenta1 emagenta1

  # ======================================================================== 
  # === Colours::AllColourMethods.magenta2
  # ======================================================================== 
  def self.magenta2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.magenta2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.magenta2(i, &block)
      else
        return ::Colours::BasicColours.magenta2(i, &block)
      end
    else
      return i
    end
  end; def magenta2(i = '', &block); AllColourMethods.magenta2(i, &block); end
       def konsole_colour_magenta2(i = ''); AllColourMethods.magenta2(i); end
       def konsole_magenta2(i = ''); AllColourMethods.magenta2(i); end
       self.instance_eval { alias konsole_colour_magenta2 magenta2 } # === Colours::AllColourMethods.konsole_colour_magenta2
       def Colours.emagenta2(i = ''); puts AllColourMethods.magenta2(i); end
       def emagenta2(i = ''); puts AllColourMethods.magenta2(i); end
       alias ekonsole_colour_magenta2 emagenta2

  # ======================================================================== 
  # === Colours::AllColourMethods.magenta3
  # ======================================================================== 
  def self.magenta3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.magenta3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.magenta3(i, &block)
      else
        return ::Colours::BasicColours.magenta3(i, &block)
      end
    else
      return i
    end
  end; def magenta3(i = '', &block); AllColourMethods.magenta3(i, &block); end
       def konsole_colour_magenta3(i = ''); AllColourMethods.magenta3(i); end
       def konsole_magenta3(i = ''); AllColourMethods.magenta3(i); end
       self.instance_eval { alias konsole_colour_magenta3 magenta3 } # === Colours::AllColourMethods.konsole_colour_magenta3
       def Colours.emagenta3(i = ''); puts AllColourMethods.magenta3(i); end
       def emagenta3(i = ''); puts AllColourMethods.magenta3(i); end
       alias ekonsole_colour_magenta3 emagenta3

  # ======================================================================== 
  # === Colours::AllColourMethods.maroon
  # ======================================================================== 
  def self.maroon(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.maroon(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.maroon(i, &block)
      else
        return ::Colours::BasicColours.maroon(i, &block)
      end
    else
      return i
    end
  end; def maroon(i = '', &block); AllColourMethods.maroon(i, &block); end
       def konsole_colour_maroon(i = ''); AllColourMethods.maroon(i); end
       def konsole_maroon(i = ''); AllColourMethods.maroon(i); end
       self.instance_eval { alias konsole_colour_maroon maroon } # === Colours::AllColourMethods.konsole_colour_maroon
       def Colours.emaroon(i = ''); puts AllColourMethods.maroon(i); end
       def emaroon(i = ''); puts AllColourMethods.maroon(i); end
       alias ekonsole_colour_maroon emaroon

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumaquamarine
  # ======================================================================== 
  def self.mediumaquamarine(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumaquamarine(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumaquamarine(i, &block)
      else
        return ::Colours::BasicColours.mediumaquamarine(i, &block)
      end
    else
      return i
    end
  end; def mediumaquamarine(i = '', &block); AllColourMethods.mediumaquamarine(i, &block); end
       def konsole_colour_mediumaquamarine(i = ''); AllColourMethods.mediumaquamarine(i); end
       def konsole_mediumaquamarine(i = ''); AllColourMethods.mediumaquamarine(i); end
       self.instance_eval { alias konsole_colour_mediumaquamarine mediumaquamarine } # === Colours::AllColourMethods.konsole_colour_mediumaquamarine
       def Colours.emediumaquamarine(i = ''); puts AllColourMethods.mediumaquamarine(i); end
       def emediumaquamarine(i = ''); puts AllColourMethods.mediumaquamarine(i); end
       alias ekonsole_colour_mediumaquamarine emediumaquamarine

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumblue
  # ======================================================================== 
  def self.mediumblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumblue(i, &block)
      else
        return ::Colours::BasicColours.mediumblue(i, &block)
      end
    else
      return i
    end
  end; def mediumblue(i = '', &block); AllColourMethods.mediumblue(i, &block); end
       def konsole_colour_mediumblue(i = ''); AllColourMethods.mediumblue(i); end
       def konsole_mediumblue(i = ''); AllColourMethods.mediumblue(i); end
       self.instance_eval { alias konsole_colour_mediumblue mediumblue } # === Colours::AllColourMethods.konsole_colour_mediumblue
       def Colours.emediumblue(i = ''); puts AllColourMethods.mediumblue(i); end
       def emediumblue(i = ''); puts AllColourMethods.mediumblue(i); end
       alias ekonsole_colour_mediumblue emediumblue

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumorchid
  # ======================================================================== 
  def self.mediumorchid(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumorchid(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumorchid(i, &block)
      else
        return ::Colours::BasicColours.mediumorchid(i, &block)
      end
    else
      return i
    end
  end; def mediumorchid(i = '', &block); AllColourMethods.mediumorchid(i, &block); end
       def konsole_colour_mediumorchid(i = ''); AllColourMethods.mediumorchid(i); end
       def konsole_mediumorchid(i = ''); AllColourMethods.mediumorchid(i); end
       self.instance_eval { alias konsole_colour_mediumorchid mediumorchid } # === Colours::AllColourMethods.konsole_colour_mediumorchid
       def Colours.emediumorchid(i = ''); puts AllColourMethods.mediumorchid(i); end
       def emediumorchid(i = ''); puts AllColourMethods.mediumorchid(i); end
       alias ekonsole_colour_mediumorchid emediumorchid

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumorchid1
  # ======================================================================== 
  def self.mediumorchid1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumorchid1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumorchid1(i, &block)
      else
        return ::Colours::BasicColours.mediumorchid1(i, &block)
      end
    else
      return i
    end
  end; def mediumorchid1(i = '', &block); AllColourMethods.mediumorchid1(i, &block); end
       def konsole_colour_mediumorchid1(i = ''); AllColourMethods.mediumorchid1(i); end
       def konsole_mediumorchid1(i = ''); AllColourMethods.mediumorchid1(i); end
       self.instance_eval { alias konsole_colour_mediumorchid1 mediumorchid1 } # === Colours::AllColourMethods.konsole_colour_mediumorchid1
       def Colours.emediumorchid1(i = ''); puts AllColourMethods.mediumorchid1(i); end
       def emediumorchid1(i = ''); puts AllColourMethods.mediumorchid1(i); end
       alias ekonsole_colour_mediumorchid1 emediumorchid1

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumorchid3
  # ======================================================================== 
  def self.mediumorchid3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumorchid3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumorchid3(i, &block)
      else
        return ::Colours::BasicColours.mediumorchid3(i, &block)
      end
    else
      return i
    end
  end; def mediumorchid3(i = '', &block); AllColourMethods.mediumorchid3(i, &block); end
       def konsole_colour_mediumorchid3(i = ''); AllColourMethods.mediumorchid3(i); end
       def konsole_mediumorchid3(i = ''); AllColourMethods.mediumorchid3(i); end
       self.instance_eval { alias konsole_colour_mediumorchid3 mediumorchid3 } # === Colours::AllColourMethods.konsole_colour_mediumorchid3
       def Colours.emediumorchid3(i = ''); puts AllColourMethods.mediumorchid3(i); end
       def emediumorchid3(i = ''); puts AllColourMethods.mediumorchid3(i); end
       alias ekonsole_colour_mediumorchid3 emediumorchid3

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumpurple
  # ======================================================================== 
  def self.mediumpurple(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumpurple(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumpurple(i, &block)
      else
        return ::Colours::BasicColours.mediumpurple(i, &block)
      end
    else
      return i
    end
  end; def mediumpurple(i = '', &block); AllColourMethods.mediumpurple(i, &block); end
       def konsole_colour_mediumpurple(i = ''); AllColourMethods.mediumpurple(i); end
       def konsole_mediumpurple(i = ''); AllColourMethods.mediumpurple(i); end
       self.instance_eval { alias konsole_colour_mediumpurple mediumpurple } # === Colours::AllColourMethods.konsole_colour_mediumpurple
       def Colours.emediumpurple(i = ''); puts AllColourMethods.mediumpurple(i); end
       def emediumpurple(i = ''); puts AllColourMethods.mediumpurple(i); end
       alias ekonsole_colour_mediumpurple emediumpurple

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumpurple1
  # ======================================================================== 
  def self.mediumpurple1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumpurple1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumpurple1(i, &block)
      else
        return ::Colours::BasicColours.mediumpurple1(i, &block)
      end
    else
      return i
    end
  end; def mediumpurple1(i = '', &block); AllColourMethods.mediumpurple1(i, &block); end
       def konsole_colour_mediumpurple1(i = ''); AllColourMethods.mediumpurple1(i); end
       def konsole_mediumpurple1(i = ''); AllColourMethods.mediumpurple1(i); end
       self.instance_eval { alias konsole_colour_mediumpurple1 mediumpurple1 } # === Colours::AllColourMethods.konsole_colour_mediumpurple1
       def Colours.emediumpurple1(i = ''); puts AllColourMethods.mediumpurple1(i); end
       def emediumpurple1(i = ''); puts AllColourMethods.mediumpurple1(i); end
       alias ekonsole_colour_mediumpurple1 emediumpurple1

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumpurple2
  # ======================================================================== 
  def self.mediumpurple2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumpurple2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumpurple2(i, &block)
      else
        return ::Colours::BasicColours.mediumpurple2(i, &block)
      end
    else
      return i
    end
  end; def mediumpurple2(i = '', &block); AllColourMethods.mediumpurple2(i, &block); end
       def konsole_colour_mediumpurple2(i = ''); AllColourMethods.mediumpurple2(i); end
       def konsole_mediumpurple2(i = ''); AllColourMethods.mediumpurple2(i); end
       self.instance_eval { alias konsole_colour_mediumpurple2 mediumpurple2 } # === Colours::AllColourMethods.konsole_colour_mediumpurple2
       def Colours.emediumpurple2(i = ''); puts AllColourMethods.mediumpurple2(i); end
       def emediumpurple2(i = ''); puts AllColourMethods.mediumpurple2(i); end
       alias ekonsole_colour_mediumpurple2 emediumpurple2

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumpurple3
  # ======================================================================== 
  def self.mediumpurple3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumpurple3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumpurple3(i, &block)
      else
        return ::Colours::BasicColours.mediumpurple3(i, &block)
      end
    else
      return i
    end
  end; def mediumpurple3(i = '', &block); AllColourMethods.mediumpurple3(i, &block); end
       def konsole_colour_mediumpurple3(i = ''); AllColourMethods.mediumpurple3(i); end
       def konsole_mediumpurple3(i = ''); AllColourMethods.mediumpurple3(i); end
       self.instance_eval { alias konsole_colour_mediumpurple3 mediumpurple3 } # === Colours::AllColourMethods.konsole_colour_mediumpurple3
       def Colours.emediumpurple3(i = ''); puts AllColourMethods.mediumpurple3(i); end
       def emediumpurple3(i = ''); puts AllColourMethods.mediumpurple3(i); end
       alias ekonsole_colour_mediumpurple3 emediumpurple3

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumpurple4
  # ======================================================================== 
  def self.mediumpurple4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumpurple4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumpurple4(i, &block)
      else
        return ::Colours::BasicColours.mediumpurple4(i, &block)
      end
    else
      return i
    end
  end; def mediumpurple4(i = '', &block); AllColourMethods.mediumpurple4(i, &block); end
       def konsole_colour_mediumpurple4(i = ''); AllColourMethods.mediumpurple4(i); end
       def konsole_mediumpurple4(i = ''); AllColourMethods.mediumpurple4(i); end
       self.instance_eval { alias konsole_colour_mediumpurple4 mediumpurple4 } # === Colours::AllColourMethods.konsole_colour_mediumpurple4
       def Colours.emediumpurple4(i = ''); puts AllColourMethods.mediumpurple4(i); end
       def emediumpurple4(i = ''); puts AllColourMethods.mediumpurple4(i); end
       alias ekonsole_colour_mediumpurple4 emediumpurple4

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumseagreen
  # ======================================================================== 
  def self.mediumseagreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumseagreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumseagreen(i, &block)
      else
        return ::Colours::BasicColours.mediumseagreen(i, &block)
      end
    else
      return i
    end
  end; def mediumseagreen(i = '', &block); AllColourMethods.mediumseagreen(i, &block); end
       def konsole_colour_mediumseagreen(i = ''); AllColourMethods.mediumseagreen(i); end
       def konsole_mediumseagreen(i = ''); AllColourMethods.mediumseagreen(i); end
       self.instance_eval { alias konsole_colour_mediumseagreen mediumseagreen } # === Colours::AllColourMethods.konsole_colour_mediumseagreen
       def Colours.emediumseagreen(i = ''); puts AllColourMethods.mediumseagreen(i); end
       def emediumseagreen(i = ''); puts AllColourMethods.mediumseagreen(i); end
       alias ekonsole_colour_mediumseagreen emediumseagreen

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumslateblue
  # ======================================================================== 
  def self.mediumslateblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumslateblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumslateblue(i, &block)
      else
        return ::Colours::BasicColours.mediumslateblue(i, &block)
      end
    else
      return i
    end
  end; def mediumslateblue(i = '', &block); AllColourMethods.mediumslateblue(i, &block); end
       def konsole_colour_mediumslateblue(i = ''); AllColourMethods.mediumslateblue(i); end
       def konsole_mediumslateblue(i = ''); AllColourMethods.mediumslateblue(i); end
       self.instance_eval { alias konsole_colour_mediumslateblue mediumslateblue } # === Colours::AllColourMethods.konsole_colour_mediumslateblue
       def Colours.emediumslateblue(i = ''); puts AllColourMethods.mediumslateblue(i); end
       def emediumslateblue(i = ''); puts AllColourMethods.mediumslateblue(i); end
       alias ekonsole_colour_mediumslateblue emediumslateblue

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumspringgreen
  # ======================================================================== 
  def self.mediumspringgreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumspringgreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumspringgreen(i, &block)
      else
        return ::Colours::BasicColours.mediumspringgreen(i, &block)
      end
    else
      return i
    end
  end; def mediumspringgreen(i = '', &block); AllColourMethods.mediumspringgreen(i, &block); end
       def konsole_colour_mediumspringgreen(i = ''); AllColourMethods.mediumspringgreen(i); end
       def konsole_mediumspringgreen(i = ''); AllColourMethods.mediumspringgreen(i); end
       self.instance_eval { alias konsole_colour_mediumspringgreen mediumspringgreen } # === Colours::AllColourMethods.konsole_colour_mediumspringgreen
       def Colours.emediumspringgreen(i = ''); puts AllColourMethods.mediumspringgreen(i); end
       def emediumspringgreen(i = ''); puts AllColourMethods.mediumspringgreen(i); end
       alias ekonsole_colour_mediumspringgreen emediumspringgreen

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumturquoise
  # ======================================================================== 
  def self.mediumturquoise(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumturquoise(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumturquoise(i, &block)
      else
        return ::Colours::BasicColours.mediumturquoise(i, &block)
      end
    else
      return i
    end
  end; def mediumturquoise(i = '', &block); AllColourMethods.mediumturquoise(i, &block); end
       def konsole_colour_mediumturquoise(i = ''); AllColourMethods.mediumturquoise(i); end
       def konsole_mediumturquoise(i = ''); AllColourMethods.mediumturquoise(i); end
       self.instance_eval { alias konsole_colour_mediumturquoise mediumturquoise } # === Colours::AllColourMethods.konsole_colour_mediumturquoise
       def Colours.emediumturquoise(i = ''); puts AllColourMethods.mediumturquoise(i); end
       def emediumturquoise(i = ''); puts AllColourMethods.mediumturquoise(i); end
       alias ekonsole_colour_mediumturquoise emediumturquoise

  # ======================================================================== 
  # === Colours::AllColourMethods.mediumvioletred
  # ======================================================================== 
  def self.mediumvioletred(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mediumvioletred(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mediumvioletred(i, &block)
      else
        return ::Colours::BasicColours.mediumvioletred(i, &block)
      end
    else
      return i
    end
  end; def mediumvioletred(i = '', &block); AllColourMethods.mediumvioletred(i, &block); end
       def konsole_colour_mediumvioletred(i = ''); AllColourMethods.mediumvioletred(i); end
       def konsole_mediumvioletred(i = ''); AllColourMethods.mediumvioletred(i); end
       self.instance_eval { alias konsole_colour_mediumvioletred mediumvioletred } # === Colours::AllColourMethods.konsole_colour_mediumvioletred
       def Colours.emediumvioletred(i = ''); puts AllColourMethods.mediumvioletred(i); end
       def emediumvioletred(i = ''); puts AllColourMethods.mediumvioletred(i); end
       alias ekonsole_colour_mediumvioletred emediumvioletred

  # ======================================================================== 
  # === Colours::AllColourMethods.midnightblue
  # ======================================================================== 
  def self.midnightblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.midnightblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.midnightblue(i, &block)
      else
        return ::Colours::BasicColours.midnightblue(i, &block)
      end
    else
      return i
    end
  end; def midnightblue(i = '', &block); AllColourMethods.midnightblue(i, &block); end
       def konsole_colour_midnightblue(i = ''); AllColourMethods.midnightblue(i); end
       def konsole_midnightblue(i = ''); AllColourMethods.midnightblue(i); end
       self.instance_eval { alias konsole_colour_midnightblue midnightblue } # === Colours::AllColourMethods.konsole_colour_midnightblue
       def Colours.emidnightblue(i = ''); puts AllColourMethods.midnightblue(i); end
       def emidnightblue(i = ''); puts AllColourMethods.midnightblue(i); end
       alias ekonsole_colour_midnightblue emidnightblue

  # ======================================================================== 
  # === Colours::AllColourMethods.mintcream
  # ======================================================================== 
  def self.mintcream(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mintcream(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mintcream(i, &block)
      else
        return ::Colours::BasicColours.mintcream(i, &block)
      end
    else
      return i
    end
  end; def mintcream(i = '', &block); AllColourMethods.mintcream(i, &block); end
       def konsole_colour_mintcream(i = ''); AllColourMethods.mintcream(i); end
       def konsole_mintcream(i = ''); AllColourMethods.mintcream(i); end
       self.instance_eval { alias konsole_colour_mintcream mintcream } # === Colours::AllColourMethods.konsole_colour_mintcream
       def Colours.emintcream(i = ''); puts AllColourMethods.mintcream(i); end
       def emintcream(i = ''); puts AllColourMethods.mintcream(i); end
       alias ekonsole_colour_mintcream emintcream

  # ======================================================================== 
  # === Colours::AllColourMethods.mistyrose
  # ======================================================================== 
  def self.mistyrose(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mistyrose(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mistyrose(i, &block)
      else
        return ::Colours::BasicColours.mistyrose(i, &block)
      end
    else
      return i
    end
  end; def mistyrose(i = '', &block); AllColourMethods.mistyrose(i, &block); end
       def konsole_colour_mistyrose(i = ''); AllColourMethods.mistyrose(i); end
       def konsole_mistyrose(i = ''); AllColourMethods.mistyrose(i); end
       self.instance_eval { alias konsole_colour_mistyrose mistyrose } # === Colours::AllColourMethods.konsole_colour_mistyrose
       def Colours.emistyrose(i = ''); puts AllColourMethods.mistyrose(i); end
       def emistyrose(i = ''); puts AllColourMethods.mistyrose(i); end
       alias ekonsole_colour_mistyrose emistyrose

  # ======================================================================== 
  # === Colours::AllColourMethods.mistyrose1
  # ======================================================================== 
  def self.mistyrose1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mistyrose1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mistyrose1(i, &block)
      else
        return ::Colours::BasicColours.mistyrose1(i, &block)
      end
    else
      return i
    end
  end; def mistyrose1(i = '', &block); AllColourMethods.mistyrose1(i, &block); end
       def konsole_colour_mistyrose1(i = ''); AllColourMethods.mistyrose1(i); end
       def konsole_mistyrose1(i = ''); AllColourMethods.mistyrose1(i); end
       self.instance_eval { alias konsole_colour_mistyrose1 mistyrose1 } # === Colours::AllColourMethods.konsole_colour_mistyrose1
       def Colours.emistyrose1(i = ''); puts AllColourMethods.mistyrose1(i); end
       def emistyrose1(i = ''); puts AllColourMethods.mistyrose1(i); end
       alias ekonsole_colour_mistyrose1 emistyrose1

  # ======================================================================== 
  # === Colours::AllColourMethods.mistyrose3
  # ======================================================================== 
  def self.mistyrose3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.mistyrose3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.mistyrose3(i, &block)
      else
        return ::Colours::BasicColours.mistyrose3(i, &block)
      end
    else
      return i
    end
  end; def mistyrose3(i = '', &block); AllColourMethods.mistyrose3(i, &block); end
       def konsole_colour_mistyrose3(i = ''); AllColourMethods.mistyrose3(i); end
       def konsole_mistyrose3(i = ''); AllColourMethods.mistyrose3(i); end
       self.instance_eval { alias konsole_colour_mistyrose3 mistyrose3 } # === Colours::AllColourMethods.konsole_colour_mistyrose3
       def Colours.emistyrose3(i = ''); puts AllColourMethods.mistyrose3(i); end
       def emistyrose3(i = ''); puts AllColourMethods.mistyrose3(i); end
       alias ekonsole_colour_mistyrose3 emistyrose3

  # ======================================================================== 
  # === Colours::AllColourMethods.moccasin
  # ======================================================================== 
  def self.moccasin(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.moccasin(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.moccasin(i, &block)
      else
        return ::Colours::BasicColours.moccasin(i, &block)
      end
    else
      return i
    end
  end; def moccasin(i = '', &block); AllColourMethods.moccasin(i, &block); end
       def konsole_colour_moccasin(i = ''); AllColourMethods.moccasin(i); end
       def konsole_moccasin(i = ''); AllColourMethods.moccasin(i); end
       self.instance_eval { alias konsole_colour_moccasin moccasin } # === Colours::AllColourMethods.konsole_colour_moccasin
       def Colours.emoccasin(i = ''); puts AllColourMethods.moccasin(i); end
       def emoccasin(i = ''); puts AllColourMethods.moccasin(i); end
       alias ekonsole_colour_moccasin emoccasin

  # ======================================================================== 
  # === Colours::AllColourMethods.navajowhite
  # ======================================================================== 
  def self.navajowhite(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.navajowhite(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.navajowhite(i, &block)
      else
        return ::Colours::BasicColours.navajowhite(i, &block)
      end
    else
      return i
    end
  end; def navajowhite(i = '', &block); AllColourMethods.navajowhite(i, &block); end
       def konsole_colour_navajowhite(i = ''); AllColourMethods.navajowhite(i); end
       def konsole_navajowhite(i = ''); AllColourMethods.navajowhite(i); end
       self.instance_eval { alias konsole_colour_navajowhite navajowhite } # === Colours::AllColourMethods.konsole_colour_navajowhite
       def Colours.enavajowhite(i = ''); puts AllColourMethods.navajowhite(i); end
       def enavajowhite(i = ''); puts AllColourMethods.navajowhite(i); end
       alias ekonsole_colour_navajowhite enavajowhite

  # ======================================================================== 
  # === Colours::AllColourMethods.navajowhite1
  # ======================================================================== 
  def self.navajowhite1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.navajowhite1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.navajowhite1(i, &block)
      else
        return ::Colours::BasicColours.navajowhite1(i, &block)
      end
    else
      return i
    end
  end; def navajowhite1(i = '', &block); AllColourMethods.navajowhite1(i, &block); end
       def konsole_colour_navajowhite1(i = ''); AllColourMethods.navajowhite1(i); end
       def konsole_navajowhite1(i = ''); AllColourMethods.navajowhite1(i); end
       self.instance_eval { alias konsole_colour_navajowhite1 navajowhite1 } # === Colours::AllColourMethods.konsole_colour_navajowhite1
       def Colours.enavajowhite1(i = ''); puts AllColourMethods.navajowhite1(i); end
       def enavajowhite1(i = ''); puts AllColourMethods.navajowhite1(i); end
       alias ekonsole_colour_navajowhite1 enavajowhite1

  # ======================================================================== 
  # === Colours::AllColourMethods.navajowhite3
  # ======================================================================== 
  def self.navajowhite3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.navajowhite3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.navajowhite3(i, &block)
      else
        return ::Colours::BasicColours.navajowhite3(i, &block)
      end
    else
      return i
    end
  end; def navajowhite3(i = '', &block); AllColourMethods.navajowhite3(i, &block); end
       def konsole_colour_navajowhite3(i = ''); AllColourMethods.navajowhite3(i); end
       def konsole_navajowhite3(i = ''); AllColourMethods.navajowhite3(i); end
       self.instance_eval { alias konsole_colour_navajowhite3 navajowhite3 } # === Colours::AllColourMethods.konsole_colour_navajowhite3
       def Colours.enavajowhite3(i = ''); puts AllColourMethods.navajowhite3(i); end
       def enavajowhite3(i = ''); puts AllColourMethods.navajowhite3(i); end
       alias ekonsole_colour_navajowhite3 enavajowhite3

  # ======================================================================== 
  # === Colours::AllColourMethods.navy
  # ======================================================================== 
  def self.navy(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.navy(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.navy(i, &block)
      else
        return ::Colours::BasicColours.navy(i, &block)
      end
    else
      return i
    end
  end; def navy(i = '', &block); AllColourMethods.navy(i, &block); end
       def konsole_colour_navy(i = ''); AllColourMethods.navy(i); end
       def konsole_navy(i = ''); AllColourMethods.navy(i); end
       self.instance_eval { alias konsole_colour_navy navy } # === Colours::AllColourMethods.konsole_colour_navy
       def Colours.enavy(i = ''); puts AllColourMethods.navy(i); end
       def enavy(i = ''); puts AllColourMethods.navy(i); end
       alias ekonsole_colour_navy enavy

  # ======================================================================== 
  # === Colours::AllColourMethods.navyblue
  # ======================================================================== 
  def self.navyblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.navyblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.navyblue(i, &block)
      else
        return ::Colours::BasicColours.navyblue(i, &block)
      end
    else
      return i
    end
  end; def navyblue(i = '', &block); AllColourMethods.navyblue(i, &block); end
       def konsole_colour_navyblue(i = ''); AllColourMethods.navyblue(i); end
       def konsole_navyblue(i = ''); AllColourMethods.navyblue(i); end
       self.instance_eval { alias konsole_colour_navyblue navyblue } # === Colours::AllColourMethods.konsole_colour_navyblue
       def Colours.enavyblue(i = ''); puts AllColourMethods.navyblue(i); end
       def enavyblue(i = ''); puts AllColourMethods.navyblue(i); end
       alias ekonsole_colour_navyblue enavyblue

  # ======================================================================== 
  # === Colours::AllColourMethods.oldlace
  # ======================================================================== 
  def self.oldlace(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.oldlace(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.oldlace(i, &block)
      else
        return ::Colours::BasicColours.oldlace(i, &block)
      end
    else
      return i
    end
  end; def oldlace(i = '', &block); AllColourMethods.oldlace(i, &block); end
       def konsole_colour_oldlace(i = ''); AllColourMethods.oldlace(i); end
       def konsole_oldlace(i = ''); AllColourMethods.oldlace(i); end
       self.instance_eval { alias konsole_colour_oldlace oldlace } # === Colours::AllColourMethods.konsole_colour_oldlace
       def Colours.eoldlace(i = ''); puts AllColourMethods.oldlace(i); end
       def eoldlace(i = ''); puts AllColourMethods.oldlace(i); end
       alias ekonsole_colour_oldlace eoldlace

  # ======================================================================== 
  # === Colours::AllColourMethods.olive
  # ======================================================================== 
  def self.olive(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.olive(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.olive(i, &block)
      else
        return ::Colours::BasicColours.olive(i, &block)
      end
    else
      return i
    end
  end; def olive(i = '', &block); AllColourMethods.olive(i, &block); end
       def konsole_colour_olive(i = ''); AllColourMethods.olive(i); end
       def konsole_olive(i = ''); AllColourMethods.olive(i); end
       self.instance_eval { alias konsole_colour_olive olive } # === Colours::AllColourMethods.konsole_colour_olive
       def Colours.eolive(i = ''); puts AllColourMethods.olive(i); end
       def eolive(i = ''); puts AllColourMethods.olive(i); end
       alias ekonsole_colour_olive eolive

  # ======================================================================== 
  # === Colours::AllColourMethods.olivedrab
  # ======================================================================== 
  def self.olivedrab(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.olivedrab(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.olivedrab(i, &block)
      else
        return ::Colours::BasicColours.olivedrab(i, &block)
      end
    else
      return i
    end
  end; def olivedrab(i = '', &block); AllColourMethods.olivedrab(i, &block); end
       def konsole_colour_olivedrab(i = ''); AllColourMethods.olivedrab(i); end
       def konsole_olivedrab(i = ''); AllColourMethods.olivedrab(i); end
       self.instance_eval { alias konsole_colour_olivedrab olivedrab } # === Colours::AllColourMethods.konsole_colour_olivedrab
       def Colours.eolivedrab(i = ''); puts AllColourMethods.olivedrab(i); end
       def eolivedrab(i = ''); puts AllColourMethods.olivedrab(i); end
       alias ekonsole_colour_olivedrab eolivedrab

  # ======================================================================== 
  # === Colours::AllColourMethods.orange
  # ======================================================================== 
  def self.orange(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orange(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orange(i, &block)
      else
        return ::Colours::BasicColours.orange(i, &block)
      end
    else
      return i
    end
  end; def orange(i = '', &block); AllColourMethods.orange(i, &block); end
       def konsole_colour_orange(i = ''); AllColourMethods.orange(i); end
       def konsole_orange(i = ''); AllColourMethods.orange(i); end
       self.instance_eval { alias konsole_colour_orange orange } # === Colours::AllColourMethods.konsole_colour_orange
       def Colours.eorange(i = ''); puts AllColourMethods.orange(i); end
       def eorange(i = ''); puts AllColourMethods.orange(i); end
       alias ekonsole_colour_orange eorange

  # ======================================================================== 
  # === Colours::AllColourMethods.orange1
  # ======================================================================== 
  def self.orange1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orange1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orange1(i, &block)
      else
        return ::Colours::BasicColours.orange1(i, &block)
      end
    else
      return i
    end
  end; def orange1(i = '', &block); AllColourMethods.orange1(i, &block); end
       def konsole_colour_orange1(i = ''); AllColourMethods.orange1(i); end
       def konsole_orange1(i = ''); AllColourMethods.orange1(i); end
       self.instance_eval { alias konsole_colour_orange1 orange1 } # === Colours::AllColourMethods.konsole_colour_orange1
       def Colours.eorange1(i = ''); puts AllColourMethods.orange1(i); end
       def eorange1(i = ''); puts AllColourMethods.orange1(i); end
       alias ekonsole_colour_orange1 eorange1

  # ======================================================================== 
  # === Colours::AllColourMethods.orange3
  # ======================================================================== 
  def self.orange3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orange3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orange3(i, &block)
      else
        return ::Colours::BasicColours.orange3(i, &block)
      end
    else
      return i
    end
  end; def orange3(i = '', &block); AllColourMethods.orange3(i, &block); end
       def konsole_colour_orange3(i = ''); AllColourMethods.orange3(i); end
       def konsole_orange3(i = ''); AllColourMethods.orange3(i); end
       self.instance_eval { alias konsole_colour_orange3 orange3 } # === Colours::AllColourMethods.konsole_colour_orange3
       def Colours.eorange3(i = ''); puts AllColourMethods.orange3(i); end
       def eorange3(i = ''); puts AllColourMethods.orange3(i); end
       alias ekonsole_colour_orange3 eorange3

  # ======================================================================== 
  # === Colours::AllColourMethods.orange4
  # ======================================================================== 
  def self.orange4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orange4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orange4(i, &block)
      else
        return ::Colours::BasicColours.orange4(i, &block)
      end
    else
      return i
    end
  end; def orange4(i = '', &block); AllColourMethods.orange4(i, &block); end
       def konsole_colour_orange4(i = ''); AllColourMethods.orange4(i); end
       def konsole_orange4(i = ''); AllColourMethods.orange4(i); end
       self.instance_eval { alias konsole_colour_orange4 orange4 } # === Colours::AllColourMethods.konsole_colour_orange4
       def Colours.eorange4(i = ''); puts AllColourMethods.orange4(i); end
       def eorange4(i = ''); puts AllColourMethods.orange4(i); end
       alias ekonsole_colour_orange4 eorange4

  # ======================================================================== 
  # === Colours::AllColourMethods.orangered
  # ======================================================================== 
  def self.orangered(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orangered(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orangered(i, &block)
      else
        return ::Colours::BasicColours.orangered(i, &block)
      end
    else
      return i
    end
  end; def orangered(i = '', &block); AllColourMethods.orangered(i, &block); end
       def konsole_colour_orangered(i = ''); AllColourMethods.orangered(i); end
       def konsole_orangered(i = ''); AllColourMethods.orangered(i); end
       self.instance_eval { alias konsole_colour_orangered orangered } # === Colours::AllColourMethods.konsole_colour_orangered
       def Colours.eorangered(i = ''); puts AllColourMethods.orangered(i); end
       def eorangered(i = ''); puts AllColourMethods.orangered(i); end
       alias ekonsole_colour_orangered eorangered

  # ======================================================================== 
  # === Colours::AllColourMethods.orangered1
  # ======================================================================== 
  def self.orangered1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orangered1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orangered1(i, &block)
      else
        return ::Colours::BasicColours.orangered1(i, &block)
      end
    else
      return i
    end
  end; def orangered1(i = '', &block); AllColourMethods.orangered1(i, &block); end
       def konsole_colour_orangered1(i = ''); AllColourMethods.orangered1(i); end
       def konsole_orangered1(i = ''); AllColourMethods.orangered1(i); end
       self.instance_eval { alias konsole_colour_orangered1 orangered1 } # === Colours::AllColourMethods.konsole_colour_orangered1
       def Colours.eorangered1(i = ''); puts AllColourMethods.orangered1(i); end
       def eorangered1(i = ''); puts AllColourMethods.orangered1(i); end
       alias ekonsole_colour_orangered1 eorangered1

  # ======================================================================== 
  # === Colours::AllColourMethods.orchid
  # ======================================================================== 
  def self.orchid(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orchid(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orchid(i, &block)
      else
        return ::Colours::BasicColours.orchid(i, &block)
      end
    else
      return i
    end
  end; def orchid(i = '', &block); AllColourMethods.orchid(i, &block); end
       def konsole_colour_orchid(i = ''); AllColourMethods.orchid(i); end
       def konsole_orchid(i = ''); AllColourMethods.orchid(i); end
       self.instance_eval { alias konsole_colour_orchid orchid } # === Colours::AllColourMethods.konsole_colour_orchid
       def Colours.eorchid(i = ''); puts AllColourMethods.orchid(i); end
       def eorchid(i = ''); puts AllColourMethods.orchid(i); end
       alias ekonsole_colour_orchid eorchid

  # ======================================================================== 
  # === Colours::AllColourMethods.orchid1
  # ======================================================================== 
  def self.orchid1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orchid1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orchid1(i, &block)
      else
        return ::Colours::BasicColours.orchid1(i, &block)
      end
    else
      return i
    end
  end; def orchid1(i = '', &block); AllColourMethods.orchid1(i, &block); end
       def konsole_colour_orchid1(i = ''); AllColourMethods.orchid1(i); end
       def konsole_orchid1(i = ''); AllColourMethods.orchid1(i); end
       self.instance_eval { alias konsole_colour_orchid1 orchid1 } # === Colours::AllColourMethods.konsole_colour_orchid1
       def Colours.eorchid1(i = ''); puts AllColourMethods.orchid1(i); end
       def eorchid1(i = ''); puts AllColourMethods.orchid1(i); end
       alias ekonsole_colour_orchid1 eorchid1

  # ======================================================================== 
  # === Colours::AllColourMethods.orchid2
  # ======================================================================== 
  def self.orchid2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.orchid2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.orchid2(i, &block)
      else
        return ::Colours::BasicColours.orchid2(i, &block)
      end
    else
      return i
    end
  end; def orchid2(i = '', &block); AllColourMethods.orchid2(i, &block); end
       def konsole_colour_orchid2(i = ''); AllColourMethods.orchid2(i); end
       def konsole_orchid2(i = ''); AllColourMethods.orchid2(i); end
       self.instance_eval { alias konsole_colour_orchid2 orchid2 } # === Colours::AllColourMethods.konsole_colour_orchid2
       def Colours.eorchid2(i = ''); puts AllColourMethods.orchid2(i); end
       def eorchid2(i = ''); puts AllColourMethods.orchid2(i); end
       alias ekonsole_colour_orchid2 eorchid2

  # ======================================================================== 
  # === Colours::AllColourMethods.palegoldenrod
  # ======================================================================== 
  def self.palegoldenrod(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.palegoldenrod(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.palegoldenrod(i, &block)
      else
        return ::Colours::BasicColours.palegoldenrod(i, &block)
      end
    else
      return i
    end
  end; def palegoldenrod(i = '', &block); AllColourMethods.palegoldenrod(i, &block); end
       def konsole_colour_palegoldenrod(i = ''); AllColourMethods.palegoldenrod(i); end
       def konsole_palegoldenrod(i = ''); AllColourMethods.palegoldenrod(i); end
       self.instance_eval { alias konsole_colour_palegoldenrod palegoldenrod } # === Colours::AllColourMethods.konsole_colour_palegoldenrod
       def Colours.epalegoldenrod(i = ''); puts AllColourMethods.palegoldenrod(i); end
       def epalegoldenrod(i = ''); puts AllColourMethods.palegoldenrod(i); end
       alias ekonsole_colour_palegoldenrod epalegoldenrod

  # ======================================================================== 
  # === Colours::AllColourMethods.palegreen
  # ======================================================================== 
  def self.palegreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.palegreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.palegreen(i, &block)
      else
        return ::Colours::BasicColours.palegreen(i, &block)
      end
    else
      return i
    end
  end; def palegreen(i = '', &block); AllColourMethods.palegreen(i, &block); end
       def konsole_colour_palegreen(i = ''); AllColourMethods.palegreen(i); end
       def konsole_palegreen(i = ''); AllColourMethods.palegreen(i); end
       self.instance_eval { alias konsole_colour_palegreen palegreen } # === Colours::AllColourMethods.konsole_colour_palegreen
       def Colours.epalegreen(i = ''); puts AllColourMethods.palegreen(i); end
       def epalegreen(i = ''); puts AllColourMethods.palegreen(i); end
       alias ekonsole_colour_palegreen epalegreen

  # ======================================================================== 
  # === Colours::AllColourMethods.palegreen1
  # ======================================================================== 
  def self.palegreen1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.palegreen1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.palegreen1(i, &block)
      else
        return ::Colours::BasicColours.palegreen1(i, &block)
      end
    else
      return i
    end
  end; def palegreen1(i = '', &block); AllColourMethods.palegreen1(i, &block); end
       def konsole_colour_palegreen1(i = ''); AllColourMethods.palegreen1(i); end
       def konsole_palegreen1(i = ''); AllColourMethods.palegreen1(i); end
       self.instance_eval { alias konsole_colour_palegreen1 palegreen1 } # === Colours::AllColourMethods.konsole_colour_palegreen1
       def Colours.epalegreen1(i = ''); puts AllColourMethods.palegreen1(i); end
       def epalegreen1(i = ''); puts AllColourMethods.palegreen1(i); end
       alias ekonsole_colour_palegreen1 epalegreen1

  # ======================================================================== 
  # === Colours::AllColourMethods.palegreen3
  # ======================================================================== 
  def self.palegreen3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.palegreen3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.palegreen3(i, &block)
      else
        return ::Colours::BasicColours.palegreen3(i, &block)
      end
    else
      return i
    end
  end; def palegreen3(i = '', &block); AllColourMethods.palegreen3(i, &block); end
       def konsole_colour_palegreen3(i = ''); AllColourMethods.palegreen3(i); end
       def konsole_palegreen3(i = ''); AllColourMethods.palegreen3(i); end
       self.instance_eval { alias konsole_colour_palegreen3 palegreen3 } # === Colours::AllColourMethods.konsole_colour_palegreen3
       def Colours.epalegreen3(i = ''); puts AllColourMethods.palegreen3(i); end
       def epalegreen3(i = ''); puts AllColourMethods.palegreen3(i); end
       alias ekonsole_colour_palegreen3 epalegreen3

  # ======================================================================== 
  # === Colours::AllColourMethods.paleturquoise
  # ======================================================================== 
  def self.paleturquoise(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.paleturquoise(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.paleturquoise(i, &block)
      else
        return ::Colours::BasicColours.paleturquoise(i, &block)
      end
    else
      return i
    end
  end; def paleturquoise(i = '', &block); AllColourMethods.paleturquoise(i, &block); end
       def konsole_colour_paleturquoise(i = ''); AllColourMethods.paleturquoise(i); end
       def konsole_paleturquoise(i = ''); AllColourMethods.paleturquoise(i); end
       self.instance_eval { alias konsole_colour_paleturquoise paleturquoise } # === Colours::AllColourMethods.konsole_colour_paleturquoise
       def Colours.epaleturquoise(i = ''); puts AllColourMethods.paleturquoise(i); end
       def epaleturquoise(i = ''); puts AllColourMethods.paleturquoise(i); end
       alias ekonsole_colour_paleturquoise epaleturquoise

  # ======================================================================== 
  # === Colours::AllColourMethods.paleturquoise1
  # ======================================================================== 
  def self.paleturquoise1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.paleturquoise1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.paleturquoise1(i, &block)
      else
        return ::Colours::BasicColours.paleturquoise1(i, &block)
      end
    else
      return i
    end
  end; def paleturquoise1(i = '', &block); AllColourMethods.paleturquoise1(i, &block); end
       def konsole_colour_paleturquoise1(i = ''); AllColourMethods.paleturquoise1(i); end
       def konsole_paleturquoise1(i = ''); AllColourMethods.paleturquoise1(i); end
       self.instance_eval { alias konsole_colour_paleturquoise1 paleturquoise1 } # === Colours::AllColourMethods.konsole_colour_paleturquoise1
       def Colours.epaleturquoise1(i = ''); puts AllColourMethods.paleturquoise1(i); end
       def epaleturquoise1(i = ''); puts AllColourMethods.paleturquoise1(i); end
       alias ekonsole_colour_paleturquoise1 epaleturquoise1

  # ======================================================================== 
  # === Colours::AllColourMethods.paleturquoise4
  # ======================================================================== 
  def self.paleturquoise4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.paleturquoise4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.paleturquoise4(i, &block)
      else
        return ::Colours::BasicColours.paleturquoise4(i, &block)
      end
    else
      return i
    end
  end; def paleturquoise4(i = '', &block); AllColourMethods.paleturquoise4(i, &block); end
       def konsole_colour_paleturquoise4(i = ''); AllColourMethods.paleturquoise4(i); end
       def konsole_paleturquoise4(i = ''); AllColourMethods.paleturquoise4(i); end
       self.instance_eval { alias konsole_colour_paleturquoise4 paleturquoise4 } # === Colours::AllColourMethods.konsole_colour_paleturquoise4
       def Colours.epaleturquoise4(i = ''); puts AllColourMethods.paleturquoise4(i); end
       def epaleturquoise4(i = ''); puts AllColourMethods.paleturquoise4(i); end
       alias ekonsole_colour_paleturquoise4 epaleturquoise4

  # ======================================================================== 
  # === Colours::AllColourMethods.palevioletred
  # ======================================================================== 
  def self.palevioletred(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.palevioletred(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.palevioletred(i, &block)
      else
        return ::Colours::BasicColours.palevioletred(i, &block)
      end
    else
      return i
    end
  end; def palevioletred(i = '', &block); AllColourMethods.palevioletred(i, &block); end
       def konsole_colour_palevioletred(i = ''); AllColourMethods.palevioletred(i); end
       def konsole_palevioletred(i = ''); AllColourMethods.palevioletred(i); end
       self.instance_eval { alias konsole_colour_palevioletred palevioletred } # === Colours::AllColourMethods.konsole_colour_palevioletred
       def Colours.epalevioletred(i = ''); puts AllColourMethods.palevioletred(i); end
       def epalevioletred(i = ''); puts AllColourMethods.palevioletred(i); end
       alias ekonsole_colour_palevioletred epalevioletred

  # ======================================================================== 
  # === Colours::AllColourMethods.palevioletred1
  # ======================================================================== 
  def self.palevioletred1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.palevioletred1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.palevioletred1(i, &block)
      else
        return ::Colours::BasicColours.palevioletred1(i, &block)
      end
    else
      return i
    end
  end; def palevioletred1(i = '', &block); AllColourMethods.palevioletred1(i, &block); end
       def konsole_colour_palevioletred1(i = ''); AllColourMethods.palevioletred1(i); end
       def konsole_palevioletred1(i = ''); AllColourMethods.palevioletred1(i); end
       self.instance_eval { alias konsole_colour_palevioletred1 palevioletred1 } # === Colours::AllColourMethods.konsole_colour_palevioletred1
       def Colours.epalevioletred1(i = ''); puts AllColourMethods.palevioletred1(i); end
       def epalevioletred1(i = ''); puts AllColourMethods.palevioletred1(i); end
       alias ekonsole_colour_palevioletred1 epalevioletred1

  # ======================================================================== 
  # === Colours::AllColourMethods.papayawhip
  # ======================================================================== 
  def self.papayawhip(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.papayawhip(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.papayawhip(i, &block)
      else
        return ::Colours::BasicColours.papayawhip(i, &block)
      end
    else
      return i
    end
  end; def papayawhip(i = '', &block); AllColourMethods.papayawhip(i, &block); end
       def konsole_colour_papayawhip(i = ''); AllColourMethods.papayawhip(i); end
       def konsole_papayawhip(i = ''); AllColourMethods.papayawhip(i); end
       self.instance_eval { alias konsole_colour_papayawhip papayawhip } # === Colours::AllColourMethods.konsole_colour_papayawhip
       def Colours.epapayawhip(i = ''); puts AllColourMethods.papayawhip(i); end
       def epapayawhip(i = ''); puts AllColourMethods.papayawhip(i); end
       alias ekonsole_colour_papayawhip epapayawhip

  # ======================================================================== 
  # === Colours::AllColourMethods.peachpuff
  # ======================================================================== 
  def self.peachpuff(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.peachpuff(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.peachpuff(i, &block)
      else
        return ::Colours::BasicColours.peachpuff(i, &block)
      end
    else
      return i
    end
  end; def peachpuff(i = '', &block); AllColourMethods.peachpuff(i, &block); end
       def konsole_colour_peachpuff(i = ''); AllColourMethods.peachpuff(i); end
       def konsole_peachpuff(i = ''); AllColourMethods.peachpuff(i); end
       self.instance_eval { alias konsole_colour_peachpuff peachpuff } # === Colours::AllColourMethods.konsole_colour_peachpuff
       def Colours.epeachpuff(i = ''); puts AllColourMethods.peachpuff(i); end
       def epeachpuff(i = ''); puts AllColourMethods.peachpuff(i); end
       alias ekonsole_colour_peachpuff epeachpuff

  # ======================================================================== 
  # === Colours::AllColourMethods.peru
  # ======================================================================== 
  def self.peru(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.peru(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.peru(i, &block)
      else
        return ::Colours::BasicColours.peru(i, &block)
      end
    else
      return i
    end
  end; def peru(i = '', &block); AllColourMethods.peru(i, &block); end
       def konsole_colour_peru(i = ''); AllColourMethods.peru(i); end
       def konsole_peru(i = ''); AllColourMethods.peru(i); end
       self.instance_eval { alias konsole_colour_peru peru } # === Colours::AllColourMethods.konsole_colour_peru
       def Colours.eperu(i = ''); puts AllColourMethods.peru(i); end
       def eperu(i = ''); puts AllColourMethods.peru(i); end
       alias ekonsole_colour_peru eperu

  # ======================================================================== 
  # === Colours::AllColourMethods.pink
  # ======================================================================== 
  def self.pink(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.pink(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.pink(i, &block)
      else
        return ::Colours::BasicColours.pink(i, &block)
      end
    else
      return i
    end
  end; def pink(i = '', &block); AllColourMethods.pink(i, &block); end
       def konsole_colour_pink(i = ''); AllColourMethods.pink(i); end
       def konsole_pink(i = ''); AllColourMethods.pink(i); end
       self.instance_eval { alias konsole_colour_pink pink } # === Colours::AllColourMethods.konsole_colour_pink
       def Colours.epink(i = ''); puts AllColourMethods.pink(i); end
       def epink(i = ''); puts AllColourMethods.pink(i); end
       alias ekonsole_colour_pink epink

  # ======================================================================== 
  # === Colours::AllColourMethods.pink1
  # ======================================================================== 
  def self.pink1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.pink1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.pink1(i, &block)
      else
        return ::Colours::BasicColours.pink1(i, &block)
      end
    else
      return i
    end
  end; def pink1(i = '', &block); AllColourMethods.pink1(i, &block); end
       def konsole_colour_pink1(i = ''); AllColourMethods.pink1(i); end
       def konsole_pink1(i = ''); AllColourMethods.pink1(i); end
       self.instance_eval { alias konsole_colour_pink1 pink1 } # === Colours::AllColourMethods.konsole_colour_pink1
       def Colours.epink1(i = ''); puts AllColourMethods.pink1(i); end
       def epink1(i = ''); puts AllColourMethods.pink1(i); end
       alias ekonsole_colour_pink1 epink1

  # ======================================================================== 
  # === Colours::AllColourMethods.pink3
  # ======================================================================== 
  def self.pink3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.pink3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.pink3(i, &block)
      else
        return ::Colours::BasicColours.pink3(i, &block)
      end
    else
      return i
    end
  end; def pink3(i = '', &block); AllColourMethods.pink3(i, &block); end
       def konsole_colour_pink3(i = ''); AllColourMethods.pink3(i); end
       def konsole_pink3(i = ''); AllColourMethods.pink3(i); end
       self.instance_eval { alias konsole_colour_pink3 pink3 } # === Colours::AllColourMethods.konsole_colour_pink3
       def Colours.epink3(i = ''); puts AllColourMethods.pink3(i); end
       def epink3(i = ''); puts AllColourMethods.pink3(i); end
       alias ekonsole_colour_pink3 epink3

  # ======================================================================== 
  # === Colours::AllColourMethods.plum
  # ======================================================================== 
  def self.plum(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.plum(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.plum(i, &block)
      else
        return ::Colours::BasicColours.plum(i, &block)
      end
    else
      return i
    end
  end; def plum(i = '', &block); AllColourMethods.plum(i, &block); end
       def konsole_colour_plum(i = ''); AllColourMethods.plum(i); end
       def konsole_plum(i = ''); AllColourMethods.plum(i); end
       self.instance_eval { alias konsole_colour_plum plum } # === Colours::AllColourMethods.konsole_colour_plum
       def Colours.eplum(i = ''); puts AllColourMethods.plum(i); end
       def eplum(i = ''); puts AllColourMethods.plum(i); end
       alias ekonsole_colour_plum eplum

  # ======================================================================== 
  # === Colours::AllColourMethods.plum1
  # ======================================================================== 
  def self.plum1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.plum1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.plum1(i, &block)
      else
        return ::Colours::BasicColours.plum1(i, &block)
      end
    else
      return i
    end
  end; def plum1(i = '', &block); AllColourMethods.plum1(i, &block); end
       def konsole_colour_plum1(i = ''); AllColourMethods.plum1(i); end
       def konsole_plum1(i = ''); AllColourMethods.plum1(i); end
       self.instance_eval { alias konsole_colour_plum1 plum1 } # === Colours::AllColourMethods.konsole_colour_plum1
       def Colours.eplum1(i = ''); puts AllColourMethods.plum1(i); end
       def eplum1(i = ''); puts AllColourMethods.plum1(i); end
       alias ekonsole_colour_plum1 eplum1

  # ======================================================================== 
  # === Colours::AllColourMethods.plum2
  # ======================================================================== 
  def self.plum2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.plum2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.plum2(i, &block)
      else
        return ::Colours::BasicColours.plum2(i, &block)
      end
    else
      return i
    end
  end; def plum2(i = '', &block); AllColourMethods.plum2(i, &block); end
       def konsole_colour_plum2(i = ''); AllColourMethods.plum2(i); end
       def konsole_plum2(i = ''); AllColourMethods.plum2(i); end
       self.instance_eval { alias konsole_colour_plum2 plum2 } # === Colours::AllColourMethods.konsole_colour_plum2
       def Colours.eplum2(i = ''); puts AllColourMethods.plum2(i); end
       def eplum2(i = ''); puts AllColourMethods.plum2(i); end
       alias ekonsole_colour_plum2 eplum2

  # ======================================================================== 
  # === Colours::AllColourMethods.plum3
  # ======================================================================== 
  def self.plum3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.plum3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.plum3(i, &block)
      else
        return ::Colours::BasicColours.plum3(i, &block)
      end
    else
      return i
    end
  end; def plum3(i = '', &block); AllColourMethods.plum3(i, &block); end
       def konsole_colour_plum3(i = ''); AllColourMethods.plum3(i); end
       def konsole_plum3(i = ''); AllColourMethods.plum3(i); end
       self.instance_eval { alias konsole_colour_plum3 plum3 } # === Colours::AllColourMethods.konsole_colour_plum3
       def Colours.eplum3(i = ''); puts AllColourMethods.plum3(i); end
       def eplum3(i = ''); puts AllColourMethods.plum3(i); end
       alias ekonsole_colour_plum3 eplum3

  # ======================================================================== 
  # === Colours::AllColourMethods.plum4
  # ======================================================================== 
  def self.plum4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.plum4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.plum4(i, &block)
      else
        return ::Colours::BasicColours.plum4(i, &block)
      end
    else
      return i
    end
  end; def plum4(i = '', &block); AllColourMethods.plum4(i, &block); end
       def konsole_colour_plum4(i = ''); AllColourMethods.plum4(i); end
       def konsole_plum4(i = ''); AllColourMethods.plum4(i); end
       self.instance_eval { alias konsole_colour_plum4 plum4 } # === Colours::AllColourMethods.konsole_colour_plum4
       def Colours.eplum4(i = ''); puts AllColourMethods.plum4(i); end
       def eplum4(i = ''); puts AllColourMethods.plum4(i); end
       alias ekonsole_colour_plum4 eplum4

  # ======================================================================== 
  # === Colours::AllColourMethods.powderblue
  # ======================================================================== 
  def self.powderblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.powderblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.powderblue(i, &block)
      else
        return ::Colours::BasicColours.powderblue(i, &block)
      end
    else
      return i
    end
  end; def powderblue(i = '', &block); AllColourMethods.powderblue(i, &block); end
       def konsole_colour_powderblue(i = ''); AllColourMethods.powderblue(i); end
       def konsole_powderblue(i = ''); AllColourMethods.powderblue(i); end
       self.instance_eval { alias konsole_colour_powderblue powderblue } # === Colours::AllColourMethods.konsole_colour_powderblue
       def Colours.epowderblue(i = ''); puts AllColourMethods.powderblue(i); end
       def epowderblue(i = ''); puts AllColourMethods.powderblue(i); end
       alias ekonsole_colour_powderblue epowderblue

  # ======================================================================== 
  # === Colours::AllColourMethods.purple
  # ======================================================================== 
  def self.purple(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.purple(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.purple(i, &block)
      else
        return ::Colours::BasicColours.purple(i, &block)
      end
    else
      return i
    end
  end; def purple(i = '', &block); AllColourMethods.purple(i, &block); end
       def konsole_colour_purple(i = ''); AllColourMethods.purple(i); end
       def konsole_purple(i = ''); AllColourMethods.purple(i); end
       self.instance_eval { alias konsole_colour_purple purple } # === Colours::AllColourMethods.konsole_colour_purple
       def Colours.epurple(i = ''); puts AllColourMethods.purple(i); end
       def epurple(i = ''); puts AllColourMethods.purple(i); end
       alias ekonsole_colour_purple epurple

  # ======================================================================== 
  # === Colours::AllColourMethods.purple3
  # ======================================================================== 
  def self.purple3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.purple3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.purple3(i, &block)
      else
        return ::Colours::BasicColours.purple3(i, &block)
      end
    else
      return i
    end
  end; def purple3(i = '', &block); AllColourMethods.purple3(i, &block); end
       def konsole_colour_purple3(i = ''); AllColourMethods.purple3(i); end
       def konsole_purple3(i = ''); AllColourMethods.purple3(i); end
       self.instance_eval { alias konsole_colour_purple3 purple3 } # === Colours::AllColourMethods.konsole_colour_purple3
       def Colours.epurple3(i = ''); puts AllColourMethods.purple3(i); end
       def epurple3(i = ''); puts AllColourMethods.purple3(i); end
       alias ekonsole_colour_purple3 epurple3

  # ======================================================================== 
  # === Colours::AllColourMethods.purple4
  # ======================================================================== 
  def self.purple4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.purple4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.purple4(i, &block)
      else
        return ::Colours::BasicColours.purple4(i, &block)
      end
    else
      return i
    end
  end; def purple4(i = '', &block); AllColourMethods.purple4(i, &block); end
       def konsole_colour_purple4(i = ''); AllColourMethods.purple4(i); end
       def konsole_purple4(i = ''); AllColourMethods.purple4(i); end
       self.instance_eval { alias konsole_colour_purple4 purple4 } # === Colours::AllColourMethods.konsole_colour_purple4
       def Colours.epurple4(i = ''); puts AllColourMethods.purple4(i); end
       def epurple4(i = ''); puts AllColourMethods.purple4(i); end
       alias ekonsole_colour_purple4 epurple4

  # ======================================================================== 
  # === Colours::AllColourMethods.red
  # ======================================================================== 
  def self.red(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.red(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.red(i, &block)
      else
        return ::Colours::BasicColours.red(i, &block)
      end
    else
      return i
    end
  end; def red(i = '', &block); AllColourMethods.red(i, &block); end
       def konsole_colour_red(i = ''); AllColourMethods.red(i); end
       def konsole_red(i = ''); AllColourMethods.red(i); end
       self.instance_eval { alias konsole_colour_red red } # === Colours::AllColourMethods.konsole_colour_red
       def Colours.ered(i = ''); puts AllColourMethods.red(i); end
       def ered(i = ''); puts AllColourMethods.red(i); end
       alias ekonsole_colour_red ered

  # ======================================================================== 
  # === Colours::AllColourMethods.red1
  # ======================================================================== 
  def self.red1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.red1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.red1(i, &block)
      else
        return ::Colours::BasicColours.red1(i, &block)
      end
    else
      return i
    end
  end; def red1(i = '', &block); AllColourMethods.red1(i, &block); end
       def konsole_colour_red1(i = ''); AllColourMethods.red1(i); end
       def konsole_red1(i = ''); AllColourMethods.red1(i); end
       self.instance_eval { alias konsole_colour_red1 red1 } # === Colours::AllColourMethods.konsole_colour_red1
       def Colours.ered1(i = ''); puts AllColourMethods.red1(i); end
       def ered1(i = ''); puts AllColourMethods.red1(i); end
       alias ekonsole_colour_red1 ered1

  # ======================================================================== 
  # === Colours::AllColourMethods.red3
  # ======================================================================== 
  def self.red3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.red3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.red3(i, &block)
      else
        return ::Colours::BasicColours.red3(i, &block)
      end
    else
      return i
    end
  end; def red3(i = '', &block); AllColourMethods.red3(i, &block); end
       def konsole_colour_red3(i = ''); AllColourMethods.red3(i); end
       def konsole_red3(i = ''); AllColourMethods.red3(i); end
       self.instance_eval { alias konsole_colour_red3 red3 } # === Colours::AllColourMethods.konsole_colour_red3
       def Colours.ered3(i = ''); puts AllColourMethods.red3(i); end
       def ered3(i = ''); puts AllColourMethods.red3(i); end
       alias ekonsole_colour_red3 ered3

  # ======================================================================== 
  # === Colours::AllColourMethods.rosybrown
  # ======================================================================== 
  def self.rosybrown(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.rosybrown(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.rosybrown(i, &block)
      else
        return ::Colours::BasicColours.rosybrown(i, &block)
      end
    else
      return i
    end
  end; def rosybrown(i = '', &block); AllColourMethods.rosybrown(i, &block); end
       def konsole_colour_rosybrown(i = ''); AllColourMethods.rosybrown(i); end
       def konsole_rosybrown(i = ''); AllColourMethods.rosybrown(i); end
       self.instance_eval { alias konsole_colour_rosybrown rosybrown } # === Colours::AllColourMethods.konsole_colour_rosybrown
       def Colours.erosybrown(i = ''); puts AllColourMethods.rosybrown(i); end
       def erosybrown(i = ''); puts AllColourMethods.rosybrown(i); end
       alias ekonsole_colour_rosybrown erosybrown

  # ======================================================================== 
  # === Colours::AllColourMethods.royalblue
  # ======================================================================== 
  def self.royalblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.royalblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.royalblue(i, &block)
      else
        return ::Colours::BasicColours.royalblue(i, &block)
      end
    else
      return i
    end
  end; def royalblue(i = '', &block); AllColourMethods.royalblue(i, &block); end
       def konsole_colour_royalblue(i = ''); AllColourMethods.royalblue(i); end
       def konsole_royalblue(i = ''); AllColourMethods.royalblue(i); end
       self.instance_eval { alias konsole_colour_royalblue royalblue } # === Colours::AllColourMethods.konsole_colour_royalblue
       def Colours.eroyalblue(i = ''); puts AllColourMethods.royalblue(i); end
       def eroyalblue(i = ''); puts AllColourMethods.royalblue(i); end
       alias ekonsole_colour_royalblue eroyalblue

  # ======================================================================== 
  # === Colours::AllColourMethods.royalblue1
  # ======================================================================== 
  def self.royalblue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.royalblue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.royalblue1(i, &block)
      else
        return ::Colours::BasicColours.royalblue1(i, &block)
      end
    else
      return i
    end
  end; def royalblue1(i = '', &block); AllColourMethods.royalblue1(i, &block); end
       def konsole_colour_royalblue1(i = ''); AllColourMethods.royalblue1(i); end
       def konsole_royalblue1(i = ''); AllColourMethods.royalblue1(i); end
       self.instance_eval { alias konsole_colour_royalblue1 royalblue1 } # === Colours::AllColourMethods.konsole_colour_royalblue1
       def Colours.eroyalblue1(i = ''); puts AllColourMethods.royalblue1(i); end
       def eroyalblue1(i = ''); puts AllColourMethods.royalblue1(i); end
       alias ekonsole_colour_royalblue1 eroyalblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.saddlebrown
  # ======================================================================== 
  def self.saddlebrown(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.saddlebrown(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.saddlebrown(i, &block)
      else
        return ::Colours::BasicColours.saddlebrown(i, &block)
      end
    else
      return i
    end
  end; def saddlebrown(i = '', &block); AllColourMethods.saddlebrown(i, &block); end
       def konsole_colour_saddlebrown(i = ''); AllColourMethods.saddlebrown(i); end
       def konsole_saddlebrown(i = ''); AllColourMethods.saddlebrown(i); end
       self.instance_eval { alias konsole_colour_saddlebrown saddlebrown } # === Colours::AllColourMethods.konsole_colour_saddlebrown
       def Colours.esaddlebrown(i = ''); puts AllColourMethods.saddlebrown(i); end
       def esaddlebrown(i = ''); puts AllColourMethods.saddlebrown(i); end
       alias ekonsole_colour_saddlebrown esaddlebrown

  # ======================================================================== 
  # === Colours::AllColourMethods.salmon
  # ======================================================================== 
  def self.salmon(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.salmon(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.salmon(i, &block)
      else
        return ::Colours::BasicColours.salmon(i, &block)
      end
    else
      return i
    end
  end; def salmon(i = '', &block); AllColourMethods.salmon(i, &block); end
       def konsole_colour_salmon(i = ''); AllColourMethods.salmon(i); end
       def konsole_salmon(i = ''); AllColourMethods.salmon(i); end
       self.instance_eval { alias konsole_colour_salmon salmon } # === Colours::AllColourMethods.konsole_colour_salmon
       def Colours.esalmon(i = ''); puts AllColourMethods.salmon(i); end
       def esalmon(i = ''); puts AllColourMethods.salmon(i); end
       alias ekonsole_colour_salmon esalmon

  # ======================================================================== 
  # === Colours::AllColourMethods.salmon1
  # ======================================================================== 
  def self.salmon1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.salmon1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.salmon1(i, &block)
      else
        return ::Colours::BasicColours.salmon1(i, &block)
      end
    else
      return i
    end
  end; def salmon1(i = '', &block); AllColourMethods.salmon1(i, &block); end
       def konsole_colour_salmon1(i = ''); AllColourMethods.salmon1(i); end
       def konsole_salmon1(i = ''); AllColourMethods.salmon1(i); end
       self.instance_eval { alias konsole_colour_salmon1 salmon1 } # === Colours::AllColourMethods.konsole_colour_salmon1
       def Colours.esalmon1(i = ''); puts AllColourMethods.salmon1(i); end
       def esalmon1(i = ''); puts AllColourMethods.salmon1(i); end
       alias ekonsole_colour_salmon1 esalmon1

  # ======================================================================== 
  # === Colours::AllColourMethods.sandybrown
  # ======================================================================== 
  def self.sandybrown(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.sandybrown(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.sandybrown(i, &block)
      else
        return ::Colours::BasicColours.sandybrown(i, &block)
      end
    else
      return i
    end
  end; def sandybrown(i = '', &block); AllColourMethods.sandybrown(i, &block); end
       def konsole_colour_sandybrown(i = ''); AllColourMethods.sandybrown(i); end
       def konsole_sandybrown(i = ''); AllColourMethods.sandybrown(i); end
       self.instance_eval { alias konsole_colour_sandybrown sandybrown } # === Colours::AllColourMethods.konsole_colour_sandybrown
       def Colours.esandybrown(i = ''); puts AllColourMethods.sandybrown(i); end
       def esandybrown(i = ''); puts AllColourMethods.sandybrown(i); end
       alias ekonsole_colour_sandybrown esandybrown

  # ======================================================================== 
  # === Colours::AllColourMethods.seagreen
  # ======================================================================== 
  def self.seagreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.seagreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.seagreen(i, &block)
      else
        return ::Colours::BasicColours.seagreen(i, &block)
      end
    else
      return i
    end
  end; def seagreen(i = '', &block); AllColourMethods.seagreen(i, &block); end
       def konsole_colour_seagreen(i = ''); AllColourMethods.seagreen(i); end
       def konsole_seagreen(i = ''); AllColourMethods.seagreen(i); end
       self.instance_eval { alias konsole_colour_seagreen seagreen } # === Colours::AllColourMethods.konsole_colour_seagreen
       def Colours.eseagreen(i = ''); puts AllColourMethods.seagreen(i); end
       def eseagreen(i = ''); puts AllColourMethods.seagreen(i); end
       alias ekonsole_colour_seagreen eseagreen

  # ======================================================================== 
  # === Colours::AllColourMethods.seagreen1
  # ======================================================================== 
  def self.seagreen1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.seagreen1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.seagreen1(i, &block)
      else
        return ::Colours::BasicColours.seagreen1(i, &block)
      end
    else
      return i
    end
  end; def seagreen1(i = '', &block); AllColourMethods.seagreen1(i, &block); end
       def konsole_colour_seagreen1(i = ''); AllColourMethods.seagreen1(i); end
       def konsole_seagreen1(i = ''); AllColourMethods.seagreen1(i); end
       self.instance_eval { alias konsole_colour_seagreen1 seagreen1 } # === Colours::AllColourMethods.konsole_colour_seagreen1
       def Colours.eseagreen1(i = ''); puts AllColourMethods.seagreen1(i); end
       def eseagreen1(i = ''); puts AllColourMethods.seagreen1(i); end
       alias ekonsole_colour_seagreen1 eseagreen1

  # ======================================================================== 
  # === Colours::AllColourMethods.seagreen2
  # ======================================================================== 
  def self.seagreen2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.seagreen2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.seagreen2(i, &block)
      else
        return ::Colours::BasicColours.seagreen2(i, &block)
      end
    else
      return i
    end
  end; def seagreen2(i = '', &block); AllColourMethods.seagreen2(i, &block); end
       def konsole_colour_seagreen2(i = ''); AllColourMethods.seagreen2(i); end
       def konsole_seagreen2(i = ''); AllColourMethods.seagreen2(i); end
       self.instance_eval { alias konsole_colour_seagreen2 seagreen2 } # === Colours::AllColourMethods.konsole_colour_seagreen2
       def Colours.eseagreen2(i = ''); puts AllColourMethods.seagreen2(i); end
       def eseagreen2(i = ''); puts AllColourMethods.seagreen2(i); end
       alias ekonsole_colour_seagreen2 eseagreen2

  # ======================================================================== 
  # === Colours::AllColourMethods.seagreen3
  # ======================================================================== 
  def self.seagreen3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.seagreen3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.seagreen3(i, &block)
      else
        return ::Colours::BasicColours.seagreen3(i, &block)
      end
    else
      return i
    end
  end; def seagreen3(i = '', &block); AllColourMethods.seagreen3(i, &block); end
       def konsole_colour_seagreen3(i = ''); AllColourMethods.seagreen3(i); end
       def konsole_seagreen3(i = ''); AllColourMethods.seagreen3(i); end
       self.instance_eval { alias konsole_colour_seagreen3 seagreen3 } # === Colours::AllColourMethods.konsole_colour_seagreen3
       def Colours.eseagreen3(i = ''); puts AllColourMethods.seagreen3(i); end
       def eseagreen3(i = ''); puts AllColourMethods.seagreen3(i); end
       alias ekonsole_colour_seagreen3 eseagreen3

  # ======================================================================== 
  # === Colours::AllColourMethods.seashell
  # ======================================================================== 
  def self.seashell(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.seashell(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.seashell(i, &block)
      else
        return ::Colours::BasicColours.seashell(i, &block)
      end
    else
      return i
    end
  end; def seashell(i = '', &block); AllColourMethods.seashell(i, &block); end
       def konsole_colour_seashell(i = ''); AllColourMethods.seashell(i); end
       def konsole_seashell(i = ''); AllColourMethods.seashell(i); end
       self.instance_eval { alias konsole_colour_seashell seashell } # === Colours::AllColourMethods.konsole_colour_seashell
       def Colours.eseashell(i = ''); puts AllColourMethods.seashell(i); end
       def eseashell(i = ''); puts AllColourMethods.seashell(i); end
       alias ekonsole_colour_seashell eseashell

  # ======================================================================== 
  # === Colours::AllColourMethods.sienna
  # ======================================================================== 
  def self.sienna(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.sienna(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.sienna(i, &block)
      else
        return ::Colours::BasicColours.sienna(i, &block)
      end
    else
      return i
    end
  end; def sienna(i = '', &block); AllColourMethods.sienna(i, &block); end
       def konsole_colour_sienna(i = ''); AllColourMethods.sienna(i); end
       def konsole_sienna(i = ''); AllColourMethods.sienna(i); end
       self.instance_eval { alias konsole_colour_sienna sienna } # === Colours::AllColourMethods.konsole_colour_sienna
       def Colours.esienna(i = ''); puts AllColourMethods.sienna(i); end
       def esienna(i = ''); puts AllColourMethods.sienna(i); end
       alias ekonsole_colour_sienna esienna

  # ======================================================================== 
  # === Colours::AllColourMethods.silver
  # ======================================================================== 
  def self.silver(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.silver(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.silver(i, &block)
      else
        return ::Colours::BasicColours.silver(i, &block)
      end
    else
      return i
    end
  end; def silver(i = '', &block); AllColourMethods.silver(i, &block); end
       def konsole_colour_silver(i = ''); AllColourMethods.silver(i); end
       def konsole_silver(i = ''); AllColourMethods.silver(i); end
       self.instance_eval { alias konsole_colour_silver silver } # === Colours::AllColourMethods.konsole_colour_silver
       def Colours.esilver(i = ''); puts AllColourMethods.silver(i); end
       def esilver(i = ''); puts AllColourMethods.silver(i); end
       alias ekonsole_colour_silver esilver

  # ======================================================================== 
  # === Colours::AllColourMethods.skyblue
  # ======================================================================== 
  def self.skyblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.skyblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.skyblue(i, &block)
      else
        return ::Colours::BasicColours.skyblue(i, &block)
      end
    else
      return i
    end
  end; def skyblue(i = '', &block); AllColourMethods.skyblue(i, &block); end
       def konsole_colour_skyblue(i = ''); AllColourMethods.skyblue(i); end
       def konsole_skyblue(i = ''); AllColourMethods.skyblue(i); end
       self.instance_eval { alias konsole_colour_skyblue skyblue } # === Colours::AllColourMethods.konsole_colour_skyblue
       def Colours.eskyblue(i = ''); puts AllColourMethods.skyblue(i); end
       def eskyblue(i = ''); puts AllColourMethods.skyblue(i); end
       alias ekonsole_colour_skyblue eskyblue

  # ======================================================================== 
  # === Colours::AllColourMethods.skyblue1
  # ======================================================================== 
  def self.skyblue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.skyblue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.skyblue1(i, &block)
      else
        return ::Colours::BasicColours.skyblue1(i, &block)
      end
    else
      return i
    end
  end; def skyblue1(i = '', &block); AllColourMethods.skyblue1(i, &block); end
       def konsole_colour_skyblue1(i = ''); AllColourMethods.skyblue1(i); end
       def konsole_skyblue1(i = ''); AllColourMethods.skyblue1(i); end
       self.instance_eval { alias konsole_colour_skyblue1 skyblue1 } # === Colours::AllColourMethods.konsole_colour_skyblue1
       def Colours.eskyblue1(i = ''); puts AllColourMethods.skyblue1(i); end
       def eskyblue1(i = ''); puts AllColourMethods.skyblue1(i); end
       alias ekonsole_colour_skyblue1 eskyblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.skyblue2
  # ======================================================================== 
  def self.skyblue2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.skyblue2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.skyblue2(i, &block)
      else
        return ::Colours::BasicColours.skyblue2(i, &block)
      end
    else
      return i
    end
  end; def skyblue2(i = '', &block); AllColourMethods.skyblue2(i, &block); end
       def konsole_colour_skyblue2(i = ''); AllColourMethods.skyblue2(i); end
       def konsole_skyblue2(i = ''); AllColourMethods.skyblue2(i); end
       self.instance_eval { alias konsole_colour_skyblue2 skyblue2 } # === Colours::AllColourMethods.konsole_colour_skyblue2
       def Colours.eskyblue2(i = ''); puts AllColourMethods.skyblue2(i); end
       def eskyblue2(i = ''); puts AllColourMethods.skyblue2(i); end
       alias ekonsole_colour_skyblue2 eskyblue2

  # ======================================================================== 
  # === Colours::AllColourMethods.skyblue3
  # ======================================================================== 
  def self.skyblue3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.skyblue3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.skyblue3(i, &block)
      else
        return ::Colours::BasicColours.skyblue3(i, &block)
      end
    else
      return i
    end
  end; def skyblue3(i = '', &block); AllColourMethods.skyblue3(i, &block); end
       def konsole_colour_skyblue3(i = ''); AllColourMethods.skyblue3(i); end
       def konsole_skyblue3(i = ''); AllColourMethods.skyblue3(i); end
       self.instance_eval { alias konsole_colour_skyblue3 skyblue3 } # === Colours::AllColourMethods.konsole_colour_skyblue3
       def Colours.eskyblue3(i = ''); puts AllColourMethods.skyblue3(i); end
       def eskyblue3(i = ''); puts AllColourMethods.skyblue3(i); end
       alias ekonsole_colour_skyblue3 eskyblue3

  # ======================================================================== 
  # === Colours::AllColourMethods.slateblue
  # ======================================================================== 
  def self.slateblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.slateblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.slateblue(i, &block)
      else
        return ::Colours::BasicColours.slateblue(i, &block)
      end
    else
      return i
    end
  end; def slateblue(i = '', &block); AllColourMethods.slateblue(i, &block); end
       def konsole_colour_slateblue(i = ''); AllColourMethods.slateblue(i); end
       def konsole_slateblue(i = ''); AllColourMethods.slateblue(i); end
       self.instance_eval { alias konsole_colour_slateblue slateblue } # === Colours::AllColourMethods.konsole_colour_slateblue
       def Colours.eslateblue(i = ''); puts AllColourMethods.slateblue(i); end
       def eslateblue(i = ''); puts AllColourMethods.slateblue(i); end
       alias ekonsole_colour_slateblue eslateblue

  # ======================================================================== 
  # === Colours::AllColourMethods.slateblue1
  # ======================================================================== 
  def self.slateblue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.slateblue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.slateblue1(i, &block)
      else
        return ::Colours::BasicColours.slateblue1(i, &block)
      end
    else
      return i
    end
  end; def slateblue1(i = '', &block); AllColourMethods.slateblue1(i, &block); end
       def konsole_colour_slateblue1(i = ''); AllColourMethods.slateblue1(i); end
       def konsole_slateblue1(i = ''); AllColourMethods.slateblue1(i); end
       self.instance_eval { alias konsole_colour_slateblue1 slateblue1 } # === Colours::AllColourMethods.konsole_colour_slateblue1
       def Colours.eslateblue1(i = ''); puts AllColourMethods.slateblue1(i); end
       def eslateblue1(i = ''); puts AllColourMethods.slateblue1(i); end
       alias ekonsole_colour_slateblue1 eslateblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.slateblue3
  # ======================================================================== 
  def self.slateblue3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.slateblue3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.slateblue3(i, &block)
      else
        return ::Colours::BasicColours.slateblue3(i, &block)
      end
    else
      return i
    end
  end; def slateblue3(i = '', &block); AllColourMethods.slateblue3(i, &block); end
       def konsole_colour_slateblue3(i = ''); AllColourMethods.slateblue3(i); end
       def konsole_slateblue3(i = ''); AllColourMethods.slateblue3(i); end
       self.instance_eval { alias konsole_colour_slateblue3 slateblue3 } # === Colours::AllColourMethods.konsole_colour_slateblue3
       def Colours.eslateblue3(i = ''); puts AllColourMethods.slateblue3(i); end
       def eslateblue3(i = ''); puts AllColourMethods.slateblue3(i); end
       alias ekonsole_colour_slateblue3 eslateblue3

  # ======================================================================== 
  # === Colours::AllColourMethods.slategray
  # ======================================================================== 
  def self.slategray(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.slategray(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.slategray(i, &block)
      else
        return ::Colours::BasicColours.slategray(i, &block)
      end
    else
      return i
    end
  end; def slategray(i = '', &block); AllColourMethods.slategray(i, &block); end
       def konsole_colour_slategray(i = ''); AllColourMethods.slategray(i); end
       def konsole_slategray(i = ''); AllColourMethods.slategray(i); end
       self.instance_eval { alias konsole_colour_slategray slategray } # === Colours::AllColourMethods.konsole_colour_slategray
       def Colours.eslategray(i = ''); puts AllColourMethods.slategray(i); end
       def eslategray(i = ''); puts AllColourMethods.slategray(i); end
       alias ekonsole_colour_slategray eslategray

  # ======================================================================== 
  # === Colours::AllColourMethods.slategrey
  # ======================================================================== 
  def self.slategrey(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.slategrey(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.slategrey(i, &block)
      else
        return ::Colours::BasicColours.slategrey(i, &block)
      end
    else
      return i
    end
  end; def slategrey(i = '', &block); AllColourMethods.slategrey(i, &block); end
       def konsole_colour_slategrey(i = ''); AllColourMethods.slategrey(i); end
       def konsole_slategrey(i = ''); AllColourMethods.slategrey(i); end
       self.instance_eval { alias konsole_colour_slategrey slategrey } # === Colours::AllColourMethods.konsole_colour_slategrey
       def Colours.eslategrey(i = ''); puts AllColourMethods.slategrey(i); end
       def eslategrey(i = ''); puts AllColourMethods.slategrey(i); end
       alias ekonsole_colour_slategrey eslategrey

  # ======================================================================== 
  # === Colours::AllColourMethods.snow
  # ======================================================================== 
  def self.snow(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.snow(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.snow(i, &block)
      else
        return ::Colours::BasicColours.snow(i, &block)
      end
    else
      return i
    end
  end; def snow(i = '', &block); AllColourMethods.snow(i, &block); end
       def konsole_colour_snow(i = ''); AllColourMethods.snow(i); end
       def konsole_snow(i = ''); AllColourMethods.snow(i); end
       self.instance_eval { alias konsole_colour_snow snow } # === Colours::AllColourMethods.konsole_colour_snow
       def Colours.esnow(i = ''); puts AllColourMethods.snow(i); end
       def esnow(i = ''); puts AllColourMethods.snow(i); end
       alias ekonsole_colour_snow esnow

  # ======================================================================== 
  # === Colours::AllColourMethods.springgreen
  # ======================================================================== 
  def self.springgreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.springgreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.springgreen(i, &block)
      else
        return ::Colours::BasicColours.springgreen(i, &block)
      end
    else
      return i
    end
  end; def springgreen(i = '', &block); AllColourMethods.springgreen(i, &block); end
       def konsole_colour_springgreen(i = ''); AllColourMethods.springgreen(i); end
       def konsole_springgreen(i = ''); AllColourMethods.springgreen(i); end
       self.instance_eval { alias konsole_colour_springgreen springgreen } # === Colours::AllColourMethods.konsole_colour_springgreen
       def Colours.espringgreen(i = ''); puts AllColourMethods.springgreen(i); end
       def espringgreen(i = ''); puts AllColourMethods.springgreen(i); end
       alias ekonsole_colour_springgreen espringgreen

  # ======================================================================== 
  # === Colours::AllColourMethods.springgreen1
  # ======================================================================== 
  def self.springgreen1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.springgreen1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.springgreen1(i, &block)
      else
        return ::Colours::BasicColours.springgreen1(i, &block)
      end
    else
      return i
    end
  end; def springgreen1(i = '', &block); AllColourMethods.springgreen1(i, &block); end
       def konsole_colour_springgreen1(i = ''); AllColourMethods.springgreen1(i); end
       def konsole_springgreen1(i = ''); AllColourMethods.springgreen1(i); end
       self.instance_eval { alias konsole_colour_springgreen1 springgreen1 } # === Colours::AllColourMethods.konsole_colour_springgreen1
       def Colours.espringgreen1(i = ''); puts AllColourMethods.springgreen1(i); end
       def espringgreen1(i = ''); puts AllColourMethods.springgreen1(i); end
       alias ekonsole_colour_springgreen1 espringgreen1

  # ======================================================================== 
  # === Colours::AllColourMethods.springgreen2
  # ======================================================================== 
  def self.springgreen2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.springgreen2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.springgreen2(i, &block)
      else
        return ::Colours::BasicColours.springgreen2(i, &block)
      end
    else
      return i
    end
  end; def springgreen2(i = '', &block); AllColourMethods.springgreen2(i, &block); end
       def konsole_colour_springgreen2(i = ''); AllColourMethods.springgreen2(i); end
       def konsole_springgreen2(i = ''); AllColourMethods.springgreen2(i); end
       self.instance_eval { alias konsole_colour_springgreen2 springgreen2 } # === Colours::AllColourMethods.konsole_colour_springgreen2
       def Colours.espringgreen2(i = ''); puts AllColourMethods.springgreen2(i); end
       def espringgreen2(i = ''); puts AllColourMethods.springgreen2(i); end
       alias ekonsole_colour_springgreen2 espringgreen2

  # ======================================================================== 
  # === Colours::AllColourMethods.springgreen3
  # ======================================================================== 
  def self.springgreen3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.springgreen3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.springgreen3(i, &block)
      else
        return ::Colours::BasicColours.springgreen3(i, &block)
      end
    else
      return i
    end
  end; def springgreen3(i = '', &block); AllColourMethods.springgreen3(i, &block); end
       def konsole_colour_springgreen3(i = ''); AllColourMethods.springgreen3(i); end
       def konsole_springgreen3(i = ''); AllColourMethods.springgreen3(i); end
       self.instance_eval { alias konsole_colour_springgreen3 springgreen3 } # === Colours::AllColourMethods.konsole_colour_springgreen3
       def Colours.espringgreen3(i = ''); puts AllColourMethods.springgreen3(i); end
       def espringgreen3(i = ''); puts AllColourMethods.springgreen3(i); end
       alias ekonsole_colour_springgreen3 espringgreen3

  # ======================================================================== 
  # === Colours::AllColourMethods.springgreen4
  # ======================================================================== 
  def self.springgreen4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.springgreen4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.springgreen4(i, &block)
      else
        return ::Colours::BasicColours.springgreen4(i, &block)
      end
    else
      return i
    end
  end; def springgreen4(i = '', &block); AllColourMethods.springgreen4(i, &block); end
       def konsole_colour_springgreen4(i = ''); AllColourMethods.springgreen4(i); end
       def konsole_springgreen4(i = ''); AllColourMethods.springgreen4(i); end
       self.instance_eval { alias konsole_colour_springgreen4 springgreen4 } # === Colours::AllColourMethods.konsole_colour_springgreen4
       def Colours.espringgreen4(i = ''); puts AllColourMethods.springgreen4(i); end
       def espringgreen4(i = ''); puts AllColourMethods.springgreen4(i); end
       alias ekonsole_colour_springgreen4 espringgreen4

  # ======================================================================== 
  # === Colours::AllColourMethods.steelblue
  # ======================================================================== 
  def self.steelblue(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.steelblue(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.steelblue(i, &block)
      else
        return ::Colours::BasicColours.steelblue(i, &block)
      end
    else
      return i
    end
  end; def steelblue(i = '', &block); AllColourMethods.steelblue(i, &block); end
       def konsole_colour_steelblue(i = ''); AllColourMethods.steelblue(i); end
       def konsole_steelblue(i = ''); AllColourMethods.steelblue(i); end
       self.instance_eval { alias konsole_colour_steelblue steelblue } # === Colours::AllColourMethods.konsole_colour_steelblue
       def Colours.esteelblue(i = ''); puts AllColourMethods.steelblue(i); end
       def esteelblue(i = ''); puts AllColourMethods.steelblue(i); end
       alias ekonsole_colour_steelblue esteelblue

  # ======================================================================== 
  # === Colours::AllColourMethods.steelblue1
  # ======================================================================== 
  def self.steelblue1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.steelblue1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.steelblue1(i, &block)
      else
        return ::Colours::BasicColours.steelblue1(i, &block)
      end
    else
      return i
    end
  end; def steelblue1(i = '', &block); AllColourMethods.steelblue1(i, &block); end
       def konsole_colour_steelblue1(i = ''); AllColourMethods.steelblue1(i); end
       def konsole_steelblue1(i = ''); AllColourMethods.steelblue1(i); end
       self.instance_eval { alias konsole_colour_steelblue1 steelblue1 } # === Colours::AllColourMethods.konsole_colour_steelblue1
       def Colours.esteelblue1(i = ''); puts AllColourMethods.steelblue1(i); end
       def esteelblue1(i = ''); puts AllColourMethods.steelblue1(i); end
       alias ekonsole_colour_steelblue1 esteelblue1

  # ======================================================================== 
  # === Colours::AllColourMethods.steelblue3
  # ======================================================================== 
  def self.steelblue3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.steelblue3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.steelblue3(i, &block)
      else
        return ::Colours::BasicColours.steelblue3(i, &block)
      end
    else
      return i
    end
  end; def steelblue3(i = '', &block); AllColourMethods.steelblue3(i, &block); end
       def konsole_colour_steelblue3(i = ''); AllColourMethods.steelblue3(i); end
       def konsole_steelblue3(i = ''); AllColourMethods.steelblue3(i); end
       self.instance_eval { alias konsole_colour_steelblue3 steelblue3 } # === Colours::AllColourMethods.konsole_colour_steelblue3
       def Colours.esteelblue3(i = ''); puts AllColourMethods.steelblue3(i); end
       def esteelblue3(i = ''); puts AllColourMethods.steelblue3(i); end
       alias ekonsole_colour_steelblue3 esteelblue3

  # ======================================================================== 
  # === Colours::AllColourMethods.tan
  # ======================================================================== 
  def self.tan(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.tan(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.tan(i, &block)
      else
        return ::Colours::BasicColours.tan(i, &block)
      end
    else
      return i
    end
  end; def tan(i = '', &block); AllColourMethods.tan(i, &block); end
       def konsole_colour_tan(i = ''); AllColourMethods.tan(i); end
       def konsole_tan(i = ''); AllColourMethods.tan(i); end
       self.instance_eval { alias konsole_colour_tan tan } # === Colours::AllColourMethods.konsole_colour_tan
       def Colours.etan(i = ''); puts AllColourMethods.tan(i); end
       def etan(i = ''); puts AllColourMethods.tan(i); end
       alias ekonsole_colour_tan etan

  # ======================================================================== 
  # === Colours::AllColourMethods.teal
  # ======================================================================== 
  def self.teal(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.teal(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.teal(i, &block)
      else
        return ::Colours::BasicColours.teal(i, &block)
      end
    else
      return i
    end
  end; def teal(i = '', &block); AllColourMethods.teal(i, &block); end
       def konsole_colour_teal(i = ''); AllColourMethods.teal(i); end
       def konsole_teal(i = ''); AllColourMethods.teal(i); end
       self.instance_eval { alias konsole_colour_teal teal } # === Colours::AllColourMethods.konsole_colour_teal
       def Colours.eteal(i = ''); puts AllColourMethods.teal(i); end
       def eteal(i = ''); puts AllColourMethods.teal(i); end
       alias ekonsole_colour_teal eteal

  # ======================================================================== 
  # === Colours::AllColourMethods.thistle
  # ======================================================================== 
  def self.thistle(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.thistle(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.thistle(i, &block)
      else
        return ::Colours::BasicColours.thistle(i, &block)
      end
    else
      return i
    end
  end; def thistle(i = '', &block); AllColourMethods.thistle(i, &block); end
       def konsole_colour_thistle(i = ''); AllColourMethods.thistle(i); end
       def konsole_thistle(i = ''); AllColourMethods.thistle(i); end
       self.instance_eval { alias konsole_colour_thistle thistle } # === Colours::AllColourMethods.konsole_colour_thistle
       def Colours.ethistle(i = ''); puts AllColourMethods.thistle(i); end
       def ethistle(i = ''); puts AllColourMethods.thistle(i); end
       alias ekonsole_colour_thistle ethistle

  # ======================================================================== 
  # === Colours::AllColourMethods.thistle1
  # ======================================================================== 
  def self.thistle1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.thistle1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.thistle1(i, &block)
      else
        return ::Colours::BasicColours.thistle1(i, &block)
      end
    else
      return i
    end
  end; def thistle1(i = '', &block); AllColourMethods.thistle1(i, &block); end
       def konsole_colour_thistle1(i = ''); AllColourMethods.thistle1(i); end
       def konsole_thistle1(i = ''); AllColourMethods.thistle1(i); end
       self.instance_eval { alias konsole_colour_thistle1 thistle1 } # === Colours::AllColourMethods.konsole_colour_thistle1
       def Colours.ethistle1(i = ''); puts AllColourMethods.thistle1(i); end
       def ethistle1(i = ''); puts AllColourMethods.thistle1(i); end
       alias ekonsole_colour_thistle1 ethistle1

  # ======================================================================== 
  # === Colours::AllColourMethods.thistle3
  # ======================================================================== 
  def self.thistle3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.thistle3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.thistle3(i, &block)
      else
        return ::Colours::BasicColours.thistle3(i, &block)
      end
    else
      return i
    end
  end; def thistle3(i = '', &block); AllColourMethods.thistle3(i, &block); end
       def konsole_colour_thistle3(i = ''); AllColourMethods.thistle3(i); end
       def konsole_thistle3(i = ''); AllColourMethods.thistle3(i); end
       self.instance_eval { alias konsole_colour_thistle3 thistle3 } # === Colours::AllColourMethods.konsole_colour_thistle3
       def Colours.ethistle3(i = ''); puts AllColourMethods.thistle3(i); end
       def ethistle3(i = ''); puts AllColourMethods.thistle3(i); end
       alias ekonsole_colour_thistle3 ethistle3

  # ======================================================================== 
  # === Colours::AllColourMethods.tomato
  # ======================================================================== 
  def self.tomato(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.tomato(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.tomato(i, &block)
      else
        return ::Colours::BasicColours.tomato(i, &block)
      end
    else
      return i
    end
  end; def tomato(i = '', &block); AllColourMethods.tomato(i, &block); end
       def konsole_colour_tomato(i = ''); AllColourMethods.tomato(i); end
       def konsole_tomato(i = ''); AllColourMethods.tomato(i); end
       self.instance_eval { alias konsole_colour_tomato tomato } # === Colours::AllColourMethods.konsole_colour_tomato
       def Colours.etomato(i = ''); puts AllColourMethods.tomato(i); end
       def etomato(i = ''); puts AllColourMethods.tomato(i); end
       alias ekonsole_colour_tomato etomato

  # ======================================================================== 
  # === Colours::AllColourMethods.turquoise
  # ======================================================================== 
  def self.turquoise(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.turquoise(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.turquoise(i, &block)
      else
        return ::Colours::BasicColours.turquoise(i, &block)
      end
    else
      return i
    end
  end; def turquoise(i = '', &block); AllColourMethods.turquoise(i, &block); end
       def konsole_colour_turquoise(i = ''); AllColourMethods.turquoise(i); end
       def konsole_turquoise(i = ''); AllColourMethods.turquoise(i); end
       self.instance_eval { alias konsole_colour_turquoise turquoise } # === Colours::AllColourMethods.konsole_colour_turquoise
       def Colours.eturquoise(i = ''); puts AllColourMethods.turquoise(i); end
       def eturquoise(i = ''); puts AllColourMethods.turquoise(i); end
       alias ekonsole_colour_turquoise eturquoise

  # ======================================================================== 
  # === Colours::AllColourMethods.turquoise2
  # ======================================================================== 
  def self.turquoise2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.turquoise2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.turquoise2(i, &block)
      else
        return ::Colours::BasicColours.turquoise2(i, &block)
      end
    else
      return i
    end
  end; def turquoise2(i = '', &block); AllColourMethods.turquoise2(i, &block); end
       def konsole_colour_turquoise2(i = ''); AllColourMethods.turquoise2(i); end
       def konsole_turquoise2(i = ''); AllColourMethods.turquoise2(i); end
       self.instance_eval { alias konsole_colour_turquoise2 turquoise2 } # === Colours::AllColourMethods.konsole_colour_turquoise2
       def Colours.eturquoise2(i = ''); puts AllColourMethods.turquoise2(i); end
       def eturquoise2(i = ''); puts AllColourMethods.turquoise2(i); end
       alias ekonsole_colour_turquoise2 eturquoise2

  # ======================================================================== 
  # === Colours::AllColourMethods.turquoise4
  # ======================================================================== 
  def self.turquoise4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.turquoise4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.turquoise4(i, &block)
      else
        return ::Colours::BasicColours.turquoise4(i, &block)
      end
    else
      return i
    end
  end; def turquoise4(i = '', &block); AllColourMethods.turquoise4(i, &block); end
       def konsole_colour_turquoise4(i = ''); AllColourMethods.turquoise4(i); end
       def konsole_turquoise4(i = ''); AllColourMethods.turquoise4(i); end
       self.instance_eval { alias konsole_colour_turquoise4 turquoise4 } # === Colours::AllColourMethods.konsole_colour_turquoise4
       def Colours.eturquoise4(i = ''); puts AllColourMethods.turquoise4(i); end
       def eturquoise4(i = ''); puts AllColourMethods.turquoise4(i); end
       alias ekonsole_colour_turquoise4 eturquoise4

  # ======================================================================== 
  # === Colours::AllColourMethods.violet
  # ======================================================================== 
  def self.violet(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.violet(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.violet(i, &block)
      else
        return ::Colours::BasicColours.violet(i, &block)
      end
    else
      return i
    end
  end; def violet(i = '', &block); AllColourMethods.violet(i, &block); end
       def konsole_colour_violet(i = ''); AllColourMethods.violet(i); end
       def konsole_violet(i = ''); AllColourMethods.violet(i); end
       self.instance_eval { alias konsole_colour_violet violet } # === Colours::AllColourMethods.konsole_colour_violet
       def Colours.eviolet(i = ''); puts AllColourMethods.violet(i); end
       def eviolet(i = ''); puts AllColourMethods.violet(i); end
       alias ekonsole_colour_violet eviolet

  # ======================================================================== 
  # === Colours::AllColourMethods.wheat
  # ======================================================================== 
  def self.wheat(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.wheat(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.wheat(i, &block)
      else
        return ::Colours::BasicColours.wheat(i, &block)
      end
    else
      return i
    end
  end; def wheat(i = '', &block); AllColourMethods.wheat(i, &block); end
       def konsole_colour_wheat(i = ''); AllColourMethods.wheat(i); end
       def konsole_wheat(i = ''); AllColourMethods.wheat(i); end
       self.instance_eval { alias konsole_colour_wheat wheat } # === Colours::AllColourMethods.konsole_colour_wheat
       def Colours.ewheat(i = ''); puts AllColourMethods.wheat(i); end
       def ewheat(i = ''); puts AllColourMethods.wheat(i); end
       alias ekonsole_colour_wheat ewheat

  # ======================================================================== 
  # === Colours::AllColourMethods.wheat1
  # ======================================================================== 
  def self.wheat1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.wheat1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.wheat1(i, &block)
      else
        return ::Colours::BasicColours.wheat1(i, &block)
      end
    else
      return i
    end
  end; def wheat1(i = '', &block); AllColourMethods.wheat1(i, &block); end
       def konsole_colour_wheat1(i = ''); AllColourMethods.wheat1(i); end
       def konsole_wheat1(i = ''); AllColourMethods.wheat1(i); end
       self.instance_eval { alias konsole_colour_wheat1 wheat1 } # === Colours::AllColourMethods.konsole_colour_wheat1
       def Colours.ewheat1(i = ''); puts AllColourMethods.wheat1(i); end
       def ewheat1(i = ''); puts AllColourMethods.wheat1(i); end
       alias ekonsole_colour_wheat1 ewheat1

  # ======================================================================== 
  # === Colours::AllColourMethods.wheat4
  # ======================================================================== 
  def self.wheat4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.wheat4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.wheat4(i, &block)
      else
        return ::Colours::BasicColours.wheat4(i, &block)
      end
    else
      return i
    end
  end; def wheat4(i = '', &block); AllColourMethods.wheat4(i, &block); end
       def konsole_colour_wheat4(i = ''); AllColourMethods.wheat4(i); end
       def konsole_wheat4(i = ''); AllColourMethods.wheat4(i); end
       self.instance_eval { alias konsole_colour_wheat4 wheat4 } # === Colours::AllColourMethods.konsole_colour_wheat4
       def Colours.ewheat4(i = ''); puts AllColourMethods.wheat4(i); end
       def ewheat4(i = ''); puts AllColourMethods.wheat4(i); end
       alias ekonsole_colour_wheat4 ewheat4

  # ======================================================================== 
  # === Colours::AllColourMethods.white
  # ======================================================================== 
  def self.white(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.white(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.white(i, &block)
      else
        return ::Colours::BasicColours.white(i, &block)
      end
    else
      return i
    end
  end; def white(i = '', &block); AllColourMethods.white(i, &block); end
       def konsole_colour_white(i = ''); AllColourMethods.white(i); end
       def konsole_white(i = ''); AllColourMethods.white(i); end
       self.instance_eval { alias konsole_colour_white white } # === Colours::AllColourMethods.konsole_colour_white
       def Colours.ewhite(i = ''); puts AllColourMethods.white(i); end
       def ewhite(i = ''); puts AllColourMethods.white(i); end
       alias ekonsole_colour_white ewhite

  # ======================================================================== 
  # === Colours::AllColourMethods.whitesmoke
  # ======================================================================== 
  def self.whitesmoke(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.whitesmoke(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.whitesmoke(i, &block)
      else
        return ::Colours::BasicColours.whitesmoke(i, &block)
      end
    else
      return i
    end
  end; def whitesmoke(i = '', &block); AllColourMethods.whitesmoke(i, &block); end
       def konsole_colour_whitesmoke(i = ''); AllColourMethods.whitesmoke(i); end
       def konsole_whitesmoke(i = ''); AllColourMethods.whitesmoke(i); end
       self.instance_eval { alias konsole_colour_whitesmoke whitesmoke } # === Colours::AllColourMethods.konsole_colour_whitesmoke
       def Colours.ewhitesmoke(i = ''); puts AllColourMethods.whitesmoke(i); end
       def ewhitesmoke(i = ''); puts AllColourMethods.whitesmoke(i); end
       alias ekonsole_colour_whitesmoke ewhitesmoke

  # ======================================================================== 
  # === Colours::AllColourMethods.yellow
  # ======================================================================== 
  def self.yellow(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.yellow(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.yellow(i, &block)
      else
        return ::Colours::BasicColours.yellow(i, &block)
      end
    else
      return i
    end
  end; def yellow(i = '', &block); AllColourMethods.yellow(i, &block); end
       def konsole_colour_yellow(i = ''); AllColourMethods.yellow(i); end
       def konsole_yellow(i = ''); AllColourMethods.yellow(i); end
       self.instance_eval { alias konsole_colour_yellow yellow } # === Colours::AllColourMethods.konsole_colour_yellow
       def Colours.eyellow(i = ''); puts AllColourMethods.yellow(i); end
       def eyellow(i = ''); puts AllColourMethods.yellow(i); end
       alias ekonsole_colour_yellow eyellow

  # ======================================================================== 
  # === Colours::AllColourMethods.yellow1
  # ======================================================================== 
  def self.yellow1(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.yellow1(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.yellow1(i, &block)
      else
        return ::Colours::BasicColours.yellow1(i, &block)
      end
    else
      return i
    end
  end; def yellow1(i = '', &block); AllColourMethods.yellow1(i, &block); end
       def konsole_colour_yellow1(i = ''); AllColourMethods.yellow1(i); end
       def konsole_yellow1(i = ''); AllColourMethods.yellow1(i); end
       self.instance_eval { alias konsole_colour_yellow1 yellow1 } # === Colours::AllColourMethods.konsole_colour_yellow1
       def Colours.eyellow1(i = ''); puts AllColourMethods.yellow1(i); end
       def eyellow1(i = ''); puts AllColourMethods.yellow1(i); end
       alias ekonsole_colour_yellow1 eyellow1

  # ======================================================================== 
  # === Colours::AllColourMethods.yellow2
  # ======================================================================== 
  def self.yellow2(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.yellow2(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.yellow2(i, &block)
      else
        return ::Colours::BasicColours.yellow2(i, &block)
      end
    else
      return i
    end
  end; def yellow2(i = '', &block); AllColourMethods.yellow2(i, &block); end
       def konsole_colour_yellow2(i = ''); AllColourMethods.yellow2(i); end
       def konsole_yellow2(i = ''); AllColourMethods.yellow2(i); end
       self.instance_eval { alias konsole_colour_yellow2 yellow2 } # === Colours::AllColourMethods.konsole_colour_yellow2
       def Colours.eyellow2(i = ''); puts AllColourMethods.yellow2(i); end
       def eyellow2(i = ''); puts AllColourMethods.yellow2(i); end
       alias ekonsole_colour_yellow2 eyellow2

  # ======================================================================== 
  # === Colours::AllColourMethods.yellow3
  # ======================================================================== 
  def self.yellow3(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.yellow3(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.yellow3(i, &block)
      else
        return ::Colours::BasicColours.yellow3(i, &block)
      end
    else
      return i
    end
  end; def yellow3(i = '', &block); AllColourMethods.yellow3(i, &block); end
       def konsole_colour_yellow3(i = ''); AllColourMethods.yellow3(i); end
       def konsole_yellow3(i = ''); AllColourMethods.yellow3(i); end
       self.instance_eval { alias konsole_colour_yellow3 yellow3 } # === Colours::AllColourMethods.konsole_colour_yellow3
       def Colours.eyellow3(i = ''); puts AllColourMethods.yellow3(i); end
       def eyellow3(i = ''); puts AllColourMethods.yellow3(i); end
       alias ekonsole_colour_yellow3 eyellow3

  # ======================================================================== 
  # === Colours::AllColourMethods.yellow4
  # ======================================================================== 
  def self.yellow4(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.yellow4(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.yellow4(i, &block)
      else
        return ::Colours::BasicColours.yellow4(i, &block)
      end
    else
      return i
    end
  end; def yellow4(i = '', &block); AllColourMethods.yellow4(i, &block); end
       def konsole_colour_yellow4(i = ''); AllColourMethods.yellow4(i); end
       def konsole_yellow4(i = ''); AllColourMethods.yellow4(i); end
       self.instance_eval { alias konsole_colour_yellow4 yellow4 } # === Colours::AllColourMethods.konsole_colour_yellow4
       def Colours.eyellow4(i = ''); puts AllColourMethods.yellow4(i); end
       def eyellow4(i = ''); puts AllColourMethods.yellow4(i); end
       alias ekonsole_colour_yellow4 eyellow4

  # ======================================================================== 
  # === Colours::AllColourMethods.yellowgreen
  # ======================================================================== 
  def self.yellowgreen(i = '', &block)
    if ::Colours.use_colours?
      if ::Colours.is_this_a_html_colour?(__method__)
        return ::Colours::SupportForHTMLColours.yellowgreen(i, &block)
      elsif ::Colours.is_this_a_256_colour?(__method__)
        return ::Colours::SupportFor256Colours.yellowgreen(i, &block)
      else
        return ::Colours::BasicColours.yellowgreen(i, &block)
      end
    else
      return i
    end
  end; def yellowgreen(i = '', &block); AllColourMethods.yellowgreen(i, &block); end
       def konsole_colour_yellowgreen(i = ''); AllColourMethods.yellowgreen(i); end
       def konsole_yellowgreen(i = ''); AllColourMethods.yellowgreen(i); end
       self.instance_eval { alias konsole_colour_yellowgreen yellowgreen } # === Colours::AllColourMethods.konsole_colour_yellowgreen
       def Colours.eyellowgreen(i = ''); puts AllColourMethods.yellowgreen(i); end
       def eyellowgreen(i = ''); puts AllColourMethods.yellowgreen(i); end
       alias ekonsole_colour_yellowgreen eyellowgreen

end; end
